; OKCTRL.ASM is the screen scanning control program
; this allows you to move up and down and left and right around
; the virtual page
; the main public call here is DO_DISPLAY
;
;
segmentsize equ 8000h
DSEG	SEGMENT PARA PUBLIC 'DATA'
	ASSUME CS:CSEG,DS:DSEG,ES:DSEG
extrn   curr_seg:word,tree7000:word,vid_wid:word
extrn   siloc:word,vwid:word,vid_len:word,last_seg:word,last_si:word
extrn   helps:word,fat_on:byte,curx:word,cury:word,left_margin:word
extrn   last_fseg:word,last_fsi:word,goback1:word,quitter:word
extrn   goback2:word,tree2200:word
extrn	rselect:near,mselect:near,sselect:near,do_image:near
extrn   prbox:near
;
;
smess  db 13,10,'Press the "/" key to return to menu',13,10,0
nswitch db 0
public nswitch
;
DSEG	ENDS

CSEG2	SEGMENT PARA PUBLIC 'text'
	ASSUME CS:CSEG2
extrn   help:far
cseg2   ends

CSEG	SEGMENT PARA PUBLIC 'CODE'
	ASSUME CS:CSEG,DS:DSEG,ES:DSEG

extrn   blip:near,blop:near,do_tree:near,getkey:near
extrn   got_slash:near,present:near,reset_segs:near
extrn   set_color:near,set_palette:near,do_hires:near,do_med:near
extrn   do_type:near,do_line:near,print_string:near
extrn   do_fat:near,goback:near,gobackf:near,quit:near
public  up_key,left_key,right_key,down_key,home_key,end_key

;
; the key_procs are the up, down left right type of things
;
do_display  proc near
; this is the loop where the display is shown to us
public do_display
   call   reset_segs
   call   present
; the printing of a message goes here
   mov   left_margin,64
   mov   curx,64
   mov   cury,32
   lea   dx,smess
   call  print_string
   mov   left_margin,0
   jmp   do_displayb
do_displaya:
   call   present
do_displayb:
   call   reset_segs
   mov   ax,0
   call   getkey
; check for read,save and merge
   cmp   al,0
   je   no_fast
; check for fast path guys
   cmp   ah,17h
   jne   no_image
   call   do_image
   jmp   do_displaya
no_image:
   cmp   ah,13h
   jne   no_read
   call   rselect
   jmp   do_displaya
no_read:
   cmp   ah,1fh
   jne   no_save
   call   sselect
   jmp   do_displaya
no_save:
   cmp   ah,32h
   jne   no_merge
   call   mselect
   jmp   do_displaya
no_merge:
no_fast:

; check for type
   cmp   ax,1400h
   jne   no_type
   call   do_type
   jmp   do_displaya
no_type:
; check for zoom
   cmp   ax,2c00h
   jne   no_zoom
   call   do_fat
   jmp   do_displaya
no_zoom:
   cmp   ax,2600h
   jne   no_line
   call   do_line
   jmp   do_displaya
no_line:
   cmp   ax,3002h
   jne   no_break
   jmp   ctrl_b
no_break:
   cmp   ah,31h  ; ALT-N
   jne   no_name
   xor   nswitch,1
   jmp   do_displaya
no_name:
   cmp   bx,44
   jge   go_go_line
   cmp   ah,68h
   jge   no_get_key
   cmp   bx,54
   jg   no_get_key
go_go_line:
   call   word ptr cs:go_line[bx]
   jmp   do_displaya
extrn do_font0:near,do_font1:near,do_font2:near,do_font3:near
extrn do_font4:near
fontline dw do_font1,do_font2,do_font3,do_font4
no_get_key:
; check here for alternate fonts
   cmp   ah,71h
   jne   no_71h
   call   do_font0
   call   blip
   jmp   do_displaya
no_71h:
   cmp   ah,68h
   jl   do_blop
   cmp   ah,6bh
   jg   do_blop
   sub   ah,68h
   mov   bl,ah
   mov   bh,0
   shl   bx,1
   call   cs:fontline[bx]
   call   blip
   jmp   do_displaya
do_blop:
   call   blop
   jmp   do_displaya
do_display  endp
key_procs  proc  near
esc_key:
   call  blip
   call  blop
   call  gobackf
   ret
ret_key:
   call  blip
   call  blop
   ret
;
ctright:
public ctright
   mov   ax,vid_wid
   jmp   check_back
right_key:
; if the right key is pressed we must move picture left
; that means subtracting from si
   test   dh,3
   jz   nright
   mov   ax,1
   jmp   check_back
nright: ; normal right
   cmp   dl,2
   jne   nr_s   ; if dl is 2 then we move fast
   mov   ax,24
   jmp   check_back
nr_s:
   mov   ax,8
   jmp   check_back
ctleft:
public ctleft
; this is the ctrl-left key
   mov   ax,vid_wid
   jmp   check_for
left_key:
   test   dh,3
   jz   nleft
   mov   ax,1
   jmp   check_for
nleft:
   cmp   dl,2
   jne   nl_s
   mov   ax,24
   jmp   check_for
nl_s:
   mov   ax,8
   jmp   check_for
cthome:
; cntrol home
   mov   ax,vwid ; one page width
   dec   ax   ; make it ones
   and   siloc,ax
   mov   curr_seg,0
   ret
home_key:
; go to top left
   mov   siloc,0
   mov   curr_seg,0
   ret
up_key:
; misleading up key and down key were switched
; up_key is really the down key which moves the picture up!
; and vice versa
   mov   ax,vwid
   test   dh,3
   jz   nup
   jmp   check_back
nup:
   shl   ax,1
   shl   ax,1
   cmp   dl,2
   jne   nu_s
   shl   ax,1
   shl   ax,1
   jmp   check_back
nu_s:
   jmp   check_back
down_key:
   mov   ax,vwid
   test   dh,3
   jz   ndown
   jmp   check_for
ndown:
   shl   ax,1
   shl   ax,1
   cmp   dl,2
   jne   nd_s
   shl   ax,1
   shl   ax,1
   jmp   check_for
nd_s:
   jmp   check_for
;
;
ctend:
   mov   ax,last_si
   mov   bx,vwid ; one page width
   dec   bx   ; make it ones
   and   siloc,bx
   xor   bx,0ffffh
   and   ax,bx
   add   siloc,ax
   mov   ax,last_seg
   mov   curr_seg,ax
   cmp   fat_on,0
   jne   fat3
   ret
end_key:
   mov   ax,last_si
   mov   siloc,ax
   mov   ax,last_seg
   mov   curr_seg,ax
   cmp   fat_on,0
   jne   fat3
   ret
fat3:
   mov   ax,last_Fsi
   mov   siloc,ax
   mov   ax,last_Fseg
   mov   curr_seg,ax
   ret
ctpgup:
   mov   ax,7000h
   jmp   check_back
ctpgdn:
   mov   ax,7000h
   jmp   check_for
pgup_key:
   mov   ax,4000h
   jmp   check_back
pgdn_key:
   mov   ax,4000h
   jmp   check_for
;
;
check_back:
; this checks to see if we have overstepped boundaries
;
; ax comes in with the amount of the decrement
; how to check if we can't go left
   cmp   ax,128  ; minimum virtual page size
   jge   upper
; this is a righter
; here we must subtract the ax amount with out goin left off
; of page
   cmp  siloc,0
   je  exit_back_loop
   mov   bx,vwid   ; virtual page width
   dec   bx   ; turns it to 1's
   mov   cx,ax   ; bytes to move
back_loop:
   test  siloc,bx
   jz   exit_back_loop   ; boundary edge if zero
   cmp  siloc,0
   je  exit_back_loop
   dec   siloc
   loop  back_loop
   ret
exit_back_loop:
   call   blop
   ret
;
;
upper:
; here the down key is pressed so we are moving back
   cmp   siloc,ax   ; is there room enough to sub?
   jge   ok_up   ; carry is set if you can't
   call   get_prev_seg   ; get last segment
   jc   no_ok_up
   sub   siloc,ax
   add   siloc,segmentsize
   ret
ok_up:
   sub   siloc,ax
   ret
no_ok_up:
; here we have to move to top
   mov   ax,vwid
no_ok_up2:
   cmp   siloc,ax
   jl   exit_up
   sub   siloc,ax
   jmp   no_ok_up2
exit_up:
   ret
;
; check_for checks if a left or up key is pressed
; THIS IS WHERE WE **ADD** to SI OFFSET
;
check_for:
; check for boundary overstep
; we have to see if we are overstepping segments or si's
   cmp   ax,128  ; minimum virtual page size
   jge   lower
; step formard until we reach an end segment
; no need to test for last_seg because last_si is always
; a border
   mov   bx,vwid
   dec   bx   ; make it ones
   mov   cx,ax   ; how many to move
   mov   dx,siloc
   add   dx,vid_wid
; check to see if all this is necessary
   inc   dx
   test   dx,bx
   jnz   for_loop
; move all the way to right
   and    siloc,bx
   call   blop
   ret
; here move to the right until the ax is run out
for_loop:
; if we are here, we know we can move at least 1 to right
   inc   siloc
   inc   dx
   test   dx,bx
   jz   exit_down
   loop   for_loop
   ret
exit_down:
; the si has passed the end of the seg or line
   call   blop
   ret
lower:
; this assumes that we are not moving closer to the right edge
; just down
   mov   bx,siloc
   sub   bx,segmentsize
   neg   bx
   dec   bx
; bx has the remaining bytes in the segment, we must check to see
; that we will not overstep the segments
   cmp   bx,ax   ; is it ok to add?
   jge   ok_down
; adding in ax here will cause a segment flip
;
;   we have to flip a segment. If we are already in the
; last segment, time to get pu
   mov   cx,last_seg
   cmp   fat_on,0
   je   no_fat1
   mov   cx,last_fseg
no_fat1:
   cmp   curr_seg,cx
   jge   no_down
;
;  get a new seg
;   we can flip because it won't put us past last seg
   push   ax
   call   get_next_seg  ; get a seg
   pop   ax
   jc   no_down   ; no seg to give
   add   siloc,ax
   sub   siloc,segmentsize
;   now have to see if we passed the end
   jmp   try_down
no_down:
; can't add in the ax because we are too near the end
   call   blop
   ret
ok_down:
; here we just add in, no danger of screwing up segments
   add   siloc,ax
;
; try_down checks to see if we are still in a valid range
try_down:
; check to see if we are in last segment
   mov   cx,last_seg
   cmp   fat_on,0
   je   no_fat5
   mov   cx,last_fseg
no_fat5:
   cmp   curr_seg,cx
   jl   exit_for
; we are in the last_seg, did we exceed last_si?
   mov   cx,last_si
   cmp   fat_on,0
   je   no_fat2
   mov   cx,last_fsi
no_fat2:
   cmp   siloc,cx
   jl   exit_for
   mov   bx,vwid   ; virtual page width
   sub   siloc,bx   ; back off virtual line width
   jmp   no_fat2
exit_for:
   ret
;
;
;
slash_key:
; we are heading back to the tree
   pop   ax   ; gets rid of return
   mov   sp,quitter
   mov   goback2,sp
   mov   ax,sp
   push   ax
   push   ax
   mov   goback1,sp
   jmp   got_slash
f1_key:
   mov  helps,0
   call blip
   call help
   ret
f2_key:
   ret
f3_key:
   call  set_color
   ret
f4_key:
   call  set_palette
   ret
f5_key:
   call  do_hires
   ret
f6_key:
   call  do_med
   ret
f7_key:
   ret
f8_key:
   ret
f9_key:
   jmp  slash_key
   ret
f0_key:
; do the quit yes/no stuff
   lea   si,tree7000
   mov   bp,0
   call   do_tree
   call   quit
   ret
ctrl_b:
   lea   si,tree2200
   mov   bp,0
   call   do_tree
   call   quit
   ret
dot_key:
   ret
go_line dw  esc_key,ret_key,right_key,left_key,home_key,up_key,end_key
   dw down_key,pgup_key,pgdn_key,slash_key,dot_key
   dw f1_key,f2_key,f3_key,f4_key,f5_key
   dw f6_key,f7_key,f8_key,f9_key,f0_key,cthome,ctend,ctleft
   dw ctright,ctpgup,ctpgdn
   dw 64 dup(do_displaya)
key_procs  endp
;
;=============================================
;
; GET_PREV_SEG allows you to go up a segment
;
get_prev_seg  proc  near
   cmp   curr_seg,0
   jle   bad_segment1
   dec   curr_seg
   clc
   ret
bad_segment1:
   call   blop
   stc
   ret
get_prev_seg  endp
;
;=============================================
;
; GET_NEXT_SEG allows you to go down a segment
;
get_next_seg  proc  near
   push   ax
   mov   ax,last_seg
   cmp   fat_on,0
   je   fat4
   mov   ax,last_fseg
fat4:
   cmp   curr_seg,ax
   pop   ax
   jl   same_segment0
   call   blop
   stc
   ret
same_segment0:
   inc   curr_seg
   clc
   ret
get_next_seg  endp
CSEG	ENDS
   END
