; OKDATAT.ASM is the area for DSEG which is the tree structure
; of the menus.
; TREES consist of three main parts.
;
;   BARS are the menu choices on the line. They are highlighted
;   when they are chosen. They are 8 bytes per choice and there
;   can be 10 choices on a bar. Items must at least start with a
;   number or an upper case letter and all first characters of a
;   bar choice must be unique!
;   Bars are ended with the 00h character.
;
;   LINES are the explanation line. They consist of 2 parts, first
;   is the help screen number (byte) from 0 to 256. (see help for
;   explanation of various ranges.) Next is the line of explanation
;   about the menu item up to 72 bytes, ended again with a 0.
;
;   TREES are the structural glue of the menu system. They have
;   information, such as the names of the bar and the line that
;   is used to traverse the tree. They have either the address of
;   the next tree, or the program module to execute for that node.
;
;   Tree format is all in words and is as follows
;   BAR ADDRESS - address of the bar associated with this node
;   if bar is zero then this is assumed to be an execution node
;   if bar is 1 then assumed to be not yet installed
;   if bar is 2 then assumed to be pay only option - message 1
;   if bar is 3 then assumed to be pay only option - message 2
;
;   LINE ADDRESS - address of explanation line associated with
;   this tree node.
;
;   COUNT - number of nodes which follow - only meaningful if
;   bar address is not 0 to 4.
;   LINE ADDRESS - address of line record associated with this node
;
;   TREE ADDRESSES - Address of trees associated with the BAR NAMES
;   there must be the same number of tree addresses as the indicated
;   by the count field. If BAR Address is 0 then there is only one
;   address and that is the executable module which will be called
;   when this node is selected.
;   If tree address is 0 then this is an old record, same as if
;   bar address is 0 - not installed.
;
cseg        SEGMENT PUBLIC 'CODE'
;
EXTRN	list_file2:NEAR
EXTRN   rselect:near,mselect:near,sselect:near,iselect:near
EXTRN	get_p_printer:NEAR,do_cap:NEAR,do_space:NEAR
EXTRN	set_range:NEAR,set_page:NEAR,set_lf:NEAR,do_print:NEAR
EXTRN	get_p1:NEAR,get_p2:NEAR,get_p_file:NEAR,get_p3:NEAR,get_p4:NEAR
EXTRN	get_p5:NEAR,get_p6:NEAR,get_p7:NEAR,get_p8:NEAR,get_p9:NEAR
EXTRN	get_p10:NEAR,get_p11:NEAR,get_p12:NEAR,get_p13:near
EXTRN	get_p14:NEAR
EXTRN	set_lpt1:NEAR,set_lpt2:NEAR,set_lpt3:NEAR
EXTRN	set_den1:NEAR,set_lbox:near,set_xbox:near
EXTRN	set_den2:NEAR
EXTRN	set_den3:NEAR
EXTRN	set_den4:NEAR
EXTRN	set_den5:NEAR
EXTRN	set_den6:NEAR
EXTRN	set_or1:NEAR,set_or2:NEAR
EXTRN	set_asp1:NEAR,set_asp2:NEAR
EXTRN	set_p_xor:NEAR,set_p_no_xor:NEAR
EXTRN	set_color:NEAR,set_palette:NEAR,do_tosh3100:near
EXTRN	do_line:NEAR,do_type:NEAR,do_box:NEAR,do_ellipse:NEAR
EXTRN   do_vids:near
EXTRN	do_paint:NEAR
EXTRN	set_font0:NEAR
EXTRN	set_font1:NEAR,set_font2:NEAR,set_font3:NEAR,set_font4:NEAR
EXTRN	color0:NEAR,color1:NEAR,color2:NEAR,color3:NEAR
EXTRN	color4:NEAR,color5:NEAR,color6:NEAR,color7:NEAR
EXTRN	color8:NEAR,color9:NEAR,color10:NEAR,color11:NEAR
EXTRN	color12:NEAR,color13:NEAR,color14:NEAR,color15:NEAR
EXTRN	color16:NEAR,color17:NEAR;,color18:NEAR,color19:NEAR
EXTRN	set_appl0:NEAR,set_appl1:NEAR,set_appl2:NEAR
EXTRN	set_appl3:NEAR,set_appl4:NEAR,set_appl5:NEAR
EXTRN	do_rotate:NEAR
EXTRN	do_hshrink:NEAR,do_vshrink:NEAR,do_bshrink:NEAR
EXTRN	do_hexpand:NEAR,do_vexpand:NEAR,do_bexpand:NEAR
EXTRN	do_mirror:NEAR,do_xor_mem:NEAR,do_blank:NEAR,do_flip:NEAR
EXTRN	do_bound:NEAR,do_roll:NEAR,do_clean:NEAR,do_unstep:NEAR
EXTRN	quit:NEAR,do_erase_memg:NEAR,goback:NEAR
EXTRN	end_prog:NEAR
EXTRN	do_delete:NEAR,do_copy:NEAR
EXTRN	disp_config:NEAR
EXTRN	do_memory:NEAR,set_ems1:NEAR,set_ems2:NEAR,set_ems3:NEAR
EXTRN	set_ems5:NEAR,set_ems6:NEAR,set_ems7:NEAR
EXTRN	set_ems8:NEAR,set_ems0:NEAR
EXTRN	set_emsa:NEAR
EXTRN	set_break0:NEAR,set_ems4:NEAR
EXTRN	set_break1:NEAR,set_break2:NEAR,set_break3:NEAR,set_break4:NEAR
EXTRN	set_break5:NEAR,set_break6:NEAR,set_break7:NEAR,set_break8:NEAR
EXTRN	set_break9:NEAR
EXTRN	set_v128:NEAR,set_v256:NEAR,set_v512:NEAR
EXTRN	set_tone_on:NEAR,set_tone_off:NEAR
EXTRN	set_v1024:NEAR
EXTRN	save_config:NEAR
EXTRN	do_ega0f:NEAR,do_ega10:NEAR,do_para480:NEAR,do_tseng:NEAR
EXTRN	do_vga11:NEAR,do_vga12:NEAR,do_vga13:NEAR
EXTRN	do_compaq:NEAR,do_stb:NEAR
EXTRN	set_macro1:NEAR,set_macro2:NEAR,set_macro3:NEAR
EXTRN	set_macro4:NEAR,set_macro5:NEAR,set_macro6:NEAR
EXTRN	set_macro7:NEAR,set_macro8:NEAR,set_macro9:NEAR
EXTRN	set_baud1:NEAR,set_parity1:NEAR,set_com1:NEAR,set_com2:NEAR
EXTRN	set_baud2:NEAR,set_parity2:NEAR
EXTRN	set_baud3:NEAR,set_parity3:NEAR
EXTRN	set_baud4:NEAR
EXTRN	set_com3:NEAR,set_init:NEAR
EXTRN	do_smooth:NEAR,do_lskew:NEAR,set_1skew:NEAR,set_2skew:NEAR
EXTRN	set_hskew:NEAR,do_rskew:NEAR
EXTRN	do_gray:NEAR
EXTRN	do_fat:NEAR,do_overlay:NEAR,do_inlay:NEAR
EXTRN	set_scaleh:NEAR,set_scale1:NEAR,set_scale2:NEAR,set_scale4:NEAR
EXTRN	set_attrib0:NEAR,set_attrib1:NEAR,set_attrib2:NEAR,set_attrib3:NEAR
EXTRN	set_attrib5:NEAR,set_attrib6:NEAR,set_attrib7:NEAR
EXTRN	set_attrib4:NEAR
EXTRN	exit_prog:NEAR
EXTRN	do_scan:NEAR,do_check:NEAR,do_princeton:NEAR,do_handy:NEAR
EXTRN	set_sred1:NEAR,set_sres1:NEAR,set_smod1:NEAR,set_sden1:NEAR
EXTRN	set_sred2:NEAR,set_sres2:NEAR,set_smod2:NEAR,set_sden2:NEAR
EXTRN	set_sred3:NEAR,set_sres3:NEAR,set_smod3:NEAR,set_sden3:NEAR
EXTRN	set_sres4:NEAR
EXTRN	do_sstart:NEAR,do_srange:NEAR
EXTRN	width1:NEAR,width2:NEAR,width3:NEAR
EXTRN	width4:NEAR,width5:NEAR,width6:NEAR
EXTRN	width7:NEAR,width8:NEAR
EXTRN	set_sneg1:NEAR,set_sneg2:NEAR
EXTRN	do_scale:NEAR
EXTRN	set_pass1:NEAR,set_pass2:NEAR
EXTRN	set_plane_1:NEAR,set_plane_4:NEAR
EXTRN	do_vip53:NEAR
EXTRN	do_genius:NEAR
EXTRN	do_gen73:NEAR
EXTRN	do_gen7c:NEAR
EXTRN	do_gen59:NEAR
EXTRN   say_hello:near
EXTRN	set_destroy_on:near,set_destroy_off:near
cseg	ENDS
tseg	segment public 'DATA'
	assume	CS:cseg,DS:tseg,ES:tseg
;
; now the line for each bar
;
line11000	DB	0,'Load, save, merge, and list files',0
;
line11100	DB	0,'Load a file from disk into the workspace',0
;
line11170	DB	0,'Best Guess: MicroSoft Paint, GEM, Zsoft PCX, GIF, TIF or MacPaint',0
;
line1200	DB	0,'Write picture information to disk',0
line1300	DB	0,'Combine a file from disk with the current picture',0
line1400	DB	0,'List files or change disk or directory',0
line1500	DB	0,'Display information from the header of a file',0
;
; scanner stuff
;
line16		DB	0,'Read/write image data from CANON IX-12',0
line161		DB	0,'Read image data from CANON Image Scanner IX-12',0
line1612	DB	0,'Locate the starting postion for Scan/Print',0
line1613	DB	0,'Set Resolution, Mode, Density, Etc for Scanning',0
line16131	DB	0,'Change the horizontal reduction',0
line161311	DB	0,'No horizontal reduction',0
line161312	DB	0,'1/2 horizontal reduction',0
line161313	DB	0,'1/4 horizontal reduction',0
line16132	DB	0,'Change scan resolution 75DPI - 300DPI',0
line161321	DB	0,'75  dots per inch',0
line161322	DB	0,'150 dots per inch',0
line161323	DB	0,'200 dots per inch',0
line161324	DB	0,'300 dots per inch',0
line16133	DB	0,'Scan mode (massage the dots)',0
line161331	DB	0,'Normal 2 gradation input mode',0
line161332	DB	0,'2 value OR (not at 300 DPI)',0
line161333	DB	0,'DITHER. (simulate gray scaling)',0
line16134	DB	0,'Darken or lighten - Adjust for dark or light pictures',0
line161341	DB	0,'Standard density',0
line161342	DB	0,'DARK compensate for dark pictures',0
line161343	DB	0,'LIGHT compensates for light pictures',0
line16135	DB	0,'Make the picture negative',0
line161351	DB	0,'Standard, white is white - black is black',0
line161352	DB	0,'Negative, white is black and black is white.',0
line1614	DB	0,'Start the scan!',0
;ine1615	DB	0,'Special scanning/printing instructions',0
; jlaser menus
line163		DB	0,'Read image through a Princeton Graphics Scanner',0
line162		DB	0,'Read image data from DFI Handy Scanner',0
; mode is dithering stuff
; check file types
line1700	DB	0,'Check For Recognizeable file header',0
;
; the configuration stuff - all new
;
line2000	DB	0,'OPTIKS Environment and optional features',0
line2100	DB	0,'Set and Save configuration',0
line2110	DB	0,'Virtual Page width and Page dataset',0
line2111	DB	0,'1024 pels width (good for Mac pictures, etc)',0
line2112	DB	0,'2048 pels wide. 6-3/4 inches at 300 dpi',0
line2113	DB	0,'4096 pels wide. 13 inches at 300 dpi',0
line21131	DB	0,'8196 pels wide. 27 inches at 300 dpi',0
line2114	DB	0,'Allocate EMS memory for virtual paging',0
line21140	DB	0,'Automatically Allocate all Available EMS',0
line21141	DB	0,'Allocate 128K of EMS memory for paging',0
line21142	DB	0,'Allocate 256K of EMS memory for paging',0
line21143	DB	0,'Allocate 512K of EMS memory for paging',0
line21144	DB	0,'Allocate 1 Meg of EMS memory for paging',0
line21145	DB	0,'Allocate 1.5 Megs of EMS memory for paging',0
line21146	DB	0,'Allocate 2 Megs of EMS memory for paging',0
line21147	DB	0,'Allocate 3 Megs of EMS memory for paging',0
line21148	DB	0,'Allocate 4 Megs of EMS memory for paging',0
line21149	DB	0,'Deallocate all EMS memory',0
line2115	DB	0,'Display memory allocation',0
;line2120	DB	0,'Set that talking noise on or off',0
;line2121	DB	0,'Set that infernal talking noise OFF!',0
;line2122	DB	0,'Set the talker back on',0
line2130	DB	0,'Set the print options',0
line2150	DB	0,'Save the configuration',0
line2160	DB	0,'Display the current configuration',0
line2170	DB	0,'Turn BLIP/BLOP sound off and on',0
line2171	DB	0,'Turn ON the blip/blop',0
line2172	DB	0,'Silence is golden',0
line2180	DB	0,'Use a Block Range or BOX range',0
line2181	DB	0,'USE the big Block BOX range indicator',0
line2182	DB	0,'Use a line outline range indicator',0
line2190	DB	0,'Clean area or Leave area on TILT, SIZE and SHRINK',0
line2191	DB	0,'Leave old picture on TILT, SIZE and SHRINK',0
line2192	DB	0,'CLEAN out old picture on TILT, SIZE, and SHRINK',0
line2200	DB	0,'Set debug INT 3 breakpoints (true hackers only)',0
line2210	DB	0,'Turn off breakpoint',0
line2220	DB	0,'1 - Initial screen mode setup',0
line2230	DB	0,'2 - Start of Menu tree',0
line2240	DB	0,'3 - Start of Module execution from tree',0
line2250	DB	0,'4 - Enter file header check',0
line2260	DB	0,'5 - Enter file body decompress',0
line2270	DB	0,'6 - Enter file header write',0
line2280	DB	0,'7 - Enter file body compress',0
line2290	DB	0,'8 - Enter print file GO',0
line229a	DB	0,'9 - Various (let me suprise you)',0
; 2300 is change the default screen modes
line2300	DB	0,'Change the screen mode',0
line2310	DB	0,'Select a Video Screen Mode',0
line2314	DB	0,'COLOR Planes for EGA and VGA',0
line23141	DB	0,'One color Plane (black and white)',0
line23142	DB	0,'Four color Planes - 16 colors',0
line23143	DB	0,'Eight color Planes - 64 colors',0
line23144	DB	0,'Sixteen color Planes - 256 colors',0
line2400	DB	0,'Set keyboard macros Alt-1 to Alt-9',0
line2410	DB	0,'Enter Keyboard string started by pressing Alt-1',0
line2420	DB	0,'Enter Keyboard string started by pressing Alt-2',0
line2430	DB	0,'Enter Keyboard string started by pressing Alt-3',0
line2440	DB	0,'Enter Keyboard string started by pressing Alt-4',0
line2450	DB	0,'Enter Keyboard string started by pressing Alt-5',0
line2460	DB	0,'Enter Keyboard string started by pressing Alt-6',0
line2470	DB	0,'Enter Keyboard string started by pressing Alt-7',0
line2480	DB	0,'Enter Keyboard string started by pressing Alt-8',0
line2490	DB	0,'Enter Keyboard string started by pressing Alt-9',0
line2500	DB	0,'Erase the picture and start with a clean slate',0
line2510	DB	0,"No, don't erase the picture",0
line2520	DB	0,'Yes, Erase the whole picture',0
;
; 3000 is the print stuff, much of which can be reached through config
;
line3000	DB	0,'Print a Picture to a Disk file or a Printer',0
line3100	DB	0,'Print to a printer',0
line3200	DB	0,'Print to a disk file',0
line3300	DB	0,'Print to a LaserMaster Corp. CAPCard',0
line3330	DB	0,'Start printing after setting range and start',0
line3110	DB	0,'Specify a range',0
line3120	DB	0,'Issue a Page eject to printer',0
line3130	DB	0,'Issue a Line feed to printer',0
line3140	DB	0,'Print the picture',0
line3150	DB	0,'Change printer defaults',0
line3151	DB	0,'Change the default printer type',0
line31511	DB	0,'Dot matrix printers',0
line31512	DB	0,'Laser Printers',0
line315111	DB	0,'IBM graphics printer',0
line315112	DB	0,'Epson and Compatible printers',0
line315113	DB	0,'C.ITOH 8510 or NCR 6411-8510',0
line315114	DB	0,'Toshiba P321',0
line315118	DB	0,'IBM Proprinter',0
line315120	DB	0,'IBM Proprinter P24, high density',0
line315115	DB	0,'GEMINI 10X or 15X (please report if fixed)',0
line315116	DB	0,'Epson LQ1000/LQ800 24 wire modes',0
line315121	DB	0,'Hewlett Packard Laser Jet',0
line315122	DB	0,'Ricoh LP4080R (for Rob Masterson)',0
line315123	DB	0,'Canon LaserBeam LBP-8A2 Printer',0
line3152	DB	0,'Select from LPT1-3 or COM1-3',0
line31521	DB	0,'Set printer to LPT1 to LPT3',0
line315211	DB	0,'All output will go to LPT1:',0
line315212	DB	0,'All output will go to LPT2:',0
line315213	DB	0,'All output will go to LPT3:',0
line31522	DB	0,'Set printer to COM1 to COM3',0
line315221	DB	0,'Set printer Baud rate',0
line3152211	DB	0,'Set rate to 1200 baud',0
line3152212	DB	0,'Set rate to 2400 baud',0
line3152213	DB	0,'Set rate to 4800 baud',0
line3152214	DB	0,'Set rate to 9600 baud',0
line315222	DB	0,'Set printer Parity',0
line3152221	DB	0,'Set parity to NONE with 8 data bits and one stop bit',0
line3152222	DB	0,'Set parity to EVEN with 7 data bits and one stop bit',0
line3152223	DB	0,'Set parity to IGNORE with 7 data bits and one stop bit',0
line315223	DB	0,'Initialize printer port to correct Baud and Parity',0
line315224	DB	0,'All output will go to COM1:',0
line315225	DB	0,'All output will go to COM2:',0
line315226	DB	0,'All output will go to COM3:',0
line3153	DB	0,'Select graphics density. (Selects closest for your printer)',0
line31531	DB	0,'Low density',0
line31532	DB	0,'Medium density',0
line31533	DB	0,'High density',0
line31534	DB	0,'Highest density.',0
line31535	DB	0,'Epson FX CRT mode. (Not LJ or BJ80 compatible)',0
line31536	DB	0,'EPSON FX 1 to 1 plotter mode (Not LJ or BJ80 compatible)',0
line3154	DB	0,'Select orientation. (HP LaserJet, only)',0
line31541	DB	0,'Portrait. (default)',0
line31542	DB	0,'Landscape Mode. (Sideways printing)',0
line3155	DB	0,'Select negative or positive printing',0
line31551	DB	0,'Print output as negative image (default)',0
line31552	DB	0,'Print positive output (opposite of screen)',0
line3156	DB	0,'Switch from draft to dark printing (dot matrix)',0
line31561	DB	0,'Draft, one pass of the print head',0
line31562	DB	0,'Darker, two passes of the print head',0
line3160	DB	0,'Space over the right',0
line7000	DB	0,'Exit to operating system',0
line7100	DB	0,'No, do not exit at this time',0
line7200	DB	0,'Yes, Exit OPTIKS',0
line8000	DB	0,'Display current version of OPTIKS.',0
tseg    ends
dseg	segment PUBLIC 'DATA'
	assume     CS:cseg,DS:dseg,ES:dseg
public tree0000,tree7000
;
; first the bar for each tree
;
	DB	'OPTIKS',13,10
	DB	'Copyright 1990 by Keith P. Graham',13,10,26
bar0000	DB	'FILE    ENVIRN  PRINT   IMAGE   DRAW    '
	DB	'TYPE    SCAN    VERSION QUIT    ',0
; bar 1000 is file stuff
bar1000	DB	'READ    SAVE    MERGE   LIST    INFO    CHECK',0
bar16	DB	'IX-12   PRINCTN DFI',0
bar161	DB	'RANGE   LOCATE  DEFAULT SCAN',0
bar1613	DB	'HREDUC  RESOL   MODE    DENSITY NEGATE',0
bar16131	DB	'NONE    HALF    QUARTER ',0
bar16132	DB	'75DPI   150DPI  200DPI  300DPI',0
bar16133	DB	'NORMAL  2-OR    DITHER',0
bar16134	DB	'STANDRD DARK    LIGHT',0
bar16135	DB	'POSIT   NEGATE',0
bar162	DB	'RANGE   SCAN',0
; bar 2000 is config and control stuff
bar2000	DB	'CONFIG  SCREEN  MACROS  ERASE',0
bar2100	DB	'VIRT    SCREEN  PRINTER KEEP    DISPLAY '
	DB	'BLIP    RANGE   CLEAN',0
bar2110	DB	'1024    2048    4096    8192    EMS     DISPLAY',0
bar2114	DB	'ALL     128     256     512     MEG     B-1.5M  C-2M    '
	DB	'C-3M    D-4M    UNALLOC ',0
bar2120	DB	'YES     NO',0
bar2200	DB	'0       1       2       3       4       5       '
	DB	'6       7       8       9',0
bar2170	DB	'ON      QUIET',0
bar2180	DB	'BOX     LINE',0
bar2190	DB	'LEAVE   CLEAN',0
; screens
bar2300	DB	'VIDEO   COLOR',0
bar2314	DB	'1       4',0
;
bar2400	DB	'1       2       3       4       5       '
	DB	'6       7       8       9',0
bar2500	DB	'NO      YES     ',0
;
; bar 3000 is the printer options, much is already in config
;
bar3000	DB	'PRINTER FILE    CAPCard',0
bar3100	DB	'RANGE   PAGE    LINEF   GO      CONFIG  SPACE',0
; printers and densities  config stuff
bar3150	DB	'MODEL   PORT    DENSITY ORIENT  NEGATE  STRIKES',0
bar3151	DB	'DOT     LASER   ',0
bar31511	DB	'IBM     EPSON   8510    '
	DB	'TOSHIBA PROPRT  24PROPR GEMINI  LQnnnn',0
bar31512	DB	'HPLJ    RICOH   CANONLB ',0
bar3152	DB	'LPT     COM',0
bar31521	DB	'1       2       3',0
bar31522	DB	'BAUD    PARITY  INIT    1       2       3',0
bar315221	DB	'1200    2400    4800    9600',0
bar315222	DB	'N,8,1   E,7,1   I,7,1   ',0
bar3153	DB	'1       2       3       4       5       6       ',0
bar3154	DB	'PORTR   LAND    ',0
bar3155	DB	'NEGATE  POSIT   ',0
bar3156	DB	'ONE     TWO',0
;
bar3300	DB	'RANGE   LOCATE  GO      PAGE',0
;
;
; bar 7000 is the yes no
;
bar7000	DB	'NO      YES     ',0
;
; now the trees
;
; tree000 is  file,work,print,image,draw,type,quit
EXTRN	tree4000:word,tree5000:word,tree6000:word
tree0000	DW	bar0000,0,9,tree1000,tree2000,tree3000,tree4000
	DW	tree5000,tree6000,tree1600,tree8000,tree7000
; tree1000  retreiv,save,merge,list,default,read
tree1000	DW	bar1000,line11000,6,tree1100,tree1200,tree1300
	DW	tree1400,treei1100,tree1700
; tree1100 pcr,text,lang,bload,fonts,more
tree1100	DW	0,line11100,0,rselect
;
;
; tree1200 save  pcr,apple,brush,msp,load,img,dcopy,more
tree1200	DW	0,line1200,0,sselect
;
;
; tree1300 merge pcr,text,lang,bload,more
tree1300	DW	0,line1300,0,mselect
;
;
; 1400 is the list file function
;
tree1400	DW	0,line1400,0,list_file2
; 1500 is change dir
;tree1500	DW	0,line1500,0,0,get_info
;
; scanner stuff
; 1600 is read scanned image stuff direct
;
tree1600	DW	bar16,line16,3,tree16100,tree16300,tree16200
; this is the ix-12 stuff
tree16100	DW	bar161,line161,4,tree1611,tree1612,tree1613
	DW	tree1614
tree1611	DW	0,line3110,0,do_srange
tree1612	DW	0,line1612,0,do_sstart
tree1613	DW	bar1613,line1613,5,tree16131,tree16132,tree16133
	DW	tree16134,tree16135
tree16131	DW	bar16131,line16131,3,tree161311,tree161312,tree161313
tree161311	DW	0,line161311,0,set_sred1
tree161312	DW	0,line161312,0,set_sred2
tree161313	DW	0,line161313,0,set_sred3
tree16132	DW	bar16132,line16132,4,tree161321,tree161322,tree161323,tree161324
tree161321	DW	0,line161321,0,set_sres1
tree161322	DW	0,line161322,0,set_sres2
tree161323	DW	0,line161323,0,set_sres3
tree161324	DW	0,line161324,0,set_sres4
tree16133	DW	bar16133,line16133,3,tree161331,tree161332,tree161333
tree161331	DW	0,line161331,0,set_smod1
tree161332	DW	0,line161332,0,set_smod2
tree161333	DW	0,line161333,0,set_smod3
tree16134	DW	bar16134,line16134,3,tree161341,tree161342,tree161343
tree161341	DW	0,line161341,0,set_sden1
tree161342	DW	0,line161342,0,set_sden2
tree161343	DW	0,line161343,0,set_sden3
tree16135	DW	bar16135,line16135,2,tree161351,tree161352
tree161351	DW	0,line161351,0,set_sneg1
tree161352	DW	0,line161352,0,set_sneg2
tree1614	DW	0,line1614,0,do_scan
;tree1615	DW	0,line1615,0,do_shelp
; jlaser - old
; princeton
tree16300	DW	bar161,line163,4,tree1611,tree1612,tree1613
	DW	tree1614
tree16200	DW	bar162,line162,2,tree1611,tree1622
tree1622 	DW	0,line1614,0,do_handy
;
tree1700	DW	0,line1700,0,do_check
;
;
;2000 is the /W for workspace type of stuff
;
tree2000	DW	bar2000,line2000,4,tree2100,tree2300
	DW	tree2400,tree2500
tree2100	DW	bar2100,line2100,8,tree2110,tree2300
	DW	tree3150,tree2150,tree2160,tree2170,tree2180,tree2190
; 3150 above is a branch into the printer stuff
; virt screen size
tree2110	DW	bar2110,line2110,6,tree2111,tree2112,tree2113,tree21131
	DW	tree2114,tree2115
tree2111	DW	0,line2111,0,set_v128
tree2112	DW	0,line2112,0,set_v256
tree2113	DW	0,line2113,0,set_v512
tree21131	DW	0,line21131,0,set_v1024
tree2114	DW	bar2114,line2114,10,tree21140,tree21141,tree21142,tree21143
	DW	tree21144,tree21145,tree21146,tree21147,tree21148
	DW	tree21149
tree21140	DW	0,line21140,0,set_emsa
tree21141	DW	0,line21141,0,set_ems1
tree21142	DW	0,line21142,0,set_ems2
tree21143	DW	0,line21143,0,set_ems3
tree21144	DW	0,line21144,0,set_ems4
tree21145	DW	0,line21145,0,set_ems5
tree21146	DW	0,line21146,0,set_ems6
tree21147	DW	0,line21147,0,set_ems7
tree21148	DW	0,line21148,0,set_ems8
tree21149	DW	0,line21149,0,set_ems0
tree2115	DW	0,line2115,0,do_memory
; talk
;tree2120	DW	bar2120,line2120,2,tree2121,tree2122
;tree2121	DW	0,line2121,0,set_voice_off
;tree2122	DW	0,line2122,0,set_voice_on
;
; config  save
tree2150	DW	0,line2150,0,save_config  ; save the configuration
tree2160	DW	0,line2160,0,disp_config  ;display the configuration
; tone
tree2170	DW	bar2170,line2170,2,tree2171,tree2172
tree2171	DW	0,line2171,0,set_tone_on
tree2172	DW	0,line2172,0,set_tone_off
; range block
tree2180	DW	bar2180,line2180,2,tree2181,tree2182
tree2181	DW	0,line2181,0,set_xbox
tree2182	DW	0,line2182,0,set_lbox
; leave or clean on sizing
tree2190	DW	bar2190,line2190,2,tree2191,tree2192
tree2191	DW	0,line2191,0,set_destroy_off
tree2192	DW	0,line2192,0,set_destroy_on
;
;
; break selection 2200
;
tree2200	DW	bar2200,line2200,10,tree2210,tree2220,tree2230,tree2240
	DW	tree2250,tree2260,tree2270,tree2280,tree2290,tree229a
public tree2200
tree2210	DW	0,line2210,0,set_break0
tree2220	DW	0,line2220,0,set_break1
tree2230	DW	0,line2230,0,set_break2
tree2240	DW	0,line2240,0,set_break3
tree2250	DW	0,line2250,0,set_break4
tree2260	DW	0,line2260,0,set_break5
tree2270	DW	0,line2270,0,set_break6
tree2280	DW	0,line2280,0,set_break7
tree2290	DW	0,line2290,0,set_break8
tree229a	DW	0,line229a,0,set_break9
;
; screen selection 2300
;
tree2300	DW	bar2300,line2300,2,tree2310,tree2314
tree2310	DW	0,line2310,0,do_vids
public tree2314
tree2314	DW	bar2314,line2314,2,tree23141,tree23142
tree23141	DW	0,line23141,0,set_plane_1
tree23142	DW	0,line23142,0,set_plane_4
;
; 2400 is the macro stuff
;
tree2400	DW	bar2400,line2400,9,tree2401,tree2402,tree2403
	DW	tree2404,tree2405,tree2406
	DW	tree2407,tree2408,tree2409
tree2401	DW	0,line2410,0,set_macro1
tree2402	DW	0,line2420,0,set_macro2
tree2403	DW	0,line2430,0,set_macro3
tree2404	DW	0,line2440,0,set_macro4
tree2405	DW	0,line2450,0,set_macro5
tree2406	DW	0,line2460,0,set_macro6
tree2407	DW	0,line2470,0,set_macro7
tree2408	DW	0,line2480,0,set_macro8
tree2409	DW	0,line2490,0,set_macro9
; erase picture
tree2500	DW	bar2500,line2500,2,tree2510,tree2520
tree2510	DW	0,line2510,0,goback
tree2520	DW	0,line2520,0,do_erase_memg
;
;  printer stuff here
;
tree3000	DW	bar3000,line3000,3,tree3100,tree3200,tree3300
tree3100	DW	0,line3100,0,get_p_printer
tree3200	DW	0,line3200,0,get_p_file
tree3300	DW	bar3300,line3300,4,tree1611,tree1612,tree3330,tree3120
tree3330	DW	0,line3330,0,do_cap
; the printer trees return through tree31x which is the print stuff
tree31x	DW	bar3100,0,6,tree1611,tree3120,tree3130,tree3140
	DW	tree3150,tree3160
public tree31x
tree3110	DW	0,line3110,0,set_range
tree3120	DW	0,line3120,0,set_page
tree3130	DW	0,line3130,0,set_lf
tree3140	DW	0,line3140,0,do_print
tree3160	DW	0,line3160,0,do_space
; this stuff is the print stuff for config and is called in
; from under the /w stuff
tree3150	DW	bar3150,line3150,6,tree3151,tree3152,tree3153
	DW	tree3154,tree3155,tree3156
tree3151	DW	bar3151,line3151,2,tree31511,tree31512
tree31511	DW	bar31511,line31511,8,tree315111,tree315112,tree315113
	DW	tree315114
	DW	tree315118
	DW	tree315120
	DW	tree315115
	DW	tree315116
tree315111	DW	0,line315111,0,get_p1
tree315112	DW	0,line315112,0,get_p4
tree315113	DW	0,line315113,0,get_p5
tree315114	DW	0,line315114,0,get_p7
tree315115	DW	0,line315115,0,get_p8
tree315116	DW	0,line315116,0,get_p14
;ree315117	DW	0,line315117,0,get_p10
tree315118	DW	0,line315118,0,get_p11
;ree315119	DW	0,line315119,0,get_p12
tree315120	DW	0,line315120,0,get_p13
tree31512	DW	bar31512,line31512,3,tree315121,tree315122,tree315123
tree315121	DW	0,line315121,0,get_p2
tree315122	DW	0,line315122,0,get_p3
tree315123	DW	0,line315123,0,get_p6
tree3152	DW	bar3152,line3152,2,tree31521,tree31522
tree31521	DW	bar31521,line31521,3,tree315211,tree315212,tree315213
tree315211	DW	0,line315211,0,set_lpt1
tree315212	DW	0,line315212,0,set_lpt2
tree315213	DW	0,line315213,0,set_lpt3
tree31522	DW	bar31522,line31522,6,tree315221,tree315222,tree315223
	DW	tree315224,tree315225,tree315226
tree315221	DW	bar315221,line315221,4,tree3152211,tree3152212
	DW	tree3152213,tree3152214
tree3152211	DW	0,line3152211,0,set_baud1
tree3152212	DW	0,line3152212,0,set_baud2
tree3152213	DW	0,line3152213,0,set_baud3
tree3152214	DW	0,line3152214,0,set_baud4
tree315222	DW	bar315222,line315222,3,tree3152221,tree3152222
	DW	tree3152223,0
tree3152221	DW	0,line3152221,0,set_parity1
tree3152222	DW	0,line3152222,0,set_parity2
tree3152223	DW	0,line3152223,0,set_parity3
tree315223	DW	0,line315223,0,set_init
tree315224	DW	0,line315224,0,set_com1
tree315225	DW	0,line315225,0,set_com2
tree315226	DW	0,line315226,0,set_com3
tree3153	DW	bar3153,line3153,6,tree31531,tree31532,tree31533,tree31534
	DW	tree31535,tree31536
tree31531	DW	0,line31531,0,set_den1
tree31532	DW	0,line31532,0,set_den2
tree31533	DW	0,line31533,0,set_den3
tree31534	DW	0,line31534,0,set_den4
tree31535	DW	0,line31535,0,set_den5
tree31536	DW	0,line31536,0,set_den6
tree3154	DW	bar3154,line3154,2,tree31541,tree31542
tree31541	DW	0,line31541,0,set_or1
tree31542	DW	0,line31542,0,set_or2
tree3155	DW	bar3155,line3155,2,tree31551,tree31552
tree31551	DW	0,line31551,0,set_p_xor
tree31552	DW	0,line31552,0,set_p_no_xor
tree3156	DW	bar3156,line3156,2,tree31561,tree31562
tree31561	DW	0,line31561,0,set_pass1
tree31562	DW	0,line31562,0,set_pass2
;
tree7000	DW	bar7000,line7000,2,tree7100,tree7200
PUBLIC      tree7000
tree7100	DW	0,line7100,0,quit
tree7200	DW	0,line7200,0,exit_prog
tree8000	DW	0,line8000,0,say_hello
treei1100	DW	0,line11100,0,iselect
dseg	ends
	end
