retfar2 macro
     db 0cah,02,00
     endm
print macro string
    lea   dx,string
    mov   ah,9
    int   21h
    endm
CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
        ORG        100H
ENTPT:        JMP        setpass
; 3 bytes for jmp
          db 7 dup(0)
   db 'EMMXXXX0' ; ems handle used by some routines to check EMS
; this area is used by the resident and passthrough versions
;
hello  db 13,10,'OKEMS Disk based EMS emulator installing',13,10,'$'
handle  dw  0
istack   dw   256  dup(0)
int67      dd  0
int67ip   equ word ptr int67
int67cs   equ word ptr int67 + 2
int21      dd  0
int21ip   equ word ptr int21
int21cs   equ word ptr int21 + 2
saveax   dw  0
savesp   dw  0
savess   dw  0
savespl  dw  0
savessl  dw  0
blocks   dw  0
blocks_allocated dw 0
diskfile db 'c:\$$$EMS@@.KPG',0
psp      dw  0
ioctrl   dw  0
handle_count dw 0
last_handle  dw 0
next_handle dw 107
crc_val   dw  0
page_frame dw 0  ; EMS PAGE FRAME
mess1    db  13,10,"OKEMS DE-INSTALLING",13,10,10,'$'
err1     db 'Memory allocations error',13,10,'$'
err2     db 'Insufficient Disk Space',13,10,'$'
err3     db 'Command line error',13,10
         db 'Please refer to documentation for proper use',13,10,'$'
ems_tab struc
ems_count dw 0   ; how many allocated
ems_start dw 0   ; starting at which real block
ems_saved dw 0  ; handle of any saved states
page1     dw 0  ; which real page is in page1
crc1      dw 0  ; crc of page
page2     dw 0  ; which real page is in page2
crc2      dw 0  ; crc of page
page3     dw 0  ; which real page is in page3
crc3      dw 0  ; crc of page
page4     dw 0  ; which real page is in page4
crc4      dw 0  ; crc of page
ems_tab ends
handle_table dw 21 dup(0,0,0,1,-1,-1,-1,-1,-1,-1,-1)
;
; this data is used by the passthru program only
;
command_line db 129 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute
           dw command_line
tailds     dw  0
           dw 5ch ; fcb in psp
fcb1       dw  0
           dw 6ch ; fcb in psp
fcb2       dw  0
resident        PROC        NEAR
dosint:
; check out dosint here
; check and see if it is for us
      cmp   cs:ioctrl,0
      je    check_open
      cmp   bx,'KG'
      je    check_io
      jmp   not_us
check_io:
      cmp   ah,3eh ; close
      jne   check_more_io
      mov   cs:ioctrl,0
      clc
      retfar2
check_more_io:
      cmp  ax,4400h
      je  check_device_info
      cmp  ax,4407h
      jne  not_us
      mov  al,0ffh
      clc
      retfar2
check_device_info:
      mov   dx,80h
      clc
      retfar2
check_open:
      cmp   ax,3d00h
      jne   not_us
      push  bx
      mov  bx,dx
      cmp  word ptr ds:[bx],'ME'
      jne  pop_not_us
      cmp  word ptr ds:[bx+2],'XM'
      jne  pop_not_us
      cmp  word ptr ds:[bx+4],'XX'
      jne  pop_not_us
      cmp  word ptr ds:[bx+6],'0X'
      jne  pop_not_us
      cmp  byte ptr ds:[bx+8],0
      je   pop_is_us
pop_not_us:
      pop   bx
      jmp   not_us
pop_is_us:
      pop   bx
      mov   cs:ioctrl,'KG'
      mov   ax,'KG'
      clc
      retfar2
not_us:
      jmp   cs:int21
fakeout:
; in order to make the EMS routines happy, the handle name
; had to be at ORG+10, but we have org = 100h so
; here we enter 100h ahead
        push ax
        mov  ax,cs
        sub  ax,10h
        pushf
        push ax
        mov  ax,offset ems
        push ax
        iret
EMS:
      pop  ax
      cmp  ah,40h
      jl   bad_ems_func
      cmp  ah,4ch
      jle  can_handle_function
bad_ems_func:
      mov  ah,84h
      iret
can_handle_function:
      cmp  ah,40h
      jne  not_40h
      xor   ah,ah
      iret
not_40h:
      cmp  ah,41h
      jne  not_41h
      mov  bx,cs:page_frame
      xor  ah,ah
      iret
not_41h:
      cmp  ah,42h
      jne  not_42h
      mov  bx,cs:blocks
      mov  dx,bx
      sub  bx,cs:blocks_allocated
      xor  ah,ah
      iret
not_42h:
      cmp  ah,43h
      jne  not_43h
; bx has the count of blocks to allocate
      mov   ax,cs:blocks
      sub   ax,cs:blocks_allocated
      cmp   ax,bx
      jl    not_enough_blocks
      cmp   cs:handle_count,20
      jge   no_more_handles
      cmp   bx,0
      jg    allocate_pages
      mov   ah,89h
      iret
no_more_handles:
      mov   ah,85h
      iret
not_enough_blocks:
      mov   ah,87h
      iret
not_43h:
      cmp  ah,46h
      jne  not_46h
; this is the get version
      mov  ax,32h
      iret
allocate_pages:
      push  bx
      push  cx
      mov   dx,cs:next_handle
      push  dx
      push  si
      inc   cs:next_handle
      inc   cs:handle_count
      mov  si,cs:blocks_allocated  ; starting real block
      add  cs:blocks_allocated,bx
; set up the hadle record
      mov  ax,dx
      sub  ax,107 ; lowest handle
      mov  cl,22  ; size of record
      mul  cl     ; offset into record
      xchg ax,bx
      mov  cs:handle_table[bx].ems_count,ax  ; how many
      mov  cs:handle_table[bx].ems_start,si
      mov  cs:handle_table[bx].page1,0ffffh
      mov  cs:handle_table[bx].page2,0ffffh
      mov  cs:handle_table[bx].page3,0ffffh
      mov  cs:handle_table[bx].page4,0ffffh
      mov  cs:handle_table[bx].crc1,0ffffh
      mov  cs:handle_table[bx].crc2,0ffffh
      mov  cs:handle_table[bx].crc3,0ffffh
      mov  cs:handle_table[bx].crc4,0ffffh
      pop  si
      pop  dx
      pop  cx
      pop  bx
      xor  ah,ah
      iret
not_46h:
      cmp  ah,4bh
      jne  not_4bh
; get the handle_count
     mov  bx,cs:handle_count
      xor  ah,ah
      iret
not_4bh:
;
; our ems handles are in the range 107 to 127
; from here on out there are handles needed
; all of these calls require a handle
        cmp  dl,106
        jg   our_handle
; can't be for us, there is a handle we don't know
        jmp  cs:int67
our_handle:
; good handle in dx
        cmp  ah,44h
        je   got_44h
        jmp  not_44h
bad_lpage2:
        pop   ax
        pop   dx
        pop   cx
        pop   bx
        pop   di
        pop   si
        pop   bp
bad_lpage:
        mov  ah,8ah
        iret
bad_ppage:
        mov  ah,8bh
        iret
got_44h:
;==============================================================
;
;     FUNCTION 44H - MAP - REMAP
;
;
;==============================================================
; this is the map function
; al is the physical page     0 , 1, 2, 3
; bx is the logical page number   0 to max pages
; dx has the handle
;
; first value check
        mov  cs:last_handle,dx
        cmp  al,0
        jl   bad_ppage
        cmp  al,3
        jg   bad_ppage
        cmp  bx,0
        jl   bad_lpage
        push  bp
        push  si
        push  di
        push  bx
        push  cx
        push  dx
        push  ax
; calculate the index into the table  from dx (who has the logical page)
        call  calc_si_index
        cmp   bx,cs:handle_table[si].ems_count ; bx is the logical pages
        jge   bad_lpage2
; have a good page, we have to allocate it
        call   set_psp  ; saves the current psp
;
; get the real guy in bp
        mov  bp,bx   ; relative page
        add  bp,cs:handle_table[si].ems_start
; bp has the real page we are working on
; may be that we already have the guy
        pop   bx
        push  bx
        mov   bh,0
        shl   bx,1
        shl   bx,1
        cmp  cs:handle_table[si+bx].page1,bp ; is page already mapped?
        je    done_44h
; have get where the page goes into dx
       pop  ax
       push ax
       mov  ah,0
       mov  cx,4000h
       mul  cx
       mov  di,ax  ; save the offset for the write_page
; di now has the offset into the page_frame
       call  write_page
       jc   bad_44h
;
; now the seek to the correct page
      mov  cs:handle_table[si+bx].page1,bp
      call  read_page
      jc   bad_44h
done_44h:
       call  reset_psp
        pop   ax
        pop   dx
        pop   cx
        pop   bx
        pop   di
        pop   si
        pop   bp
        xor  ah,ah
        iret
bad_44h:
       call  reset_psp
        pop   ax
        pop   dx
        pop   cx
        pop   bx
        pop   di
        pop   si
        pop   bp
       mov  ah,81h
        iret
done_44ha: jmp done_44h
not_44h:
;
        cmp  ah,45h
        jne  not_45h
; dx has a handle to deallocate
        push  si
        push  bx
        push  cx
        push  dx
        call  calc_si_index
; si has the offset into the table
      cmp  cs:handle_table[si].ems_count,0  ; is it zero (unallocated?)
      je   bad_45h
; can only free the memory if it was last allocated
      pop   dx
      push  dx
      inc   dx
;     cmp   dx,cs:next_handle
;     jne   leave_45h
;
      dec   cs:handle_count
      mov  ax,cs:handle_table[si].ems_count
      sub  cs:blocks_allocated,ax
      dec   cs:next_handle
; set up the hadle record
;
leave_45h:
      mov  cs:handle_table[si].ems_count,0
;
        pop   dx
        pop   cx
        pop   bx
      pop   si
        xor   ah,ah
        iret
bad_45h:
        pop   dx
        pop   cx
        pop   bx
      pop   si
        mov   ah,83h
        iret
not_45h:
        cmp  ah,47h
        je   got_47h
        jmp  not_47h
got_47h:
; this is save page_map. we don't worry about it as far as saving,
; hell, force a write just for the heck of it
; handle in DX
; this saves the last handle's state
       push  bx
       push  cx
       push  dx
       push  si
       push  di
;
       call  set_psp
       call  calc_si_index
; si has the offset into the table
;
; now write page 0
;
      mov  dx,cs:last_handle
      mov  cs:handle_table[si].ems_saved,dx
      call calc_si_index  ; recalc the other guys page
      mov  bx,0
      mov  di,0
      call  write_page
      jc   bad_47h
      mov  bx,4
      mov  di,4000h
      call  write_page
      jc   bad_47h
      mov  bx,8
      mov  di,8000h
      call  write_page
      jc   bad_47h
      mov  bx,12
      mov  di,0c000h
      jc   bad_47h
      call  write_page
      call  reset_psp
;
       pop   di
       pop   si
       pop   dx
       pop   cx
       pop   bx
       xor  ah,ah
        iret
bad_47h:
;
       pop   di
       pop   si
       pop   dx
       pop   cx
       pop   bx
       mov  ah,81h
        iret
not_47h:
       cmp   ah,48h
       je    do_48h
       mov   ah,84h
       iret
bad_48h:
;
       pop   dx
       pop   cx
       pop   bx
       pop   si
       pop   di
       mov  ah,8eh
       iret
do_48h:
; here we have restore the page map stuff
; the handle is the guy doing the restore
       push  di
       push  si
       push  bx
       push  cx
       push  dx
       call  set_psp
;
       call  calc_si_index
; bx has the offset into the table
      mov  dx,cs:handle_table[si].ems_saved
      cmp  ax,107
      jl   bad_48h
      mov  cs:last_handle,dx
      call calc_si_index  ; get the guys pages back
; reads are just like the writes in the save state
;
      mov   bx,0
      mov   di,0
      call  read_page
      jc   bad_48h
      mov   bx,4
      mov   di,4000h
      call  read_page
      jc   bad_48h
      mov   bx,8
      mov   di,8000h
      call  read_page
      jc   bad_48h
      mov   bx,12
      mov   di,0c000h
      call  read_page
      jc   bad_48h
;
       call  reset_psp
;
       pop   dx
       pop   cx
       pop   bx
       pop   si
       pop   di
       xor  ah,ah
       iret
;
;
;
;     service routines
;
;
CRC_CALC  PROC  near
; this calculates the value of a string of characters
; si points to string. cs:crc_val gets results. cx has count of chars
      push    ax
      push    bx
      push    cx
      push    dx
      push    ds
      mov     ds,cs:page_frame
      mov     bx,0
      mov     cx,4000h
      mov     ah,0
      clc
      cld
loop0:
;     mov     dx,cx
      lodsb
;     MOV     CX,8     ;  AL=CHARACTER
;OOP1:
;     SHL     AL,1
;     RCL     BX,1
;     JNC     LOOP2
;     XOR     BX,1021H
;OOP2:
;     LOOP    LOOP1
      add     bx,ax
;     mov     cx,dx
      loop    loop0
      mov     cs:crc_val,bx
      pop     ds
      pop     dx
      pop     cx
      pop     bx
      pop     ax
      RET
CRC_CALC  ENDP
;
;
;
;
;
read_page:
; si+bx points into table to get the current real
; di points to the segment to be read
      mov  ax,cs:handle_table[si+bx].page1   ; real page
      cmp  ax,0
      jge  rp_2
      ret
rp_2:
       mov  cx,4000h
       mul  cx
       mov  cx,dx
       mov  dx,ax
       mov  ax,4200h
       push  bx
       mov  bx,cs:handle
       int  21h
       pop  bx
       jc   bad_rp
; read  the file
       mov  dx,di
       push ds
       mov  ds,cs:page_frame
       mov  cx,4000h
       push  bx
       mov  bx,cs:handle
       mov  ah,3fh
       int  21h
       pop  bx
       pop  ds
       jc   bad_rp
       cmp  ax,cx
       jne  bad_rp
       push si
       mov  si,di
       call crc_calc
       pop  si
       mov  ax,cs:crc_val
      mov  cs:handle_table[si+bx].crc1,ax ; real page
       ret
bad_rp:
      mov  cs:handle_table[si+bx].crc1,-1 ; real page
       stc
       ret
;
write_page:
; si+bx points into table to get the current real
; di points to the segment to be written
      mov  ax,cs:handle_table[si+bx].page1   ; real page
      cmp  ax,0
      jge  wp_2
by_write:
      ret
wp_2:
       push  si
       mov  si,di
       call crc_calc
       pop  si
       push  ax
       mov  ax,cs:crc_val
      cmp  cs:handle_table[si+bx].crc1,ax
       pop  ax
       je   by_write  ; same crc don't have to write it
       mov  cx,4000h
       mul  cx
       mov  cx,dx
       mov  dx,ax
       mov  ax,4200h
       push  bx
       mov  bx,cs:handle
       int  21h
       pop  bx
       jc   bad_wp
; write the file
       mov  dx,di
       push ds
       mov  ds,cs:page_frame
       mov  cx,4000h
       push  bx
       mov  bx,cs:handle
       mov  ah,40h
       int  21h
       pop  bx
       pop  ds
       jc   bad_wp
       cmp  ax,cx
       jne  bad_rp
       clc
       ret
bad_wp:
       stc
       ret
;
calc_si_index:
; this routine gets the index into si
        push  ax
        push  dx
        mov   ax,dx   ; handle
        sub   ax,107  ; starting handle
        mov   cx,22   ; length of page handling structure
        mul   cx
        mov   si,ax   ; si will have the offset into the table
        pop   dx
        pop   ax
        ret
;
set_psp:
; this sets the current PSP so as not to screw up the application
; PSP.
        push  ax
        push  bx
        mov  ah,51h
        mov  al,0
        mov  bx,0
        int  21h
        mov  cs:psp,bx
        mov  bx,cs
        mov  ah,50h  ; set psp
        mov  al,0
        int  21h
        pop  bx
        pop  ax
        ret
;
reset_psp:
        push  ax
        push  bx
        mov  bx,cs:psp
        mov  ah,50h  ; set psp
        mov  al,0
        int  21h
        pop  bx
        pop  ax
     ret
;
;

resident        ENDP

setpass  proc  near
; set up a local istack
    print hello
        lea  sp,istack+510
        call do_redirects
;
; save the istack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   int   21h
; here is where we return
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
; say that we did it
   lea   dx,mess1
   mov   ah,9
   int  21h
;
; now reset the interrupts so we can leave
;
        push  ds
        lds   dx,int67
        mov   ax,2567h
        int   21h
        pop   ds
;
        push  ds
        lds   dx,int21
        mov   ax,2521h
        int   21h
        pop   ds
; kill the temporary file
        mov   ah,3eh  ; close
        mov   bx,handle
        int   21h
        lea   dx,diskfile
        mov   ah,41h
        int   21h
        mov   ah,4ch
        mov   al,0
        int  21h
        int   20h
setpass  endp
last_byte db 16 dup(0) ; waste space so we don't walk on install code
; this stuff is throw-away as it is not used after exec
bad_end2:
    print err2
    jmp  bad_end
bad_end1:
    print err1
    jmp  bad_end
do_redirects:
;  prepare for the exec function
; shrink memory
   lea   bx,last_byte    ; last byte of program
   add   bx,15           ; trick to round up
   mov   cl,4
   shr   bx,cl           ; divide by 16 to get number of 16 byte blocks
   mov   ah,4ah          ; shrink
   int   21h
   jc    bad_end1
; allocate the page frame
   mov   ah,48h
   mov   bx,1000h  ; 64k
   int   21h
   jc    bad_end1
   mov   page_frame,ax
; parse command line
   call parse_command
; create the output file
   mov   ah,3ch  ; create
   lea   dx,diskfile
   mov   cx,0    ; hidden
   int   21h
   jc    bad_end2
   mov   handle,ax
; make it big  ; seek to file size
     mov ax,4000h
     mul blocks
     mov cx,dx
     mov ax,4200h
     mov bx,handle
     mov dx,0
     int 21h
   jc    bad_end2
; write out a byte to prove we are safe
     mov  ax,4000h
     mov  cx,1
     int  21h
      jc  bad_end2
      cmp  ax,cx
      jne bad_end2
; have the file created
;
; redirect interrupts here
;
        push  es
        mov   ax,3567h
        int   21h
        mov   int67cs,es
        mov   int67ip,bx
        pop   es
        mov   ax,2567h
        mov   bx,cs
        add   bx,10h
        lea   dx,fakeout
        sub   dx,100h
        push  ds
        mov   ds,bx
        int   21h
        pop   ds
;
;
        push  es
        mov   ax,3521h
        int   21h
        mov   int21cs,es
        mov   int21ip,bx
        pop   es
        mov   ax,2521h
        lea   dx,dosint
        int   21h
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
;
; find the comspec
;
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
    ret
bad_end:
    mov   ax,4cffh
    int   21h
parse_command:
;
; get the count of blocks to allocate
   mov  cl,byte ptr ds:[80h]
   mov  ch,0
   cmp  cx,3
   jle  bad_end3
   mov  si,81h
   cld
parse_switch:
; search for slash
   lodsb
   cmp   al,'/'
   je    got_switch
   cmp   al,13
   je    bad_end3
   cmp   al,20h
   jne   bad_end3
   loop  parse_switch
bad_end3:
    print err3
    jmp   bad_end
got_switch:
    dec   cx
    jz    bad_end
    mov   bx,0
switch_loop:
    lodsb
    cmp   al,20h
    je    store_switch
    cmp   al,'0'
    jl    bad_end3
    cmp   al,'9'
    jg    bad_end3
    and   ax,0fh
; multiply it out
     push  cx
     xchg  ax,bx
     mov   cx,10
     mul   cx
     add   bx,ax
     pop   cx
     loop  switch_loop
     jmp   bad_end3
store_switch:
    dec   cx
    jz    bad_end
    cmp   bx,4
    jl    bad_end3
    cmp   bx,128
    jg    bad_end3
    mov   blocks,bx
; continue to look for the disk
;
disk_loop:
    lodsb
    cmp  al,'/'
    je   got_disk
    cmp  al,20h
    je   dloop0
   jmp   bad_end3
dloop0:
    loop  disk_loop
   jmp   bad_end3
got_disk:
   dec   cx
    jz    bad_end
   lodsb
   dec   cx
    jz    bad_end
   mov   diskfile,al
   lodsb
   cmp   al,':'
   je    get_command_line
   jmp   bad_end3
get_command_line:
   dec   cx
    jz    bad_end4
;
;
; create the commandline
;
; the command line has to start with /C and then the command
; and then end with a carriage return. It must have a byte at
; the front saying how long it is
   cld
   lea   di,command_line+1
   mov   al,'/'
   stosb
   mov   al,'C'
   stosb
   mov   al,' '
   stosb
; now copy the real command line in
   cmp   cx,0
   jle   bad_end4
   push  cx
   cld
rep movsb
   pop   cx
   add   cx,3
   mov   command_line,cl
   ret
bad_end4: jmp bad_end3
CSEG        ENDS
        END        ENTPT
