print macro string
     mov   curx,32
     mov   cury,64
     mov   left_margin,32
     call  blop
     lea   dx,string
     call  prbox
     endm
;
;
INCLUDE     f:\ok\okfiles.asm
buffersize  EQU   4000h
lzbuffer    equ   4000h
dseg     SEGMENT PUBLIC 'DATA'
     ASSUME CS:cseg,DS:dseg,ES:dseg
;
EXTRN     buffer:WORD,width_bytes:WORD,height_pix:WORD
EXTRN     rle_header:BYTE,pcr_header:BYTE
extrn     pcb_header:byte,msp_header:byte,mac_header:byte
extrn   crc_val:word,width_pix:word
extrn     curx:word,cury:word,left_margin:word,plane_switch:byte
extrn    srow:word,lrow:word,scol:word,lcol:word,planes:word
EXTRN   CUT_HEADER:WORD,vint:word,vphase:word,color_map:byte
extrn   dcx_header:word,strg:byte,handle:word,shp_header:word
extrn   pow_header:word,pmg_header:word,trs_header:word
;
; new variable to say if stuff gets xored to screen or overlayed
; local only stuff used by the programs
byte_in  db 0
pass     DW    0
in_buffer   DW    0
BUFFCOUNT   DW    0
mac_err  db 'This file has an invalid file header. Press Esc to',10
         db 'quit now, or press enter to attempt to load the file',0
;
;
dseg     ENDS
cseg     SEGMENT PUBLIC 'CODE'
     ASSUME CS:cseg,DS:dseg,ES:dseg
EXTRN     reset_segs:NEAR,read_file:NEAR,prbox:near
extrn     blop:near,flush_buffer:near,move_raw:near
extrn   next_wait:near,fill_buffer:near,write_file:near
extrn   getkey:near,xor_check:near,present:near
extrn  do_sfpt:near,cc_setup:near,say_enter_page:near
extrn  decomp:word
PUBLIC     mac_in,rle_in,mac_read,rle_read,pcb_in,pcb_read
public     msp_in,msp_read,read_raw,dat_in,dat_read,shp_in,shp_read
public     nrd_in,nrd_read
;
;
;
buf_counter  dw  0
;
trs_in:
public trs_in
    call reset_segs
; this is the trs_80 model 4 hires image 640*300
    mov   width_pix,640
    mov   width_bytes,80
    mov   height_pix,300
     lea  ax,move_raw
     mov  cs:decomp,ax
    clc
    ret
trs_read:
public trs_read
    stc
    ret
;
;
pmg_in:
public pmg_in
    call  reset_segs
    mov   ax,pmg_header.pmg_width
    mov   width_pix,ax
    add   ax,8
    shr   ax,1
    shr   ax,1
    shr   ax,1
    mov   width_bytes,ax
    mov   ax,pmg_header.pmg_length
    mov   height_pix,ax
     lea  ax,move_pmg
     mov  cs:decomp,ax
    clc
    ret
move_pmg:
pmg_read:
public pmg_read
    call reset_segs
    mov  cx,width_bytes
    mov  es,buffer
    mov  ds,buffer
pmg_loop:
    lodsb
    cmp  al,0bfh
    je   do_bf
    xor  al,0ffh
    stosb
    loop  pmg_loop
    clc
    ret
do_bf:
    push  cx
    lodsb
    mov   cl,al
    mov   ch,0
    inc   cx
    mov   bx,cx
    lodsb
    cld
    xor  al,0ffh
rep  stosb
    pop  cx
    sub  cx,bx
    cmp   cx,0
    jg    pmg_loop
    clc
    ret
;
pow_in:
public pow_in
; read print power
    call  reset_segs
    mov   cx,pow_header.pow_num
    cmp   cx,14h
    jle   patterns
    push  cx
    mov  cx,2
    lea   dx,pow_header
    call  read_file
    pop   cx
    add   cx,7
    shr   cx,1
    shr   cx,1
    shr   cx,1
    mov   ax,word ptr ds:pow_header
    mov   width_bytes,8
    mov   height_pix,999
    jmp   pow_set
patterns:
    lea   dx,pow_header
    inc   cx
    push  cx
    shl   cx,1
    call  read_file
    pop   bx
    mov   ax,word ptr ds:pow_header+2
    mov   cx,8
    mul   cx
    mov   cx,word ptr ds:pow_header[bx]
    div   cx
    mov   width_bytes,4
    add   cx,7
    shl   cx,1
    shl   cx,1
    shl   cx,1
    mov   height_pix,5000
pow_set:
     lea  ax,move_raw
     mov  cs:decomp,ax
    clc
    ret
pow_read:
; this reads in a graphic from print power
    public pow_read
     stc
    ret
;
DCX_IN:
public DCX_IN
    call reset_segs
    cmp  word ptr dcx_header+10,0
    jne  ask_page
    cmp  word ptr dcx_header+12,0
    jne  ask_page
    jmp  dont_ask
ask_page:
extrn say_enter_page:near
    call  say_enter_page
    cmp   al,27
    jne   convert_page
bad_dcx:
    stc
    ret
convert_page:
    lea   si,strg
    mov   bx,0
    mov   cx,3
pg_loop0:
    push   cx
    mov   ah,0
    lodsb
    cmp    al,30h
    jl     done_pg
    cmp    al,39h
    jg     done_pg
    and    al,15
    xchg   ax,bx
    mov    cl,10
    mul    cl
    add    bx,ax
    pop    cx
    loop   pg_loop0
    push   cx
done_pg:
    pop   cx
    shl   bx,1
    shl   bx,1
    cmp    bx,0
    je    bad_dcx
    mov   dx,dcx_header[bx]+2
    mov   cx,dcx_header[bx]+4
; cx:dx has the dword in it, which is offset from start of file
; we must position in file at this location
     cmp    cx,0
     jne    do_seek
     cmp    dx,0
     jne    do_seek
     jmp     bad_dcx
do_seek:
     mov     bx,handle
     mov     ax,4200h
     int     21h
     jc     bad_dcx
dont_ask:
    lea  dx,pcb_header+2
    mov  cx,128
    call  read_file
    cmp   ax,128
    je    pcb_in
    stc
    ret
; just like PCB_IN

;
PCB_IN:
     call reset_segs
     lea  ax,pcx_line
     mov  cs:decomp,ax
; check to see if we are in PC paint
     cmp   pcb_header.pcb_beg,10
     je   good_pcb
     stc
     ret
v25x:  jmp v25
v25ax:  jmp v25a
good_pcb:
     mov    ax,PCB_HEADER.PCB_width_bytes
     mov    cl,PCB_HEADER.PCB_bits_per_pixel
;     cmp    cl,0
;     jle    v25
     mov    ch,0
     mul     cx
     mov    cl,PCB_HEADER.PCB_NUM_PLANES
     cmp    cl,0
     jle    v25x
; check for planes ok
     mov    ch,0
     cmp    plane_switch,1
     jle    v25ax
     push   ax
     mov    planes,cx
; reset the color planes according to what is here
     lea    si,pcb_header.PCB_colors
     call   get_pcc_palette
     pop    ax
     jmp    v25
v25a:
     mul     cx
v25:
     MOV     WIDTH_BYTES,AX     ;SAVE AS bytes
     mov    ax,PCB_HEADER.PCB_LR_y
     sub    ax,PCB_HEADER.PCB_y
     inc    ax
     mul     planes
     MOV     HEIGHT_PIX,AX     ;SAVE AS PIXELS
     clc
     ret
get_pcc_palette:
public get_pcc_palette
     lea    di,color_map
     mov    cx,16     ; length of EGA color map
     cld
pcc_cloop:
     push  cx
     mov    bl,0
; red first
     call   get_col
     mov    cx,ax
     and    cx,1
     shl    cx,1
     shl    cx,1
     add    bl,cl
     shr    ax,1
     mov    cl,5
     shl    ax,cl
     add    bl,al
; green
     call   get_col
     mov    cx,ax
     and    cx,1
     shl    cx,1
     add    bl,cl
     shr    ax,1
     mov    cl,4
     shl    ax,cl
     add    bl,al
; blue
     call   get_col
     mov    cx,ax
     and    cx,1
     add    bl,cl
     shr    ax,1
     mov    cl,3
     shl    ax,cl
     add    bl,al
     mov     al,bl
     stosb
     pop   cx
     loop pcc_cloop
     lea   dx,color_map
     mov   ah,10h  ; set pallette
     mov   al,2
     int   10h
     clc
     ret
get_col:
     lodsb
     mov    ah,0
     mov    cl,6
     shr    ax,cl
     cmp    ax,0
     je     done_col
     cmp    ax,3
     je     done_col
     cmp    al,1
     je     col1
     mov    al,0
col1:
     inc    ax
done_col:
     clc
     ret
;
;
shp_in:
; read newsmaster graphics files - the whole thing
    call reset_segs
    mov  width_bytes,80
    mov  height_pix,6000
    clc
    ret
shp_read:
; strategy:
;    read in the 4 byte header - 0b,height,wid,0
;    read in graphic
;    read final zero
; go top
    call  reset_segs
shp_top:
    lea   dx,shp_header+2
    mov   cx,4
    call  read_file
    cmp   ax,4
    je    good_4
    stc
    ret
good_4:
    mov   cl,shp_header.shp_height
    mov   ch,0
    mov   bl,shp_header.shp_width
    mov   bh,0
    add   bx,7
    shr   bx,1
    shr   bx,1
    shr   bx,1
; now read in the guy a line at a time
shp_loop0:
    push  cx
    push  bx
    push  ds
    push  es
    mov   cx,80
    mov   ax,buffer
    mov   ds,ax
    mov   es,ax
    mov   di,0
    cld
    mov   al,0
rep stosb
    mov   cx,bx
    mov   dx,0
    push  bx
    call  read_file
    pop   bx
    pop  es
    pop  ds
    cmp   ax,bx
    jne   end_shp1
    mov   cx,80
    mov   di,0
    mov   si,0
    mov   dx,80
    call  flush_buffer
;
    pop  bx
    pop  cx
    jc   end_shp
    loop  shp_loop0
; now we read the final zero
    lea   dx,shp_header+2
    mov   cx,1
    call  read_file
    cmp   ax,1
    jne   end_shp
    jmp   shp_top
end_shp1:
    pop  bx
    pop  cx
end_shp:
    stc
    ret
dat_in:
; read print_shop graphics files - the whole thing
     call reset_segs
     mov  width_bytes,77
     mov  height_pix,6000

     lea  ax,move_shop
     mov  cs:decomp,ax
    clc
    ret
dat_read:
move_shop:
; here si points to source and di points to target
; bx has the bytes to move
; there are 52 lines to move
    mov   ax,buffer
    mov   ds,ax
    mov   es,ax
    mov   cx,52
    push  si
dat_loop0:
    push  cx
    push  si
    mov   cx,7  ; do 7 accross
dat_loop1:
    push  cx
    push  si
    mov   cx,11
rep  movsb
    pop   si
    add   si,52*11 ; next picture
    pop   cx
    loop  dat_loop1
;
;
    pop   si
    pop   cx
    add   si,11
    loop  dat_loop0
    pop   si
    add   si,7*11*52
    call  reset_segs
    clc
    ret

;     MICROSOFT PAINT PICTURE FORMAT
MSP_IN:

     lea  ax,move_raw
     mov  cs:decomp,ax
     MOV     AX,MSP_HEADER.MSP_WIDTH
     AND     AX,0FFFh
     MOV     WIDTH_PIX,AX     ;SAVE AS PIXELS
     SHR     AX,1     ;MAKE INTO BYTES
     SHR     AX,1     ;
     SHR     AX,1     ;
     MOV     WIDTH_BYTES,AX     ;SAVE AS BYTES
     MOV     AX,MSP_HEADER.MSP_HEIGHT
     AND     AX,0FFFH
     MOV     HEIGHT_PIX,AX     ;SAVE AS PIXELS

     CLC
     RET


MSP_READ:
     stc
     ret




read_RAW:
; read raw will loop through reading and flush buffering until the
; buffer won't take it any more or the length is run out
     call  reset_segs
     mov   dx,0
     mov   ax,height_pix
     mul   width_bytes
; dx:ax has the bytes to read
raw_loop:
     cmp   ax,0
     jne   ax_n0
     cmp   dx,0
     jne   ax_n0
     stc
     ret
ax_n0:
     push  ds
     push  es
     push   ax
     push   dx
; start by trying to get the largest number of lines that will fit
     mov   dx,0
     mov   ax,4000h
     div   width_bytes
     mul   width_bytes
     mov   cx,ax
     mov   di,ax
     pop   dx
     pop   ax
     clc
     sub   ax,cx
     jnc   ok_msp_sub
     clc
     sub   dx,1
     jnc   ok_msp_sub
     mov   dx,0
     add   ax,di
     mov   cx,ax
     mov   ax,0
ok_msp_sub:
     push   ax
     push   dx
;
; read the file
     mov  ax,buffer
     mov  es,ax
     mov  ds,ax
     mov  dx,0
     push cx
     call read_file
     cmp  ax,buffersize
     je   flush_raw
; pad the right with blanks
     mov  di,ax
     mov  cx,buffersize
     sub  cx,ax
     cld
     mov  al,0
rep  stosb
flush_raw:
     mov  si,0
     mov  di,0
     pop   cx
     call  xor_check
     call  flush_buffer
;
     pop    dx
     pop    ax
     pop    es
     pop    ds
     jmp    raw_loop
     RET



DCX_READ:
public dcx_read
     jmp   pcb_read



pcx_line:
public pcx_line
; this decompressed one line of PCX file
; bx has the count in a line
    mov   ax,buffer
    mov   ds,ax
    mov   es,ax
     cld
pcx_loop0:
     lodsb
     mov     ah,al
     and     al,11000000b
     cmp     al,11000000b
     je     pcx_got_count
     mov     al,ah
     stosb
     dec    bx
     jmp    pcx_eloop
pcx_got_count:
; the amount is a count
     mov     cl,ah
     mov     ch,0
     and     cl,00111111b
     sub     bx,cx
     cld
     lodsb
rep     stosb
pcx_eloop:
    cmp   bx,0
    jg    pcx_loop0
    call  reset_segs
    clc
    ret

PCB_READ:
     stc
     ret

;
mac_in:
; this is called after the header is read into the 640 bytes
; we will put the stuff for checking out the file here
     CALL  reset_segs
     lea   dx,unpack_line
     mov   cs:decomp,dx
     MOV   pass,0
     MOV   width_bytes,72
     MOV   height_pix,720
     MOV   in_buffer,5000h
; have to check and see what kind of thingy we got, we read in 128
; bytes, but we may have to read in either 384 more or 512 mode
;
; check to see if we have a binary zero header guy
     lea  di,mac_header.mac_version+2
     mov  cx,62
     mov  al,0
     cld
repe  scasb
     jne  mac_check_more
     jmp  zero_head
mac_check_more:
; check for macbinary header
;
     cmp   mac_header.mac_version,1
     jg    check_mp
     cmp   mac_header.mac_file_name,'A'
     jl    check_mp
     cmp   mac_header.mac_file_name,'z'
     jg    check_mp
     cmp   mac_header.mac_file_type,'z'
     jg    check_mp
     cmp   mac_header.mac_file_type,'A'
     jl    check_mp
     cmp   word ptr mac_header.mac_r_fork,0
     jne   check_mp
     cmp   word ptr mac_header.mac_r_fork+2,0
     jne   check_mp
zero_head:
; it looks like we got the macbinary header assume that there
; is a 512 macpaint header
     mov   cx,512
     lea   dx,mac_header.mac_version
     call  read_file
     ret
check_mp:
     cmp   byte ptr mac_header.mac_version,0
     jne   bad_mac
     cmp   byte ptr mac_header.mac_version+1,0
     jne   bad_mac
     cmp   byte ptr mac_header.mac_version+2,0
     jne   bad_mac
     cmp   byte ptr mac_header.mac_version+3,5
     jg    bad_mac
     cmp   byte ptr mac_header.mac_version+3,0
     jl    bad_mac
     mov   cx,384
     lea   dx,mac_header.mac_version
     call  read_file
     ret
bad_mac:
; display the option
     print  mac_err
mac_key:
     call getkey
     cmp  al,13
     je   zero_head
     cmp  al,27
     je   ex_mac_in
     jmp  mac_key
ex_mac_in:
     stc
     RET

;
un_packbitst:
public un_packbitst
; dl has the xor byte
     XOR   CH,CH
     LODSB
     cmp   al,-1
     jne   test_80
     push   cx
     mov    cx,128
     mov    al,0
    rep   stosb
     pop    cx
     DEC   BX
     Jnb   tif_bot
     ret
test_80:
     TEST  AL,80h
     JZ    tif_no_hi
     NEG   AL
     MOV   CL,AL
     INC   CX
     LODSB
     REP   STOSB
     DEC   BX
     ret
tif_no_hi:
     MOV   CL,AL
     INC   CX
     PUSH  CX
; move loop here to xor each byte
     CLD
tif_xor_loop:
rep   movsb
     POP   CX
     SUB   BX,CX
     Jnb   tif_bot
     ret
tif_bot:
     DEC   BX
     ret
;
;
un_packbits:
public un_packbits
; dl has the xor byte
     XOR   CH,CH
     LODSB
     TEST  AL,80h
     JZ    mac_no_hi
     NEG   AL
     MOV   CL,AL
     INC   CX
     LODSB
     XOR   AL,dl
     REP   STOSB
     DEC   BX
     Jnz   mac_bot
     ret
mac_no_hi:
     MOV   CL,AL
     INC   CX
     PUSH  CX
; move loop here to xor each byte
     CLD
mac_xor_loop:
     LODSB
     XOR   AL,dl
     STOSB
     LOOP  mac_xor_loop
     POP   CX
     SUB   BX,CX
     Jnb   mac_bot
     ret
mac_bot:
     DEC   BX
     ret
unpack_line:
public unpack_line
; this is called by decomp to uncompress a line
; si points to input buffer, di to output buffer
; bx keeps a count of the length of the data in input buffer
     mov   ax,buffer
     mov   ds,ax
     mov   es,ax
     mov   dl,0ffh
unpack_line2:
     call  un_packbits
     CMP   BX,0
     JG    unpack_line2
     call  reset_segs
     clc
     ret
;
;  This reads the file and decompresses it
;  it then returns so the buffers can be flushed
;
;
mac_read:
PUBLIC     mac_read
     stc
     ret

get_one_byte:
    push  bx
    push  cx
    push  dx
    push  si
    push  di
    mov   cx,1
      mov   dx,offset byte_in
      call  read_file
    pop   di
    pop   si
    pop   dx
    pop   cx
    pop   bx
      mov   al,byte_in
    ret
nrd_unpack:
; this does one line at a time
; this is called by decomp to uncompress a line
; si points to input buffer, di to output buffer
; bx keeps a count of the length of the data in input buffer
     mov   ax,buffer
     mov   cx,8
     mov   ds,ax
     mov   es,ax
; do the right thing
     mov   dx,0
unnrd_1:
     cld
     lodsb
     cmp   al,13
     je    unnrd_4
     cmp   al,26
     je    unnrd_9
     shl   dx,1
     cmp   al,30h
     je    unnrd_2
     or    dl,1
unnrd_2:
     dec   cx
     cmp   cx,0
     jne   unnrd_1
     mov   al,dl
     stosb
     mov   cx,8
     mov   dl,0
     dec   bx
     cmp   bx,0
     jg    unnrd_1
unnrd_3:
     lodsb
     cmp   al,26
     je    unnrd_10
     cmp   al,13
     je    unnrd_4
     cmp   al,10
     jne   unnrd_3
     call  run_nrd
     call  reset_segs
     clc
     ret
unnrd_4:
     lodsb
     cmp   cl,8
     je    unnrd_5
     shl   dl,cl
     cmp   bx,0
     jle   unnrd_5
     dec   bx
     mov   al,dl
     stosb
unnrd_5:
     call  run_nrd
     call  reset_segs
     clc
     ret
unnrd_9:
     cmp   cl,8
     je    unnrd_10
     shl   dl,cl
     cmp   bx,0
     jle   unnrd_10
     mov   al,dl
     stosb
unnrd_10:
     call  run_nrd
     call  reset_segs
     stc
     ret
nrd_read:
    stc
    ret
run_nrd:
    mov   al,0
    cmp   bx,0
    jle   run_nrd2
    stosb
    dec   bx
    jmp   run_nrd
run_nrd2:
    ret
nrd_in:
; this is norand icon
      call  reset_segs
     lea   dx,nrd_unpack
     mov   cs:decomp,dx
     MOV   pass,0
; read one byte at a time
      mov   bx,0
nrd_1:
      call  get_one_byte
      jc    bad_nrd
      cmp   al,','
      je    nrd_2
      cmp   al,30h
      jl    bad_nrd
      cmp   al,39h
      jg    bad_nrd
      push  cx
      and   ax,0fh
      xchg  bx,ax
      mov   cl,10
      mul   cl
      add   bx,ax
      pop   cx
      jmp   nrd_1
bad_nrd:
; return home no good
    stc
    ret
nrd_2:
    mov   width_pix,bx
    add   bx,7
    shr   bx,1
    shr   bx,1
    shr   bx,1
    mov   width_bytes,bx
    mov   bx,0
nrd_3:
      call  get_one_byte
      jc    bad_nrd
      cmp   al,13
      je    nrd_4
      cmp   al,30h
      jl    bad_nrd
      cmp   al,39h
      jg    bad_nrd
      push  cx
      and   ax,0fh
      xchg  bx,ax
      mov   cl,10
      mul   cl
      add   bx,ax
      pop   cx
      jmp   nrd_3
nrd_4:
    mov   height_pix,bx
      call  get_one_byte
      jc    bad_nrd
      cmp   al,10
      jne   bad_nrd
      clc
      ret
; scan to get the two guys
rle_in:
; check to see if we are in rle
     CALL  reset_segs
     CMP   rle_header.rle_esc,27
     JNE   bad_rle
     CMP   rle_header.rle_g,'G'
     JNE   bad_rle
     CMP   rle_header.rle_density,'H'
     JE    rle_high
     CMP   rle_header.rle_density,'M'
     JE    rle_lo
bad_rle:
     STC
     RET
rle_high:
     MOV   width_bytes,32
     MOV   height_pix,192
     JMP   rle_header_good
rle_lo:
     MOV   width_bytes,16
     MOV   height_pix,96
rle_header_good:
     MOV   pass,0
; here we get a buffer for rle stuff - 4000 for file and 4000 for pic
     MOV   CX,buffersize
     MOV   DX,buffersize
     MOV   AX,buffer
     PUSH  DS
     MOV   DS,AX
     CALL  read_file
     POP   DS
     CMP   CX,1000h
     JL    bad_rle
     MOV   buffcount,CX
     MOV   in_buffer,buffersize
     CLC
     RET

getabyte    MACRO string
     LODSB
     DEC   BP
     CMP   BP,0
     JL    more&string
     ENDM
rle_read:
     CALL  reset_segs
     CMP   pass,0
     JE    first_rle1
     MOV   CX,0
     MOV   pass,0
     STC
     RET
first_rle1:
     MOV   SI,in_buffer
     MOV   BP,buffcount
; no passes as there is only one pass with the big buffers
;
; set up the segments
     MOV   AX,buffer
     MOV   ES,AX
     MOV   DS,AX
     MOV   DI,0
     MOV   BX,0
     MOV   DL,1    ; rle_bit
     MOV   AX,0
first_rle:
     PUSH  AX
     XOR   DL,1
next_rle:
     getabyte _rle
     CMP   AL,27
     JNE   no_esc
     getabyte _rle
     CMP   AL,'G'
     JNE   exit_rle
     getabyte _rle
     CMP   AL,'N'
     JE    exit_rle
     getabyte _rle
no_esc:
     CMP   AL,20h
     JL    exit_rle
     JMP   got_rle_count
more_rle:
; here it is possible that there are more rle files to read
     PUSH  BX
     PUSH  CX
     PUSH  DX
     PUSH  BP
     MOV   CX,buffersize
     MOV   DX,buffersize
     CALL  read_file
     CMP   CX,0
     JE    no_mo_rle
     POP   BP
     MOV   BP,CX
     POP   DX
     POP   CX
     POP   BX
     MOV   SI,buffersize
     JMP   next_rle
no_mo_rle:
     POP   BP
     POP   DX
     POP   CX
     POP   BX
exit_rle:
     POP   AX
     CALL  reset_segs
     MOV   pass,1
     MOV   CX,DI
     CLC
     RET
done_rle_count:
; finsihed a count, get another
     JMP   first_rle
got_rle_count:
; got a count to start in al
     MOV   CL,AL
     MOV   CH,0
     SUB   CX,20h
     POP   AX
     CMP   CX,0    ; if its zero means don't store any
     JLE   done_rle_count
; have a valid counter in cx
rle_loop0:
rle_loop:
     SHL   AX,1
     AND   AX,11111110b
     OR    AL,DL
     INC   BL
     CMP   BL,8
     JL    no_rle_store
     CLD
     STOSB
     MOV   BL,0
no_rle_store:
     LOOP  rle_loop
     JMP   first_rle



;     CUT   IN

     PUBLIC  CUT_IN
CUT_IN:

     PUSH    AX     ;SAVE REGISTERS
     MOV     AX,CUT_HEADER.CUT_WIDTH
     MOV     WIDTH_PIX,AX     ;SAVE AS PIXELS
     SHR     AX,1     ;MAKE INTO BYTES
     SHR     AX,1     ;
     SHR     AX,1     ;
     MOV     WIDTH_BYTES,AX     ;SAVE AS BYTES
     MOV     AX,CUT_HEADER.CUT_HEIGHT
     MOV     HEIGHT_PIX,AX     ;SAVE AS PIXELS
     CLC
     POP     AX
     RET


CUT_READ:
     PUBLIC  CUT_READ
     call  reset_segs
     push   ds
; set up buffer
     mov    ax,buffer
     mov    ds,ax
     mov    es,ax
; get a buffer
     mov     dx,0
     mov     cx,2
     call    read_file
     mov     dx,buffersize
     mov     cx,ds:[0]
     call    read_file
;     EXPAND DATA
     MOV     CX,AX     ;NUMBER OF BYTES READ
     dec     cx
     mov    di,0
     mov    si,buffersize
     mov    bp,0  ; count of bits left in ah
     mov    bx,0  ; save bits
     mov    dx,0
CR100:
     push    cx
     LODSB
     XOR     AH,AH
     TEST    AL,80H     ;
     JNZ     CR500
; here we have a count of bits to put out
     push    ax
     MOV     CX,AX
r_shift_loop:
     shl     bl,1
     lodsb
     or     bl,al
     inc     dx
     cmp     dx,8
     jl     r_shift_loop_end
     mov     al,bl
     stosb
     mov     dx,0
r_shift_loop_end:
     loop    r_shift_loop
     JMP     SHORT CR800
CR500:
     AND     al,07FH
     MOV     CX,AX
     mov     ax,1
     push    ax
     LODSB
r_sl_2:
     shl bl,1
     or  bl,al
     inc  dx
     cmp  dx,8
     jl   r_sl_2_end
     xchg bl,al
     stosb
     mov  dx,0
     mov  al,bl
r_sl_2_end:
     loop r_sl_2
CR800:
     pop     ax
     POP     CX
     sub     cx,ax
     LOOP    CR100


     POP     DS
     DEC     CUT_HEADER.CUT_HEIGHT
     JNZ     CR900
     mov     ax,0
     mov     cx,0
     STC
     JMP     SHORT CR950
CR900:
     mov     cx,di
     mov     ax,di
     CLC
CR950:
     RET     ;

cseg    ENDS
     END
;
;     PIC   IN
;
PIC_IN     PROC    NEAR
public pic_in
     call  reset_segs
     CMP     BYTE PTR PIC_HEADER.PIC_FH,0FDH
     JNE     PI025
     JMP     SHORT PI200
PI025:
     CMP     BYTE PTR PIC_HEADER.PIC_FH,0FEH
     JE     PI050
     JMP     SHORT PI200
PI050:
     MOV     WIDTH_PIX,640     ;SAVE AS PIXELS
     MOV     WIDTH_BYTES,80     ;SAVE AS BYTES
     MOV     HEIGHT_PIX,200     ;SAVE AS PIXELS
     CLC
PI100:
     RET
PI200:
     STC
     ret

PIC_IN     ENDP
; read the PC paint 2.0 format
PC2_IN     PROC    NEAR
     call  reset_segs
; check to see if we are in PC paint
     cmp   pc2_header.pc2_page,1234h
     jne   bad_pc2
     cmp   pc2_header.pc2_mode,'G'
     jne   bad_pc2
     cmp   pc2_header.pc2_pix_size,1
     jne   bad_pc2
     cmp   pc2_header.pc2_block,0
     je    bad_pc2
     jmp   ok_pc2_header
bad_pc2:
     stc
     pop    di
     pop    si
     pop    ax
     ret
     jmp    bad_pc2_wait
ok_pc2_header:
     mov     pic_pass,0

     MOV     AX,PC2_HEADER.PC2_PIX
     MOV     WIDTH_PIX,AX     ;SAVE AS pixels
     SHr     AX,1
     SHr     AX,1
     SHr     AX,1
     MOV     WIDTH_BYTES,AX     ;SAVE AS bytes
     MOV     AX,PC2_HEADER.PC2_HEIGHT
     MOV     HEIGHT_PIX,AX     ;SAVE AS PIXELS
     MOV     COLOR,1
     MOV     PEL_SIZE,1
; prime the pump here? nope
     CLC
     RET
PC2_IN     ENDP
;
;     PIC READ version 1.5
;
PIC_READ     PROC    NEAR
     call  reset_segs
; read the buffer
     push    ds
     push    es
     mov     ax,buffer
     mov     dx,4000h
     mov     es,ax
     mov     ds,ax
     mov     cx,3fffh
     call    read_file
     cmp     ax,0
     je     good_pic_read
     stc
     ret
good_pic_read:
     mov     si,4000h
     mov     di,0
     mov     bp,ax   ; amount in buffer
     add     bp,4000h ; place in buffer
     pop     ds
     pop     es
     MOV     CX,PIC_HEADER.PIC_BLOCKS
; cx has the number of blocks to decompress
;
;     UNCOMPRESS PACKET
;
     MOV     BX,-5
EP050:
     PUSH    CX
     push    ds
     push    es
     ADD     BX,PIC_HEADER.PIC_PAC_SZ
EP100:
     call    getabyte
     jnc     okg1
no_okg:
     pop     es
     pop     ds
     pop     cx
     stc
     ret
okg1:
     CMP     AL,PIC_HEADER.PIC_ID ;START OF RUN?
     JNE     EP700
     call    getabyte
     jc     no_okg
     CMP     AL,0     ;16 BIT VALUE?
     JNE     EP400     ;NO...BRANCH
     call    getabyte
     jc     no_okg
     mov     ah,al
     call    getabyte
     jc     no_okg
     xchg    al,ah
     MOV     CX,AX     ;SETUP COUNT REGISTER
     call    getabyte     ;GET DATA
     jc     no_okg
     REP     STOSB     ;
     JMP     SHORT EP800
EP400:
     MOV     CL,AL     ;GET COUNT
     XOR     CH,CH     ;
     call    getabyte     ;GET CHARACTER TO REPEAT
     jc     no_okg
; store here
     push    es
     mov     ax,buffer
     REP     STOSB     ;REPEAT CHARACTER
     pop     es
     JMP     SHORT EP800     ;EXIT
EP700:
     push    es
     mov     ax,buffer
     STOSB     ;STORE SINGLE CHARACTER
     pop     es
EP800:
     CMP     buff_si,bx
     JNE     EP100     ;
     POP     CX
     call    getabyte
     inc     buff_si
     mov     ah,al
     call    getabyte
     inc     buff_si
     xchg    al,ah
     MOV     CS:PIC_HEADER.PIC_PAC_SZ,AX
     call    getabyte
     inc     buff_si
     mov     ah,al
     call    getabyte
     inc     buff_si
     xchg    al,ah
     MOV     CS:PIC_HEADER.PIC_NORM,AX
     call    getabyte
     inc     buff_si
     MOV     CS:PIC_HEADER.PIC_ID,AL
     jmp     ep050by
ep050jmp:
     jmp     ep050
ep050by:
     LOOP    EP050jmp
     pop     es
     pop     ds
     push    ds
     push    es
     Lea     di,lzBUFFER
     mov     ds,cs:vbuffer
     mov     si,0
     MOV     CX,100     ;100 LINES TO MOVE
PR200:
     PUSH    CX
     PUSH    SI
     MOV     CX,80     ;80 BYTES PER LINE
     REP     MOVSB
     POP     SI
     ADD     SI,2000H     ;OFFSET
     MOV     CX,80     ;80 BYTES PER LINE
     REP     MOVSB
     SUB     SI,2000H
; here we have 160 bytes in the buffer it should be flushed
;
;  the registers current to be saved are:
;     CX,SI,DI,DS
     mov cs:psavesi,si
     mov cs:psavedi,di
     mov cs:psaveds,ds
     mov cs:psavebp,bp
     pop  cx
     mov cs:psavecx,cx
     POP     ES
     POP     DS
     POP     SI
     POP     DI
     POP     DX
     POP     CX
     POP     BX
     mov     ax,160
     mov     cx,ax
     ret
second_pic:
     mov si,cs:psavesi
     mov di,cs:psavedi
     mov es,cs:psaveds
     mov cx,cs:psavecx
     mov bp,cs:psavebp
     LOOP    PR200


     POP     ES
     POP     DS
     POP     SI
     POP     DI
     POP     DX
     POP     CX
     POP     BX
     mov     ax,0
     mov     cx,ax
     RET     ;
PIC_READ     ENDP
PC2_READ     PROC    NEAR

     PUSH    BX
     PUSH    CX
     PUSH    DX
     PUSH    DI
     PUSH    SI
     PUSH    DS
     PUSH    ES
     call    restore_seg
     mov si,cs:psavesi
     mov bp,cs:psavebp
; pic_pass = 0 is first time ever
; pic_pass = 1 is in the middle of a normal byte
; pic_pass = 2 is in the middle of an expansion
     mov    cs:buf_counter,0
     lea    di,lzbuffer
;     int    3
     cmp     pic_pass,0
     je     first_pc2
     jmp     second_pc2
first_pc2:
     mov     pic_pass,1
; get the header
     cmp     pc2_header.pc2_block,0
     je     exit_pc2
get_PAC_head:
     dec     pc2_header.pc2_block
     lea     di,PAC_HEADER
     mov     cx,5
get_pac:
     call    getabyte
     cld
     stosb
     loop    get_pac
     cmp     bp,0     ;count of bytes in buffer
     jg     good_pc2
exit_pc2:
     POP     ES
     POP     DS
     POP     SI
     POP     DI
     POP     DX
     POP     CX
     POP     BX
     mov     ax,0
     mov     cx,ax
     stc
     RET
pac_counter    dw  0
good_pc2:
; we now have to get 2048 bytes into lzbuffer
; have a buffer full of bytes
     lea    di,lzbuffer
     mov    ax,PC2_PAC_SZ
     sub    ax,5
     mov    pac_counter,ax
pc2_lod:
; check to see if we have to return the buffer
     mov    bl,pc2_id
     cmp    pac_counter,0
     jle    flush_pc2a
     cmp    buf_counter,buffersize
     jge    flush_pc2
     call   getabyte
     dec    pac_counter
     cmp    al,bl
     jne    pc2_sto
; have a repeat charcter
     call   getabyte
     dec    pac_counter
     cmp    al,0
     jne    pc2_byte_sto
     jmp    pc2_word_sto
pc2_sto:
     xor    al,0ffh
     stosb
     inc    buf_counter
     jmp   pc2_lod
flush_pc2a: ; finished pack
     mov   pic_pass,0

flush_pc2:
; leave pc2 to get buffer flushed
;
;  the registers current to be saved are:
;     CX,SI,DI,DS
     mov cs:psavesi,si
     lea  di,lzbuffer
     mov cs:psavedi,di
     mov cs:psaveds,ds
     mov cs:psavebp,bp
     mov cs:psavecx,cx
     POP     ES
     POP     DS
     POP     SI
     POP     DI
     POP     DX
     POP     CX
     POP     BX
     cmp  cs:buf_counter,0
     jne    ok_buff
     mov    cs:pic_pass,0
     jmp     pc2_read
ok_buff:
     mov     ax,cs:buf_counter
     mov     cx,ax
     clc
     ret
pc2_char_count dw 0
pc2_char     db  0
pc2_byte_sto:
; the byte in al is a counter for storing repeating data
     mov   ah,0
     mov   pc2_char_count,ax
     jmp   pc2_rep_sto
pc2_word_sto:
     call  getabyte
     dec    pac_counter
     mov   bh,al
     call  getabyte
     dec    pac_counter
     xchg    ah,al
     mov    al,bh
     mov   pc2_char_count,ax
;     jmp   pc2_rep_sto
pc2_rep_sto:
     call  getabyte
     dec    pac_counter
     xor    al,0ffh
     mov     pc2_char,al
     mov     pic_pass,2
pc2_rep_loop:
     stosb
     inc    buf_counter
     dec    pc2_char_count
     cmp    pc2_char_count,0
     jle    flush_pc4
     cmp    buf_counter,buffersize
     jge    flush_pc3
     jmp    pc2_rep_loop
flush_pc5:
     jmp   flush_pc2a
flush_pc3:
     cmp    pac_counter,0
     jle    flush_pc5
     jmp   flush_pc2
flush_pc4:
     cmp    pac_counter,0
     jle    flush_pc5
     cmp    buf_counter,buffersize
     jge    flush_pc3
     mov   pic_pass,1
     jmp   pc2_lod
second_pc2:
     mov si,cs:psavesi
     mov di,cs:psavedi
     mov es,cs:psaveds
     mov cx,cs:psavecx
     mov bp,cs:psavebp
     mov al,pc2_char
     cmp   pic_pass,2
     je   pc2_rep_loop
     mov   pic_pass,1
     jmp   pc2_lod


PC2_READ     ENDP
CRC_CALC  PROC  near
; al hasthe character. DS must be current data sagment
     ret
     push    ax
     push    bx
     push    cx
     push    ds
     push    es
     call    reset_segs
     MOV     CX,0008H     ;  AL=CHARACTER
     MOV     BX,CRC_VAL
LOOP0:
     SHL     AL,1
     RCL     BX,1
     JNC     LOOP1
     XOR     BX,1021H
LOOP1:
     LOOP    LOOP0
     MOV     CRC_VAL,BX
     pop     es
     pop     ds
     pop     cx
     pop     bx
     pop     ax
     RET
CRC_CALC  ENDP
