; OKFILE7.ASM has the read and write routines for various files
;
;  Included here are:
;    PDA
;
;
include f:\ok\okfiles.asm
;
dseg segment public 'DATA'
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
extrn   vint:word,vphase:word,buffer:word
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
     EXTRN   PDA_HEADER:WORD
     EXTRN   PDA_HEADERo:WORD
     EXTRN   FAX_HEADER:WORD
     EXTRN   PEL_SIZE:WORD
     EXTRN   WIDTH_PIX:WORD
     EXTRN   HEIGHT_PIX:WORD
     EXTRN   WIDTH_BYTES:WORD
     EXTRN   COLOR_MAP:byte
extrn  planes:word,plane_switch:byte
divisor  dw  0,1
ten       dw  10,100,1000,10000
grayshade equ 0
flags    dw  0
color   dw  0
PDA_PACK  db '0001'
;
;
dseg  ends
buffersize  equ 4000h
;
CSEG     SEGMENT PUBLIC 'CODE'
     ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
EXTRN   WRITE_RAW:NEAR,reset_segs:near,write_file:near
EXTRN   READ_RAW:NEAR,calc_file_size:near
extrn   read_file:near,write_file:near,next_wait:near
extrn   flush_buffer:near,fill_buffer:near
extrn   blop:near,blip:near
;
;
;     FAX IN
;
     PUBLIC  FAX_IN
FAX_IN     PROC    NEAR
     call    reset_segs
     mov     ax,1728
     MOV     WIDTH_BYTES,ax  ;SAVE AS BYTES
     shl     ax,1
     shl     ax,1
     shl     ax,1
     MOV     WIDTH_pix,ax     ;SAVE AS bits
     mov   ax,4000
     mov     height_pix,ax
     CLC
     RET
FAX_IN     ENDP
;
;
fax_write:
fax_out:
     stc
     ret
public fax_write,fax_out
;
;
;
FAX_READ        PROC    NEAR
extrn  huffr1:near,huffr:near
public fax_read
; prime the pump for starters
     call  reset_segs
;
;
     mov   di,0
     mov   si,6000h
     mov   bp,6000h
     call  fax_moved
; scan for 0ffh
     push  es
     push  di
     mov   di,si
     mov   al,0ffh
     mov   es,buffer
     cld
     mov   cx,bp
     sub   cx,si
repe scasb
     mov   si,di
     dec   si
     pop   di
     pop   es
     mov   di,0
     call  huff21
;
process_fax0:  ; loop through
     call  fax_moved
     jc    leave_fc
; lets get a line
;
     mov   di,0
     mov   ax,bp
     sub   ax,si  ; how many to go
; ax has an amount to decode
     call  huff2
; huff2 takes care of the flush
    jc    no_movef
; flush the buffer
     mov   cx,width_bytes
     sub   cx,di
     cmp   cx,0
     jle   do_fax_flush
     push  es
     mov   es,buffer
     cld
     mov   al,0
rep  stosb
     pop  es
do_fax_flush:
     mov   cx,width_bytes
     push  si
     push  bp
     call  flush_buffer
     pop   bp
     pop   si
     jnc   cont_fc
leave_fc:
     stc
     ret
;
cont_fc:
    mov    di,0
    jmp    process_fax0
;
;
fax_moved:
     mov   cx,bp     ; ending amount
     sub   cx,si     ; how much to move down
     cmp   cx,1000h  ; how much left
     jg    no_movef
     cmp   cx,0
     jl    no_move_err
     je    get_some_fax
     jmp   do_movef
no_move_err:
     stc
     ret
no_movef:
     clc
     ret
do_movef:
     mov   di,6000h
     cld
     mov   ax,buffer
     push  ds
     push  es
     mov   es,ax
     mov   ds,ax
rep  movsb
     pop   es
     pop   ds
     mov   bp,di
     mov   di,0
     mov   si,6000h
     cmp   bp,7000h
     jl    get_some_fax
     clc
     ret
get_some_fax:
     push  si
     push  di
     push  cx
     mov   dx,bp
     mov   cx,7fffh
     sub   cx,bp
     push  ds
     mov   ds,buffer
     call  read_file
     pop   ds
     pop   dx
     pop   di
     pop   si
     add   bp,ax
     mov   si,6000h
     cmp   si,bp
     jge   got_no_fax
     clc
     ret
got_no_fax:
     stc
     ret
;

FAX_READ        ENDP



;
;
;     PDA IN
;
     PUBLIC  PDA_IN
PDA_IN     PROC    NEAR
     call    reset_segs
     cmp     pda_header.pda_type,'0'
     je      got_pda_head
     cmp     pda_header.pda_type,'1' ; fax compressed
     je      got_pda_head
bad_pda_head:
     stc
     ret
got_pda_head:
     lea     si,PDA_HEADER.PDA_WIDTH
     mov     ax,5
     call    asc2bin
     MOV     WIDTH_pix,ax     ;SAVE AS bits
     add     ax,7
     SHr     AX,1
     SHr     AX,1
     SHr     AX,1
     mov     dx,0
     mov     cl,pda_header.pda_res
     and     cx,15
     div     cx
     MOV     WIDTH_BYTES,AX     ;SAVE AS BYTES
     lea     si,PDA_HEADER.PDA_HEIGHT
     mov     ax,5
     call    asc2bin
     mov     dx,0
     mov     cl,pda_header.pda_res
     and     cx,15
     div     cx
     cmp     ax,0
     jg      got_pda_height
     mov     ax,3300
got_pda_height:
     MOV     HEIGHT_PIX,AX     ;SAVE AS PIXELS
     cmp     pda_header.pda_type+25,10
     jne     get_pda_10
got_pda_10:
     CLC
     RET
get_pda_10:
     mov    cx,20
ten_loop:
     push   cx
     lea    dx,pda_pack
     mov    cx,1
     call   read_file
     pop    cx
     jc     bad_pda_10
     cmp    ax,1
     jne    bad_pda_10
     cmp    pda_pack,10
     je     got_pda_10
     loop   ten_loop
     stc
     ret
bad_pda_10:
     stc
     ret
PDA_IN     ENDP
;
;     IMAGE OUT
;
     PUBLIC  PDA_OUT
PDA_OUT     PROC    NEAR
     call    reset_segs
     MOV     AX,WIDTH_BYTES
     lea     di,PDA_HEADERo.PDA_WIDTH
     mov     bx,5
     call    bin2asc
     MOV     AX,HEIGHT_PIX
     lea  di,PDA_HEADERo.PDA_HEIGHT
     mov     bx,5
     call    bin2asc
; write file routine
     mov    cx,PDA_headero
     lea    dx,PDA_headero+2
     call   write_file
     RET
PDA_OUT     ENDP
;
;
     PUBLIC  PDA_READ
;
;
;
PDA_READ        PROC    NEAR
     call    reset_segs
     cmp     pda_header.pda_type,'0'
     je      process_flat
     jmp     process_compressed
process_flat:
     mov     cx,16     ; read 10 blocks at a time
     mov     di,0
pdaf_loop:
     push   cx
     call   get_pda_pack
     pop   cx
     jc    done_pda_packing
     cmp   ax,0
     jle   done_pda_packing
     add   di,ax
     loop  pdaf_loop
     mov   cx,di
     push  di
     pop   di
done_pda_packing:
     cmp   di,0
     jle   leave_pdaf2
     mov   cx,di
     call  flush_buffer
     jc   leave_pdaf2
     jmp   process_flat
leave_pdaf:
     cmp   di,0
     jle   leave_pdaf2
     mov   cx,di
     call  flush_buffer
leave_pdaf2:
     stc
     ret
process_compressed:
extrn  huff21:near,huff2:near
; prime the pump for starters
; xyzzy
     mov   di,0
     mov   si,6000h
     mov   bp,6000h
     call  move_down_buffer
     jnc   pc_c0
done_pc:
     stc
     ret
done_pc2:
     cmp  di,0
     jg   done_pc
     mov  cx,width_bytes
     call flush_buffer
     stc
     ret
pc_c0:
     mov   di,0
     mov   si,6000h
     mov   ax,bp
     call  huff21
     sub   ax,si  ; how many to go
     call  huff2
     jc    done_pc2
process_comp0:  ; loop through
     call  move_down_buffer
     jc    leave_pc
; lets get a line
;
     mov   di,0
     mov   si,6000h
     mov   ax,bp
     sub   ax,si  ; how many to go
; ax has an amount to decode
     call  huff2
; huff2 takes care of the flush
    jc    done_pc2
; flush the buffer
    cmp   di,0
    je   leave_pc
     call  reset_segs
     mov   cx,width_bytes
     push  si
     push  bp
     call  flush_buffer
     pop   bp
     pop   si
     jnc   cont_pc
leave_pc:
     stc
     ret
;
cont_pc:
    mov    di,0
    jmp    process_comp0
;
;
move_down_buffer:
     call  reset_segs
     mov   cx,bp
     sub   cx,si     ; how much to move down
     cmp   cx,0d00h
     jg    no_mover
     cmp   cx,0
     jl    no_mover
     je    get_some_more
     jmp   do_mover
     mov   di,0
no_mover:
;    int  3
     stc
     ret
do_mover:
     mov   di,6000h
     cld
     mov   ax,buffer
     mov   es,ax
     mov   ds,ax
rep  movsb
     call  reset_segs
     mov   bp,di
     mov   di,0
     cmp   bp,6300h
     jl    get_some_more
     mov   si,6000h
     clc
     ret
get_some_more:
     mov   dx,bp
     mov   di,bp
get_more_pack:
     push  bp
     call  get_pda_pack
     pop   bp
     jnc   pc_c1
     stc
     ret
pc_c1:
     add   bp,ax
     mov   si,6000h
     clc
     ret
;
get_pda_pack:
; have to read a block at a time
; di has the location where the pack is to go
     call   reset_segs
     push   di
     mov    cx,4
     lea    dx,pda_pack
     call   read_file
     jnc    good_pda_read
bad_pda_pack:
     mov   ax,0
     pop    di
     stc
     ret
good_pda_read:
     cmp   ax,4
     jne   bad_pda_pack
     lea   si,pda_pack
     call  asc2bin
     jc    bad_pda_pack
     cmp   ax,0
     jle   bad_pda_pack
     mov   cx,ax    ; bytes to read
     pop   di
     push  di
     mov   dx,di
     push  ds
     mov  ds,buffer
     call  read_file
     pop   ds
     cmp   ax,0
     jle   bad_pda_pack
     pop   di
     clc
     ret

PDA_READ        ENDP



;
;     IMAGE WRITE
;
     PUBLIC  PDA_WRITE
PDA_WRITE       PROC    NEAR

     call    reset_segs
     mov    vint,0
     CALL    WRITE_RAW
     RET
PDA_WRITE       ENDP

;  ASCII TO BINARY 
;
;     DS:SI = START OF ASCII STRING
;     AX = NUMBER OF CHARACTER IN STRING (1-5)
;
;     AX = RETURNS BINARY NUMBER
;
ASC2BIN     PROC    NEAR

     PUSH    BX
     PUSH    CX
     PUSH    DX
     PUSH    SI
     cld
     mov    cx,ax
     mov    ax,0
     mov    bx,0
     mov    dx,0
asc_loop:
    push    cx
    lodsb
    mov    ah,0
    cmp     al,30h
    jl      bad_asc
    cmp     al,39h
    jg      bad_asc
    and     al,0fh
    xchg    ax,bx
    mov     cx,10
    mul     cx
    add     bx,ax
    pop    cx
    loop   asc_loop
    mov    ax,bx
     POP     SI     ;RESTORE REGISTERS
     POP     DX
     POP     CX
     POP     BX
     clc
     RET
bad_asc:
; leave with a bad number
     mov     ax,0
     pop     cx
     POP     SI     ;RESTORE REGISTERS
     POP     DX
     POP     CX
     POP     BX
     stc
     RET
ASC2BIN     ENDP

;  BINARY TO ASCII 
;
;     AX = BINARY NUMBER
;     BX = NUMBER OF ASCII CHARACTERS TO FILL  (1-5)
;     ES:DI = WHERE TO PUT ASCII STRING
;
BIN2ASC     PROC    NEAR

     PUSH    AX
     PUSH    BX
     PUSH    CX
     PUSH    DX
     PUSH    DI
     PUSH    SI
     PUSH    ES

     SHL     BX,1     ;MAKE INTO WORD OFFSET
     MOV     SI,OFFSET DIVISOR
     MOV     CX,[SI+BX]     ;DIVISOR

BIN100:
     XOR     DX,DX     ;CLEAR DX FOR DIVIDE
     DIV     CX
     ADD     AL,'0'
     STOSB
     CMP     CX,1
     JE       BIN300
     PUSH    DX     ;SAVE REMAINDER
     MOV     AX,CX     ;GET DIVISOR
     XOR     DX,DX
     DIV     TEN     ;DIVIDE IT BY TEN
     MOV     CX,AX     ;PUT BACK IN DX
     POP     AX     ;GET REMAINDER IN AX
     JMP     SHORT BIN100
BIN300:
     POP     ES
     POP     SI
     POP     DI
     POP     DX
     POP     CX
     POP     BX
     POP     AX
     RET
BIN2ASC     ENDP
;
;

CSEG     ENDS
     END
