; OKTIF.ASM reads and writes TIF, fax and isf files files
;
;
;
lseg segment public 'DATA'
   assume ds:lseg
   extrn  comhead:word
   extrn  syshead:word
lseg ends
;
dseg segment public 'DATA'
      ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
extrn   buffer:word
      ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
      EXTRN   DCOPY_HEADER:WORD
      EXTRN   DCOPY_HEADERO:WORD
      EXTRN   ISF_HEADER:WORD
      EXTRN   PEL_SIZE:WORD
      EXTRN   WIDTH_PIX:WORD
      EXTRN   HEIGHT_PIX:WORD
      EXTRN   WIDTH_BYTES:WORD
      extrn   vint:byte,vwid:word,color:byte,xor_raw:byte
;
;     DCOPY HEADER
;
wips_blen  dw 0
DCOPY      STRUC
DCOPY_COUNT      DW      512
DCOPY_FH      DW      0FFFFH
DCOPY_ulx      DW      0    ; x and y of upper left
dcopy_uly      dw      0    ;
dcopy_height_pix dw      0    ; lines
DCOPY_width_bytes DW     0    ; bytes per line
dcopy_comp      dw      0    ; should be zero if not compressed
      dw      0    ; upper left in bits
dcopy_width_pix  dw      0
      dw      0    ; release
      dw      200  ; density
      db      492 dup(0)  ; dcopy filler - nulls
DCOPY      ENDS

TIF_COUNT      DW      162
;
;The following are data areas and constants for TIFF formats
;
;
;  this is the tiff header for writing only!, whole thing is 162 bytes
;
tif_head    dw      4949h      ;II, swapped byte order, INTEL default
tif_vers    dw      02ah      ;Version = 42 (See hitchiker's guide to the universe)
      dw      8,0      ;byte offset to next entity
tif_entries dw      12      ;count of directory entries
;
;
;
      dw      255      ;TAG = Subfile type
      dw      3      ;type = Short (16 bits)
      dw      1,0      ;one 'short' value, this field
      dw      1,0      ;left justified value, 1= Full resolution image

      dw      256      ;TAG = Image Width
      dw      3      ;type = Short (16 bits)
      dw      1,0      ;one 'short' value, this field
tif_width_pix  dw      3600,0      ;# pixels per line

      dw      257      ;TAG = Image Length
      dw      3      ;type = Short (16 bits)
      dw      1,0      ;one 'short' value, this field
tif_height dw      5800,0      ;# lines whole picture

      dw      258      ;TAG = Bits per Sample
      dw      3      ;type = Short (16 bits)
      dw      1,0      ;one 'short' value, this field
      dw      1,0      ;1 = bit map, line art (DEFAULT)

      dw      259      ;TAG = Compression
      dw      3      ;type = Short (16 bits)
      dw      1,0      ;one 'short' value, this field
tif_compr    dw     1,0      ;2 = CCITT G3-4 FAX Compressed line art
      ; negative is pack bits

      dw      263      ;TAG = thresholding
      dw      3      ;type = Short (16 bits)
      dw      1,0      ;one 'short' value, this field
      dw      1,0      ;1 = Line art, default (2= halftone)

      dw      266      ;TAG = fill order
      dw      3      ;type = Short (16 bits)
      dw      1,0      ;one 'short' value, this field
      dw      1,0      ;1 = MSbit to LSbit, default (2= other way)

      dw      273      ;TAG = Strip Offset
      dw      4      ;type = Long (32 bits)
      dw      1,0      ;Length of 'Strip' in 'long's
      dw      162,0      ;Offset to beginning of picture

      dw      277      ;TAG = Samples per Pixel
      dw      3      ;type = Short (16 bits)
      dw      1,0      ;one 'short' value, this field
      dw      1,0      ;1 = Monochrome, default (3= Color)

      dw      278      ;TAG = Rows per 'Strip'
      dw      4      ;type = Long (32 bits)
      dw      1,0      ;one 'short' value, this field
      dw      0ffffh,0ffffh ;Largest value: Strip = Image

      dw      279      ;TAG = Strip Byte Count
      dw      4      ;type = Long (32 bits)
      dw      1,0      ;one 'short' value, this field
      dw      1,0      ;Length of 'Strip' in bytes

      dw      284      ;TAG = Planar Configuration
      dw      3      ;type = Short (16 bits)
      dw      1,0      ;one 'short' value, this field
      dw      1,0      ;1 = Normal, single plane, default (2= Bit planes)
      dw      0,0,0,0      ;no further directory pointers, end of directory


;
;      ISF  HEADER
;
ISF_COUNT      DW      isf_end - isf_segment ;length of header
; this is the name of the picture
ISF_segment    db      70h
      db      4
      db      "OK20"
; image content is a header for image data
      db      91h
      db      1
      db      0ffh
; this is the block containing image size information
      db      94h
      db      9
      db      0   ;0=10 inch,1=10 cent
isf_horiz_x    dw      1   ;horizontal multiplier
isf_vert_x     dw      1   ;vertical multiplier
isf_horiz_p    dw      0   ;horizontal point <-width_pix
isf_vert_p     dw      0   ;vertical point   <-height_pix
;   encoding method
      db     95h
      db      2
isf_COMPR      db      3   ; 1 = mmr, 3 = raw
      db      1   ; always 1 = RIDIC ; I hope I can break it
; IMAGE DATA is the header for image data
isf_data      db     0feh
      db     92h
isf_d_length   dw     0    ; count of bytes in data
isf_end  equ this byte
;
;
; end data
isf_d_end      db     93h
isf_de_length   db     0
; end segment
isf_s_end     db     71h
isf_se_length db     0h
;
;
isf_type    db  0
isf_len     db  0
isf_body    dw  10 dup(0) ; longest is actually 9
isf_encode  db  0
isf_seg_len dw  0
;
; Locals for ISF_READ
;
;
dseg  ends
buffersize  equ 4000h
;
CSEG      SEGMENT PUBLIC 'CODE'
      ASSUME  CS:CSEG,DS:DSEG,ES:DSEG
EXTRN   WRITE_RAW:NEAR,reset_segs:near,write_file:near
EXTRN   READ_RAW:NEAR,calc_file_size:near,print_string:near
extrn   read_file:near,write_file:near,next_wait:near
extrn   flush_buffer:near,fill_buffer:near
 extrn  huffr1:near
extrn  huffr:near
;
;
      PUBLIC  ISF_READ
ISF_READ      PROC    NEAR
; enter here to get the compressed data from pic
      call  reset_segs
      cmp     isf_encode,1
      je      read_isf_comp
; bypass the first tw bytes of length
      lea     dx,isf_seg_len
      mov     cx,2
      call    read_file
      mov     vint,0
      CALL    READ_RAW
      RET
read_isf_comp:
; read in the buffer
      mov   cx,3ffeh
      mov   bp,4000h
      mov   ax,buffer
      push  ds
      mov   ds,ax
      mov   dx,4000h
      call  read_file
      cmp   ax,0
      jne   ok_isf_read1
      pop   ds
      stc
      ret
ok_isf_read1:
; ax has the buffer count, dx has the location
      mov   bp,ax
      add   bp,4000h
      mov   si,4000h
; have read the buffer
; bp has the end of the in buff
; di has the number of lines
;
      cld
      lodsw
      pop   ds
      mov    isf_seg_len,ax
      mov   cx,height_pix  ; number of lines to read
      mov   di,0
; loop through the lines
isf_loop:
      push  cx
; si has the input buffer location for lodsb
; di has the output buffer location for stosb
; ds, and es are pointing to current data, not buffer
; cx has the count of lines we are getting
; bp has the last byte of the input buffer
;
;
      cmp   si,bp  ; reaching the end?
      jl    no_isf_end
      call  flush_tiff
      pop   cx
      stc
      ret
no_isf_end:
      push   di
      call  huffr1  ; set up first stuff
      mov   ax,03ffeh
      mov   cx,03ffeh
      call  huffr
      pop   di
      jc    end_isf
; check to see if we have to flush the output buffer
      add   di,width_bytes
      cmp   di,3000h ; getting near the end?
      jl     no_isf_flush
      call  flush_tiff
      jnc   no_isf_flush
      pop   cx
      stc
      ret
no_isf_flush:
      cmp   si,7000h
      jl   no_isf_read
      push  bx
      call  tiff_read_buff
      pop   bx
      jc    end_isf
no_isf_read:
      pop   cx
      loop  isf_loop
      push  cx
end_isf:
      pop   cx
      call  flush_tiff
      stc
      ret
;
ISF_READ      ENDP
;
      PUBLIC  ISF_IN
ISF_IN      PROC    NEAR
; this is so exciting
;    6 byte of header have been read and are in okfmaind under
;    ISF_HEADER
      call reset_segs
      cmp ISF_HEADER[2],0470h
      jne  bad_isf_header
; got by the header check now to step through the various types of
; records
isf_head_loop:
      lea  dx,isf_type
      mov  cx,2
      call read_file
      cmp  ax,2
      jne  bad_isf_header
      mov  bl,isf_type
      mov  bh,0
      cmp  bx,0feh
      je   isf_do_decompress
      cmp  bx,91h
      jl   bad_isf_header
      cmp  bx,97h
      jg   bad_isf_header
; have a good isf header
      sub  bx,91h
      shl  bx,1
      jmp  cs:isf_head_jmp[bx]
isf_head_jmp dw isf_ign,bad_isf_header,bad_isf_header,rec_94,rec_95
      dw  isf_ign,isf_ign
bad_isf_header:
      stc
      ret
get_isf_body:
    cmp   isf_len,20
    jle   cont_gb
bad_body:
    pop   ax   ; get ret address out of stack
    jmp    bad_isf_header
cont_gb:
    mov    cl,isf_len
    lea    dx,isf_body
    mov    ch,0
    call   read_file
    cmp    ax,cx
    jne    bad_body
    ret
isf_ign:
      call  get_isf_body
      jmp   isf_head_loop
rec_94:
      call  get_isf_body
; record 94 is 9 bytes and has the length stuff in it
      mov   ax,word ptr isf_body[5]
      xchg  al,ah
      add   ax,7
      shr   ax,1
      shr   ax,1
      shr   ax,1
      mov   width_bytes,ax
      mov   ax,word ptr isf_body[7]
      xchg  al,ah
      mov   height_pix,ax
      jmp   isf_head_loop
rec_95:
      call  get_isf_body
; rec 95 is the method
      mov   al,byte ptr isf_body[0]
      mov   isf_encode,al
      jmp   isf_head_loop
isf_do_decompress:
; here we have found the fe guy and have to get the length of
; the first guy
      cmp   isf_len,92h
      jne   bad_isf_header
; the file pointer is pointing to the word which has the body
; length for the file decompress.
      clc
      ret
ISF_IN      ENDP
flush_tiff:
; check to see if there is something in the buffer
      cmp   di,0
      je    all_done
flush_tiff_buffer:
      push  bp
      push  bx
      push  dx
      push  si
      push  ds
      push es
      call  reset_segs
      push  cx
      mov   cx,di
      call  flush_buffer
      pop   cx
      pop  es
      pop  ds
      pop  si
      pop  dx
      pop  bx
      pop  bp
      jc   all_done
      mov   di,0
      clc
      ret
all_done:
      stc
      ret
;
tiff_read_buff:
;--------------------------------------------------
;read a buffer when empty
      push    ax
      push    cx
      push    dx
      push    ds
      push    es
      push    di
      push    si
      call    next_wait
      pop     si
      call    reset_segs
      mov     ax,buffer
      mov     ds,ax
      mov     es,ax
      mov     cx,bp
      sub     cx,si
      mov     di,4000h
      cmp     cx,0
      jle     no_move
      cld
rep    movsb
; moved what was left down
no_move:
      call    reset_segs
      mov     dx,di      ; first free after old buffer
      mov     cx,7ffeh
      sub     cx,di
;     and     cx,03ffeh   ; round to whole word
      push    ds
      mov     ds,buffer
      call    read_file
      pop     ds
      jmp     rdg1
rdg2:
      stc      ;attempt to read past EOF is error
rdex:
      pop      di
      pop      es
      pop      ds
      pop      dx
      pop      cx
      pop      ax
      ret
rdg1:
      mov      bp,di
      add      bp,ax
      mov      bx,bp
      sub      bx,4000h
      mov      si,4000h
      cmp      bp,4000h
      jle      rdg2
      clc
      jmp      rdex
sys_out  proc  near
public sys_out
; creates the self scrolling com file header
      call    reset_segs
      call    calc_file_size
      call    reset_segs
;  write out the file
     mov   cx,1c90h    ; size of comhead  - HARD CODED
     mov   ax,lseg
     assume ds:lseg
     lea   dx,syshead
     mov   ds,ax
     call  write_file
     assume ds:dseg
     call  reset_segs
     mov   cx,2
     lea   dx,width_bytes
     call  write_file
      call    reset_segs
     mov   cx,2
     lea   dx,height_pix
     call  write_file
     ret
sys_out  endp


com_out  proc  near
public com_out
; creates the self scrolling com file header
      call    reset_segs
      call    calc_file_size
      call    reset_segs
;  write out the file
     mov   cx,1670h    ; size of comhead  - HARD CODED
     mov   ax,lseg
     assume ds:lseg
     lea   dx,comhead
     mov   ds,ax
     call  write_file
     assume ds:dseg
     call  reset_segs
     mov   cx,2
     lea   dx,width_bytes
     call  write_file
      call    reset_segs
     mov   cx,2
     lea   dx,height_pix
     call  write_file
     ret
com_out  endp

      PUBLIC  TIF_OUT
TIF_OUT      PROC    NEAR
      call    reset_segs
      call    calc_file_size
      MOV     AX,WIDTH_BYTES
      shl     ax,1
      shl     ax,1
      shl     ax,1
      MOV     TIF_WIDTH_pix,AX
      MOV     AX,HEIGHT_PIX
      MOV     TIF_HEIGHT,AX
      mov     tif_compr,1
; write file routine
      mov    cx,TIF_count
      lea    dx,TIF_count+2
      call   write_file
      RET
tip_out:
public tip_out
      call    reset_segs
      call    calc_file_size
      MOV     AX,WIDTH_BYTES
      shl     ax,1
      shl     ax,1
      shl     ax,1
      MOV     TIF_WIDTH_pix,AX
      MOV     AX,HEIGHT_PIX
      MOV     TIF_HEIGHT,AX
      mov     tif_compr,8005h
; write file routine
      mov    cx,TIF_count
      lea    dx,TIF_count+2
      call   write_file
      RET
TIF_OUT      ENDP
      PUBLIC  TIF_WRITE
TIF_WRITE      PROC    NEAR

      call    reset_segs
      mov     xor_raw,0
      CALL    WRITE_RAW      ;
      mov     xor_raw,0
      RET      ;
; tif can be also tif pacbits compression
tip_write:
public tip_write
      call    reset_segs
      extrn  pac_write:near
      mov   dx,0
      jmp   pac_write
com_write:
public com_write
sys_write:
public sys_write
      call    reset_segs
      mov   dx,0ffffh
      jmp   pac_write
TIF_WRITE      ENDP

DCOPY_IN      PROC    NEAR
      public  dcopy_in
      call    reset_segs
      MOV     AX,DCOPY_HEADER.DCOPY_width_pix
      MOV     WIDTH_PIX,AX      ;SAVE AS pixels
      MOV     AX,DCOPY_HEADER.DCOPY_width_bytes
      MOV     WIDTH_BYTES,AX      ;SAVE AS bytes
      shl  ax,1
      shl  ax,1
      shl  ax,1
      MOV     WIDTH_PIX,AX      ;SAVE AS pixels
      MOV     AX,DCOPY_HEADER.DCOPY_height_pix
      MOV     height_pix,AX      ;SAVE AS bytes
extrn maxlines:word
      MOV     COLOR,1
;      MOV     PEL_SIZE,1
      clc
      RET
DCOPY_IN      ENDP
DCOPY_OUT      PROC    NEAR
      public  DCOPY_OUT
      call    reset_segs
      call    calc_file_size
      PUSH    AX      ;SAVE REGISTERS

      MOV     ax,WIDTH_BYTES
      MOV     DCOPY_HEADERo.DCOPY_width_bytes,ax

      SHl     AX,1
      SHl     AX,1
      SHl     AX,1
      MOV     DCOPY_HEADERo.DCOPY_width_PIX,ax
      MOV     ax,height_pix
      MOV     DCOPY_HEADERo.DCOPY_height_pix,ax
; write file routine
      mov    cx,dcopy_headero
      lea    dx,dcopy_headero+2
      call   write_file
      POP     AX
      RET
DCOPY_OUT      ENDP
      PUBLIC  DCOPY_READ
DCOPY_READ      PROC    NEAR

      cmp     DCOPY_HEADER.DCOPY_comp,0
      jne     do_dcopy_comp
      call    reset_segs
      mov    vint,0
      CALL    READ_RAW
      RET
do_dcopy_comp:
; here we have to do a compressed datacopy file using
;  ccitt_line
; this has t be set up on a line by line basis, priming the
; buffer and setting up the si and di and the cx and bp, etc
;
; seg regs have the reset value
; bp has the size of the image record we are working on
; read in the buffer
wips_c_loop:
      call  wips_get_buffer
      jnc   wc_1
      jmp   end_wc
wc_1:
; got a buffer, set up the output guy
      mov   si,6000h
      mov   di,0
      call  huffr1
      mov   ax,wips_blen
      mov   di,0
      call  huffr
      jc    end_wc
      cmp   di,0
      je    wc_1
      mov   cx,di
      call  flush_buffer
      jc    end_wc_1
      jmp   wips_c_loop
end_wc:
      cmp   di,0
      je    end_wc_1
      mov   cx,di
      call  flush_buffer
end_wc_1:
      stc
      ret
;
;
;
;
wips_get_buffer:
; before calling huffr we have to fix up the guys and put them in
; word order
; dx has the location,
; ax has the count
; this gets a string into si at 6000h and flips it
      push di    ; should always be 0
      call reset_segs
      lea  dx,wips_blen
      mov  cx,2
      call read_file
      jnc  good_wips_blen
bad_wips_blen:
      pop  di
      stc
      ret
good_wips_blen:
      cmp   ax,2
      jne   bad_wips_blen
      mov   cx,wips_blen
      dec cx
      dec cx
      mov   wips_blen,cx
      push  cx
      push  ds
      mov   dx,6000h
      mov   ds,buffer
      call   read_file
      pop   ds
      pop   cx
      jc    bad_wips_blen
      cmp   ax,cx
      jne   bad_wips_blen
; flip the buffer
      push  cx
      cmp   ax,1
      jle   no_flip
      mov   cx,ax
      mov   ax,buffer
      mov   es,ax
      mov   ds,ax
      mov   si,6000h
      mov   di,si
      shr   cx,1
      cld
w_s_loop:
      lodsw
      xchg  al,ah
      stosw
      loop  w_s_loop
no_flip:
      pop    cx
      call   reset_segs
      pop    di
      clc
      ret

DCOPY_READ      ENDP
      PUBLIC  DCOPY_WRITE
DCOPY_WRITE      PROC    NEAR

      call    reset_segs
      mov    vint,0
      CALL    WRITE_RAW      ;
      RET      ;
DCOPY_WRITE      ENDP
CSEG      ENDS
      END
