; OKKBD.ASM is a collection of keyboard input routines
; it also contains the highlight routine.
;
;  Public routines are:
;     GET_STRING - gets up to 32 bytes into STR variable
;     GETKEY     - gets a character and encodes the scan code
;     to facilitate jmp tables
;     HIGHLIGHT  - reverse videos a portion of screen
;     PRINTLINE - different from print_string, this one
;     pads to right according to CX register
;     TPRINTLINE - prints data in the tree segment
;
;     SAY_ENTER_FILE - prompts for a file and gets it
;
bcolor equ  2
fcolor equ  3
mickey equ  16
public getkey,highlight,printline,say_enter_file
;
tseg    segment public 'DATA'
tseg    ends
dseg    segment public 'DATA'
extrn strg:byte,curx:word,cury:word,keyline:byte,comsi:word
extrn str_len:word,e_file:byte,vbuffer:word
extrn attribute:word,comline:byte,buffer:word
extrn macro1:byte,macro2:byte,macro3:byte,macro4:byte,macro5:byte
extrn macro6:byte,macro7:byte,macro8:byte,macro9:byte,macro0:byte
extrn helps:word,mouse_on:byte,fat_on:byte
extrn left_margin:word,view:word,cwidth:word
extrn lscale:byte,vid_wid:word,mode:byte
extrn egavga:byte
; local data
;
macro_line dw macro1,macro2,macro3,macro4,macro5,macro6
     dw macro7,macro8,macro9,macro0
xmick  dw 0
ymick  dw 0
mickflip db 0
scurx  dw 0
scury  dw 0
extrn  dircount:word
curdir dw 0
kbd_on db 0
mousex db 0 ; micky limiter
gs_sw  db 0
e_page_mess db 'Enter Page:     ',0
save_attrib  dw  0
splane  db  bcolor
public splane
ddcolor  db  0
;
dseg ends
CSEG2   SEGMENT PUBLIC 'TEXT'
     ASSUME CS:CSEG2
    extrn  help:far
cseg2  ends
CSEG    SEGMENT PUBLIC 'CODE'
     ASSUME CS:CSEG,DS:DSEG,ES:DSEG
extrn blop:near,do_char:near,do_help:near,reset_segs:near
extrn present:near,print_string:near
extrn quit:near,print_string:near
extrn fixplane1:near,fixplane2:near
public do_col_char

do_col_char2:
public do_col_char2
     mov  ddcolor,12
     cmp  egavga,1
     je   do_c2
   call do_char
     ret
do_col_char:
     mov  ddcolor,13
     cmp  egavga,1
     je   do_c2
   call do_char
     ret
do_c2:
     push  ax
     push  bx
        mov     bl,splane
        push    bx
     mov    bx,attribute
     push   bx
     mov    attribute,-2
        mov     splane,2
        call    setplane
        push    ax
        mov     al,219
   call do_char
        mov     splane,13
        call    setplane
        mov     al,20h
   call do_char
        mov     al,ddcolor
        mov     splane,al
     call   setplane
        pop     ax
     mov    attribute,-1
   call do_char
        call    resetplane
      pop   ax
      mov   splane,al
     pop    bx
     mov    attribute,bx
      pop   bx
     pop   ax
     ret
;
setplane:
        cmp     egavga,1
        je      sp_1
        ret
sp_1:
        push    ax
        push    cx
        push    dx
;
;        mov     ax,0ff08h ; bit mask index and all bits
;        mov     dx,3ceh
;        out     dx,ax   ; set bit mask so all bits are on
;        mov     al,byte ptr es:[di]
; select plane
        mov     dx,3c4h ; sequencer
        mov     al,2    ; map mask
        out     dx,al
        mov     dx,3c5h
        mov     al,splane ; planes 2 & 4
        out     dx,al   ; set map to current guy
        mov     al,byte ptr es:[di]

      pop   dx
      pop   cx
      pop   ax

     ret
resetplane:
        cmp     egavga,1
        je      sp_2
        ret
sp_2:
        push    ax
        push    cx
        push    dx
        mov     ax,0f02h  ; all planes
        mov     dx,3c4h
        out     dx,ax

      pop   dx
      pop   cx
      pop   ax

     ret
public resetplane,setplane
;
color_bar proc near
; cleans a line
; cx has the amount to block out in characters!
        cmp     egavga,1
        je      sp_3
        ret
sp_3:
        push    ax
        push    cx
        push    dx
        push    di
        push    bp
        push    es
        call    reset_segs
        mov     al,splane
        push    ax
        mov     splane,7
        call    setplane
        mov     bp,cx  ; number of characters to clean
     mov    ax,vid_wid
     mul    cury
     mov    di,ax
     mov    ax,curx
     shr    ax,1
     shr    ax,1
     shr    ax,1
     add    di,ax
        mov     es,vbuffer
        mov     cx,cwidth
        mov     al,-1
        cmp     bp,0
        jle     sp_4
col_loop0:
        push    cx
        push    di
        mov     cx,bp
        cld
rep     stosb
        pop     di
        add     di,vid_wid
        pop     cx
        loop    col_loop0
        call    resetplane
sp_4:
      pop   ax
      mov   splane,al
      pop   es
      pop   bp
      pop   di
      pop   dx
      pop   cx
      pop   ax

      ret
color_bar  endp

;
;
;  =186  =187  =188  =200  =201  =205
prbox:
public prbox
; this prints a box around text. It works by scanning the
; text looking for the longest line and prints a box around the
; text.
; it uses the print_string functions call, set set curx,cury
; and load up dx with the offset
;
   push  ax
   push  bx
   push  cx
   push  dx
   push  si
   push  di
   push  bp
   push  ds
   push  es
;
; this first section determines the length of the longest line
;
   mov  si,dx
   mov  bx,0    ; length of current line
   mov  bp,0    ; length of longest line
   cld
;
bp_loop:
   lodsb
   cmp  al,0     ; end of string
   je   bp_newline
   cmp  al,13    ; ignore 13's
   je   bp_loop
   cmp  al,10    ; line feed
   je   bp_newline
   cmp  al,'~'
   jne  inc_newline
   add   bx,32
inc_newline:
   inc   bx     ;  add 1 to length of current line
   jmp  bp_loop
bp_newline:
   cmp  bx,bp
   jl   bp_low
   mov  bp,bx
bp_low:
   cmp  al,0
   je   done_bp
   mov  bx,0
   jmp  bp_loop
done_bp:
; bp has the length of the longest string
;
; draw the bar across the top
   mov   ax,curx
   push  ax     ; save x position for later
;
   mov   al,''
;  call do_char
   call do_col_char
   add  curx,8
   mov  cx,bp
   inc  cx
   inc  cx    ; space before and after line
hloop1:
   push cx
   mov  al,''
;  call do_char
   call do_col_char
   add  curx,8
   pop  cx
   loop  hloop1
   mov  al,''
   call do_col_char
;  call  do_char
; done bar across top
;
   pop   ax
   mov  curx,ax
;
; set si back to where it belongs
   mov   si,dx
;
;
; incr line on screen
;
   mov   ax,cwidth
   call  fix_width
   add   cury,ax
;
lloop0:
; this loops through the lines
   mov   ax,curx
   push  ax     ; again save the current x position
;
   mov   al,''
   call do_col_char
;  call do_char
   add  curx,8
   mov   al,' '
;  call do_char
   call do_col_char
   add  curx,8
   mov  cx,bp    ; longest line
   inc  cx     ; space at end of line
lloop1:
   push  cx
   lodsb
   cmp   al,13
   je    lspace
   cmp   al,'~'
   je    lspace32
   je    lspace
   cmp   al,10
   je    endline
   cmp   al,0
   je    endline
;  call  do_char
   call do_col_char
   add  curx,8
   jmp   lspace
lspace32:
   mov   cx,32
l32:
   push  cx
   mov   al,' '
;  call  do_char
   call do_col_char
   add  curx,8
   pop   cx
   loop  l32
lspace:
   pop   cx
   loop  lloop1 ; loop is decrementing cx an jmping in one op
; can't get here (i hope)
    mov   ax,0
    push  ax
    jmp   el2
endline:
   pop   cx     ; still a cx in the stack
   push  ax     ; save al to see if its the last line
el1:
   push  cx
   mov   al,' '
   call do_col_char
;  call  do_char
   add  curx,8
   pop   cx
   loop  el1
;
el2:
   pop   ax    ; get back the al the ended this line
;
   cmp   al,0
   je    last_line
   mov   al,''
   call do_col_char
;  call do_char
   mov   ax,cwidth
   call  fix_width
   add   cury,ax
   pop   ax     ; saved curx
   mov   curx,ax
   jmp   lloop0
last_line:
   mov   al,''
;  call do_char
   call do_col_char
   mov   ax,cwidth
   call  fix_width
   add   cury,ax
;
   pop   ax     ; curx in stack
   mov   curx,ax
;
; do the bottom line
;
;  =186  =187  =188  =200  =201  =205
   mov   al,''
   call do_col_char
;  call do_char
   add  curx,8
   mov  cx,bp
   inc  cx
   inc  cx
hloop2:
   push cx
   mov  al,''
;  call do_char
   call do_col_char
   add  curx,8
   pop  cx
   loop  hloop2
   mov  al,''
   call do_col_char
;  call  do_char
;
;
   pop  es
   pop  ds
   pop  bp
   pop  di
   pop  si
   pop  dx
   pop  cx
   pop  bx
   pop  ax
   ret
fix_width:
; fixes amount in ax
   cmp   lscale,1
   jle   no_scale
   push  cx
   mov   cl,lscale
   dec   cl
   shl   ax,cl
   pop   cx
no_scale:
   ret
;
;
;
cleanstring:
; clean up the string area
     mov   cx,str_len
     lea   di,strg
     mov   si,di
     cld
     mov   bx,0
sclean:
     lodsb
     cmp   al,0
     je    sclean2
     cmp   al,' '
     je    sclean2
     inc   bx
     loop  sclean
sclean2:
     cmp   cx,0
     je   sclean3
     mov   al,0
     mov   di,si
rep     stosb
sclean3:
; now print it
     mov  ax,scurx
     mov  curx,ax
     mov  cx,str_len
     lea  si,strg
     push bx
     call printline
     pop  bx
     ret

gstring:
public gstring
; this gets a string, any string and exits on unnatural keys
; bx has the character before the starting character
;
     mov   mousex,0
     mov   ax,attribute
     push  ax
     mov   attribute,0
     mov   ax,curx
     mov   scurx,ax
     mov   ax,cury
     mov   scury,ax
     call  cleanstring
g_s_loop:
; this highlights a character
     mov  ax,scurx
     mov  dx,bx
     mov  cl,3
     shl  dx,cl
     add  ax,dx
     mov  curx,ax
     push  bx
     mov  cx,1     ;highlight one character at cur x,y
     call highlight
     mov  bp,0
     call getkey
     inc  mousex
; unhighlight the character
     pop  bx
     push  bx
     push  ax
     mov   al,strg[bx]
     mov  attribute,0
     call do_char
     pop   ax
     pop   bx
;
     cmp  ah,3bh
     jne  no_help
leave_str:
     mov  bx,ax
; attribute pushed at beginning
     pop  ax
     mov  attribute,ax
     mov  ax,bx
     ret
no_help:
     cmp  al,27
     je   leave_str
     cmp  al,13     ; carriage return
     je   leave_str
     cmp  ah,53h
     je   del_char
     jmp  no_delete
; this deletes the current character
del_char:
     lea  si,strg
     add  si,bx
     mov  di,si
     inc  si
     mov  cx,str_len
     sub  cx,bx
     cld
rep  movsb
; no reprint
     mov  ax,curx
     push ax
     mov  ax,scurx
     mov  curx,ax
     mov  cx,str_len
     lea  si,strg
     push bx
     call printline
     pop  bx
     pop  ax
     jmp  g_s_loop
no_delete:
     cmp  al,8     ; backspace
     je   got_bs
     cmp  ah,4bh
     je   got_left
     cmp  ah,4dh
     je   got_right
     jmp  check_updn
got_left:
     cmp  bp,'KG'
     jne  gl1
     cmp  mousex,8
     jl   no_char2
gl1:
     cmp  bx,0
     jle  no_char
     mov  mousex,0
     dec  bx
     jmp  g_s_loop
got_right:
     cmp  bp,'KG'
     jne  gr1
     cmp  mousex,8
     jl   no_char2
gr1:
     cmp  bx,str_len
     jge  no_char
     cmp  strg[bx],0
     je  no_char
     inc  bx
     mov  mousex,0
     jmp  g_s_loop
got_bs:
     cmp  bx,0     ; can't backspace at beginning
     jg   do_bs
no_char:
     call blop     ; say nono
no_char2:
     jmp  g_s_loop
do_bs:
; have a backspace
; back space is deleting a character just to the left of where we are
;
     dec  bx
     jmp  del_char
check_updn:
     cmp  ah,4fh
     je   do_end
     cmp  ah,47h
     je   do_home
     jmp  got_a_char
do_end:
     mov  bx,0
     lea  di,strg
     mov  al,0
     mov  cx,str_len
     cld
rep   stosb
     mov  ax,scurx
     mov  curx,ax
     mov  cx,str_len
     lea  si,strg
     call printline
     mov  bx,0
     jmp  g_s_loop
do_home:
     mov  bx,0
     jmp  g_s_loop
got_a_char:
     cmp  bx,str_len
     jge  no_char
     push bx
     push ax
; good char in al - print it
     call do_char
     pop  ax
     pop  bx
     mov  strg[bx],al
     add  curx,8
     inc  bx
     jmp  g_s_loop
no_char3:
     jmp  no_char2

getkeynm:
public getkeynm
; this will get a key with no_mouse
     mov   bp,0
     mov   kbd_on,2
     call  getkey
     mov   kbd_on,0
     ret
getmouse:
public getmouse
; this gets a mouse stroke only (no keys)
    mov   kbd_on,1
    mov   bp,0
    call  getkey
    mov   kbd_on,0
    ret
getkey:
; this routine will get a keystroke from a mouse or a key
;
; gets a key and returns one of standard results in bx
; keys are:
;     1 = esc
;     28 = return
;     75 = left
;     77 = right
;     71 = home
;     72 = up
;     79 = end
;     80 = down
;     73 = pageup
;     81 = pgdn
;     53 = /
;     59 = F1
;     60 = F2
;     52 = period
     push cx
check_key_out:
     call   reset_segs
     call   get_a_keystroke
     push   cx
     mov    cl,ah
     mov    ch,0
     cmp    cx,78h
     pop    cx
     jl     not_func
     push   cx
     mov    cl,ah
     mov    ch,0
     cmp    cx,81h
     pop    cx
     jg     not_func
; alt-number has been pressed
     call   reset_segs
     mov    bl,ah
     mov    bh,0
     sub    bx,78h
     shl    bx,1
     mov    si,macro_line[bx]
     cmp    byte ptr ds:[si],0
     je     check_key_out
     mov    comsi,si
     jmp    check_key_out
not_func:
     cmp    ax,2200h
     jne    no22h
; grid is pressed
extrn  do_grid:near
     call   do_grid
     jmp    check_key_out
no22h:
     cmp    ax,2100h
     jne    no21h
; fat  is pressed
     xor    fat_on,1
     call   present
     jmp    check_key_out
no21h:
     cmp    ax,2f00h
     jne    no2fh
; zoom is pressed
     shl    view,1
     cmp    view,4
     jle    ok2f
     mov    view,1
     jmp    no2fh
ok2f:
     call   present
     jmp    check_key_out
no2fh:
     cmp    ax,3000h
     jne    no2bh
; zoom is pressed
     shr    view,1
     cmp    view,0
     jg     ok_view
     mov    view,4
     jmp    no2bh
ok_view:
     call   present
     jmp    check_key_out
no2bh:
in_control:
     mov    bx,0
     mov    cx,29
     lea    si,keyline
     push   ax
gk_loop:
     lodsb
     cmp    ah,al
     je     gkloop_exit
     inc    bx
     loop   gk_loop
gkloop_exit:
     pop    ax
     shl    bx,1
;
     pop cx
     ret
say_enter_page:
public say_enter_page
     call  reset_segs 
     mov  curx,0
     mov  cury,15
     mov  cx,78
     lea  dx,e_page_mess
     call prbox
     mov  curx,112
     mov  cury,15
     mov   ax,cwidth
     add   cury,ax
     mov  str_len,4
     mov  strg,'1'
     mov  word ptr strg+1,0
     call gstring
     cmp  ah,3bh
     jne  exit_say_spec
     mov  helps,3
     call help
     jmp  say_enter_page
exit_say_spec:
     ret

say_enter_file:
extrn list_files:near
     jmp  list_files

highlight:
; this has cx for length to highlight
; curx and cury have the current location
     and    curx,1111111111111000b
     push  ax
     push cx
     push  dx
     mov   ax,attribute
     push  ax
     mov  dx,curx
     push dx
     mov  attribute,-1
     call resetplane
     call fixplane1
hl_loop:
     push cx
     mov  al,219     ; the block character
;    mov  al,20h ; space
     call do_char
     pop  cx
     add  curx,8
     loop hl_loop
     pop  dx
     mov  curx,dx
     call fixplane2
     call resetplane
     pop  ax
     mov  attribute,ax
     pop  dx
     pop  cx
     pop  ax
     ret

printline:
; prints a line pointed to by si
; length of line in cx
; terminates in 0
; start position is curx,cury
     push   cx
     and    curx,1111111111111000b
     mov    ax,attribute
     mov    save_attrib,ax
     mov    attribute,0
     cmp    egavga,1
     je     is_color
     jmp    pl_loop0
is_color:
     call   color_bar
     mov    attribute,7
     call   setplane
pl_loop0:
    pop   cx
pl_loop:
     push  cx
     cld
     mov  ah,0
     mov  al,byte ptr es:[si]
     inc  si
     cmp  al,0
     je   exit_pl
     call do_char
     pop  cx
     add  curx,8
     loop pl_loop
     call  resetplane
     mov   ax,save_attrib
     mov   attribute,ax
     ret
exit_pl:
     pop  cx
e_pl_loop:
     push cx
     mov  ah,0
     mov  al,' '
     call do_char
     add  curx,8
     pop  cx
     loop e_pl_loop
     mov   ax,save_attrib
     mov   attribute,ax
     call  resetplane
     ret

;
tprintline:
public tprintline
; this is the exact same except that the tseg is printed
; prints a line pointed to by si
; length of line in cx
; terminates in 0
; start position is curx,cury
     call  reset_segs
     and    curx,1111111111111000b
     mov    ax,attribute
     mov    save_attrib,ax
     cmp    egavga,1
     je     tis_color
     jmp    pl_loopt
tis_color:
     call   color_bar
     mov    attribute,7
     call   setplane
pl_loopt:
     push  cx
     cld
     push  ds
     mov   ax,tseg
     mov   ds,ax
     lodsb
     pop   ds
     cmp  al,0
     je   exit_pl
     call do_char
     pop  cx
     add  curx,8
     loop pl_loopt
     call  resetplane
     mov   ax,save_attrib
     mov   attribute,ax
     ret

;
;  GET_A_KEYSTROKE
;
get_a_keystroke:
; returns keystroke in ax, returns a multiplier in dx for tympanic
     push   cx
; check each device in turn, priority of devices is keyboard,2,3 and
; last the macros. Keeps you from getting hung in macros.
;
check_dev1:
     cmp    kbd_on,0
     je     check_dev10
     cmp    kbd_on,2
     je     check_dev10
     jmp    check_dev2     ; mouse only check
check_dev10:
     mov    dx,1
     mov    ah,1
     int    16h
     jnz  check_dev1x
; check the macros
     call  reset_segs
     cmp   kbd_on,2
     jne   check_dev2
     mov   bp,'KG'
     cmp   comsi,0
     jne   check_dev11
     pop   cx
     ret
check_dev11:
     jmp   check_dev4
check_dev1x:
; got a keystroke
     mov    bp,0
     mov    ah,0
     int    16h
     cmp    al,27
     jne    no_esc_yet
     cmp    comsi,0
     je     no_esc_yet
     mov    comsi,0
     call   quit
no_esc_yet:
     cmp    ax,1000h
     jne    no_qq
extrn  exit_prog:near
     jmp    exit_prog
no_qq:
     mov    cx,ax
     cmp    ah,71     ; cursor controls - check for shift
     jl     done_check
     cmp    ah,82
     jg     done_check
done_check1a:
     mov    ah,1
     int    16h     ; is there a keystroke stacked up?
     jz   done_check2
     cmp    ax,cx     ; is it same as last keystroke?
     jne    done_check2
     mov   dx,2     ; dx has the multiplier for fast keys
     mov    ah,0
     int    16h
     mov    cx,ax
     jmp    done_check1a
done_check2:
     mov   ax,cx
done_check:
     push   ax
     mov    ah,2
     int    16h
     and    al,0fh
     mov    dh,al
     pop    ax
; dh, has the shift status
; dl has the number of times we pressed a key
     pop    cx
     mov   bp,0
     ret
check_dev2:
; check mouse
     cmp   kbd_on,0
     je    check_dev20
     cmp   kbd_on,1      ; no kbd
     je    check_dev20
; kbd_on = 2 means nomouse
     cmp   comsi,0
     jne   check_dev3j
     mov   bp,'KG'      ; mouse found
     pop   cx
     ret
check_dev3j: jmp check_dev3

check_dev20:
     mov   bp,0
     cmp   mouse_on,1
     je    check_mouse
     jmp   check_dev3
mouse_esc:
     mov   ah,01h
     mov   al,1bh
     mov   dx,0
     pop   cx
     ret
mouse_ret:
     mov   ah,1ch
     mov   al,0dh
     mov   dx,0
     pop   cx
     ret
mouse_slash:
     mov   ah,35h
     mov   al,'/'
     mov   dx,0
     pop   cx
     ret
check_mouse:
; have a mouse check for a left click
     mov    ax,5
     mov    bx,0
     int    33h
     cmp    bx,0
     jg     mouse_ret
; middle click = esc
     mov    ax,5
     mov    bx,2
     int    33h
     cmp    bx,0
     jg     mouse_esc
     mov    ax,5
     mov    bx,1
     int    33h
     cmp    bx,0
     jg     mouse_slash
; check here for other mickey mouse stuff
     mov    ax,11
     int    33h
; new mouse stuff
     add    xmick,cx
     add    ymick,dx
     cmp    xmick,10*mickey
     jl     xm1
     mov   xmick,10*mickey
     jmp   ym0
xm1:
     cmp    xmick,-10*mickey
     jg    ym0
     mov   xmick,-10*mickey
ym0:
     cmp    ymick,10*mickey
     jl     ym1
     mov   ymick,10*mickey
     jmp   zm0
ym1:
     cmp    ymick,-10*mickey
     jg    zm0
     mov   ymick,-10*mickey
zm0:
     xor    mickflip,1
     cmp    mickflip,1
     je     mick_2
     cmp    xmick,mickey
     jg     do_mright
     cmp    xmick,-mickey
     jl     do_mleft
     cmp    ymick,-mickey
     jl     do_mup
     cmp    ymick,mickey
     jg     do_mdown
mick_1:
     mov    ax,0
     mov    dx,300h
     mov    bp,'KG'     ; no key struck from mouse
     jmp    check_dev3
mick_2:
     cmp    ymick,-mickey
     jl     do_mup
     cmp    ymick,mickey
     jg     do_mdown
     cmp    xmick,mickey
     jg     do_mright
     cmp    xmick,-mickey
     jl     do_mleft
     jmp    mick_1
;
do_mleft:
     mov    dx,1
     add    xmick,mickey
     cmp    xmick,-2*mickey
     jg     do_mleft2
     mov    dx,2
     add    xmick,2*mickey
do_mleft2:
     mov    ax,4b00h
     pop    cx
     ret
do_mright:
     mov    dx,1
     sub    xmick,mickey
     cmp    xmick,2*mickey
     jl     do_mright2
     mov    dx,2
     sub    xmick,2*mickey
do_mright2:
     mov    ax,4d00h
     pop    cx
     ret
do_mup:
     mov    dx,1
     add    ymick,mickey
     cmp    ymick,-2*mickey
     jg     do_mup2
     mov    dx,2
     add    ymick,2*mickey
do_mup2:
     mov    ax,4800h
     pop    cx
     ret
do_mdown:
     mov    dx,1
     sub    ymick,mickey
     cmp    ymick,2*mickey
     jl     do_mdown2
     mov    dx,2
     sub    ymick,2*mickey
do_mdown2:
     mov    ax,5000h
     pop    cx
     ret
;
check_dev3:
; check joystick
check_dev4:
     call  reset_segs
; check the macros - comsi is the current location in a macro
     cmp   kbd_on,1   ; if its a no kbd then return
     jne   do_com
     pop   cx
     ret
do_com:
     cmp   comsi,0
     jne   got_com_line
     jmp   no_com_line
got_com_line:
     mov   si,comsi
     cld
     lodsb
     cmp   al,0
     jne   got_a_c_byte
     mov   comsi,0
     mov    ax,0
     jmp   no_com_line
got_a_c_byte:
     mov   comsi,si
     mov   ah,0
     mov   dx,0
     mov   bp,0
     cmp   al,'~'
     jne   got_a_c_ret
     mov   al,13
     mov   ah,28
     pop   cx
     ret
got_a_c_ret:
     cmp    al,'!'
     jne    no_endfake
     mov    ax,4f00h
     pop   cx
     ret
no_endfake:
     cmp    al,'@'
     jne    no_homfake
     mov    ax,4700h
     pop   cx
     ret
no_homfake:
     cmp    al,'*'
     jne    no_restart
     lea    si,comline
     mov    comsi,si
     jmp    check_dev1
no_restart:
     cmp   al,'^'
     jne   got_a_esc
     mov   ax,011bh
     pop   cx
     ret
got_a_esc:
     cmp   al,'?'
     jne   got_a_wait
wait_e:
     call  wait10
     cmp   al,27
     je    hit_esc
     cmp   al,0
     je    wait_e
     jmp    check_dev1
hit_esc:
     mov    comsi,0
     call   quit
got_a_wait:
     cmp   al,'$'
     jne   got_a_perc
     call  wait10
     cmp   al,27
     jne    by_a_perc
     mov    comsi,0
     call   quit
by_a_perc:
     jmp    check_dev1
got_a_perc:
     cmp   al,2fh
     jne   no_l_slash
     mov   ah,35h
     pop   cx
     ret
no_l_slash:
     cmp   al,'+'
     jne   no_plus
     mov   ah,48h
     pop   cx
     ret
no_plus:
     cmp   al,'-'
     jne   no_minus
     mov   ah,50h
     pop   cx
     ret
no_minus:
     cmp   al,'('
     jne   no_leftp
     mov   ah,4bh
     pop   cx
     ret
no_leftp:
     cmp   al,')'
     jne   no_rightp
     mov   ah,4dh
     pop   cx
     ret
no_rightp:
     cmp   al,';'
     jne   no_semi
; semicolon means another macro
; still points to comsi
     mov   si,comsi
     lodsb
     cmp   al,0
     je    end_semi
     inc   comsi
     mov   ah,0
     mov   dx,0
     mov   bp,0
     cmp   al,30h
     jl    end_semi
     cmp   al,39h
     jg    end_semi
     mov    bl,al
     mov    bh,0
     sub    bx,31h
     cmp    bx,0
     jge    semi_1
     mov    bx,10
semi_1:
     shl    bx,1
     mov    si,macro_line[bx]
     cmp    byte ptr ds:[si],0
     je     end_semi
     mov    comsi,si
     jmp   no_com_line
end_semi:
     mov   comsi,0
     jmp   no_com_line
no_semi:
     mov   ah,0
     pop   cx
     mov   bp,0
     ret
no_com_line:
     jmp    check_dev1
flush_mouse:
public flush_mouse
; this flushes out the mouse movement by doing several checks
     push  ds
     push  es
     call  reset_segs
     mov   xmick,0
     mov   ymick,0
     cmp  mouse_on,1
     pop   es
     pop   ds
     jne  fm_1
     mov    bx,0
     mov    cx,0
     mov    dx,0
     mov    ax,11
     int    33h
     cmp   cx,0
     jne   flush_mouse
     cmp   dx,0
     jne   flush_mouse
fm_1:
     ret

wait10:
; this procedure waits for n  seconds, checking keystrokes
; get entry time:
     mov   ax,2c00h
     int   21h
   ; time comes back in cl in ticks
     add   dh,2  ; about 2 seconds
     cmp   dh,59
     jle   ok_dh1
     sub   dh,60
ok_dh1:
     mov   bx,dx
wait_keystroke:
     mov    dx,1
     mov    ah,1
     int    16h
     jz   check_time
     mov    ah,0
     int    16h
     ret
check_time:
     mov    ax,2c00h
     int    21h
     cmp    bh,dh
     jne    wait_keystroke
     mov    ax,0
     ret

CSEG    ENDS
     END
