; OKSCAN has the IX12, Princeton and JLASER routines in it
include f:fmacros.asm
DSEG	SEGMENT PUBLIC 'DATA'
assume cs:cseg,ds:dseg,es:dseg
extrn left_margin:word,curx:word,cury:word,buffer:word,pass:word
extrn width_bytes:word,height_pix:word,vwid:word,scol:word,srow:word
extrn lcol:word,lrow:word,maxlines:word,strg:byte,spoint:word,lpoint:word
extrn work_seg:word,work2_seg:word,cwidth:word,str_len:word
extrn planes:word
;
;
pmaxm   db     " Pmax > ____________ ",0
pminm   db     " Pmax > ____________ ",0
qmaxm   db     " Pmax > ____________ ",0
qminm   db     " Pmax > ____________ ",0
iterm   db     " Iter > ____________ ",0
modum   db     " Modl > ____________ ",0
err7	db	"You must specify a range before",10
	db	"  you can start calculations",10
	db	"   PRESS ANY KEY TO CONTINUE",0
err1	db	"You must specify Pmax, Pmin, Qmax",10
	db	"    Qmin, Iter, and Modulus",10
	db	"   PRESS ANY KEY TO CONTINUE",0
sx  dw 0
sy  dw 0
lx  dw 0
ly  dw 0
pmax float <1,0,0,0,0>
pmin float <1,0,0,0,0>
qmax float <1,0,0,0,0>
qmin float <1,0,0,0,0>
lm    float <1,0,0,0,0>
loopmax equ lm.fhigh
tp    float <1,0,0,0,0>
turnp   equ tp.fhigh
deltap float <1,0,0,0,0>
deltaq float <1,0,0,0,0>
p     float <1,0,0,0,0>
q     float <1,0,0,0,0>
xlast float <1,0,0,0,0>
ylast float <1,0,0,0,0>
modulus float <1,0,0,0,0>
zero  float <1,0,0,0,0>
xcur  float <1,0,0,0,0>
ycur  float <1,0,0,0,0>
one   float <1,0,0100h,0,0>
tmp1  float <1,0,0,0,0>
tmp2  float <1,0,0,0,0>
tmp3  float <1,0,0,0,0>
tmp4  float <1,0,0,0,0>
color  dw 0
color1 dw 0
color2 dw 0
window_wid  dw 640
window_len  dw 350
xloc   dw  0
yloc   dw  0
dither dw 0
public dither
;
;
;
DSEG ENDS
;
;
CSEG SEGMENT PUBLIC 'CODE'
assume cs:cseg,ds:dseg,es:dseg
extrn prbox:near,blip:near,blop:near,present:near,goback:near
extrn getkey:near,flush_buffer:near,do_wait:near
extrn reset_segs:near,first_range:near,set_range:near
extrn fill_buffer:near,calc_file_size:near,get_curr_seg:near
extrn get_curr2_seg:near
extrn cc_setup:near,gstring:near
ddswitch db 0
public ddswitch

;
set_mzoom:
 public set_mzoom
	call	set_range
	cmp	al,27
	jne	ok_mrange
	call	present
	ret
ok_mrange:
; srow,scol,lrow,lcol have the current range
; sx,sy,lx,ly have the previously defined range
; we need to use this information to calculate the new pmax, etc.
;
;  make sure that the upper left is srow, scol
	mov	ax,srow
	mov	bx,lrow
        cmp     ax,bx
        jl      mr_1
        mov     srow,bx
        mov     lrow,ax
mr_1:
	mov	ax,scol
	mov	bx,lcol
        cmp     ax,bx
        jl      mr_2
        mov     scol,bx
        mov     lcol,ax
        mov     ax,spoint
        mov     bx,lpoint
        mov     lpoint,ax
        mov     spoint,bx
mr_2:
; ok now calculate the new pmin which is the scol info
        call    set_start  ; calculates the deltap
        movv    zero,tmp1
        mov     ax,scol
        shl     ax,1
        shl     ax,1
        shl     ax,1
        add     ax,spoint
        mov     bx,sx
        shl     bx,1
        shl     bx,1
        shl     bx,1
        sub     ax,bx
;  ax has the amount to move to right of sx
        cmp     ax,0
        jge      mr_3
        neg     ax
        mov     tmp1.fsign,-1
mr_3:
        mov     tmp1.fhigh,ax
        mull    tmp1,deltap,tmp2
        addd    tmp2,pmin,tmp3
        movv    tmp3,pmin
;
;
        movv    zero,tmp1
        mov     ax,lcol
        shl     ax,1
        shl     ax,1
        shl     ax,1
        add     ax,lpoint
        mov     bx,lx
        shl     bx,1
        shl     bx,1
        shl     bx,1
        sub     ax,bx
;  ax has the amount to move to right of sx
        cmp     ax,0
        jge      mr_4
        neg     ax
        mov     tmp1.fsign,-1
mr_4:
        mov     tmp1.fhigh,ax
        mull    tmp1,deltap,tmp2
        addd    tmp2,pmax,tmp3
        movv    tmp3,pmax
;
        movv    zero,tmp1
        mov     ax,srow
        sub     ax,sy
;  ax has the amount to move down for sy
        cmp     ax,0
        jge      mr_5
        neg     ax
        mov     tmp1.fsign,-1
mr_5:
        mov     dx,0
        div     planes
        mov     tmp1.fhigh,ax
        mull    tmp1,deltaq,tmp2
        addd    tmp2,qmax,tmp3
        movv    tmp3,qmax
;
        movv    zero,tmp1
        mov     ax,lrow
        sub     ax,ly
;  ax has the amount to move down for sy
        cmp     ax,0
        jge      mr_6
        neg     ax
        mov     tmp1.fsign,-1
mr_6:
        mov     dx,0
        div     planes
        mov     tmp1.fhigh,ax
        mull    tmp1,deltaq,tmp2
        addd    tmp2,qmin,tmp3
        movv    tmp3,qmin
	call	present
	ret
;
;
store_proc:
    mov    al,ah
; dithering would be done here or planes would be checked
    stosb
    ret
dither4:
; 4 shift
      shr    al,1
dither3:
      shr    al,1
dither2:
      shr    al,1
dither1:
      shr    al,1
dither0:
      ret
shift_proc  dw  dither0,dither1,dither2,dither3,dither4
separate:
; this separates out the color bytes to the 4 color planes
      mov    bx,dither ; still shift dots
      mov    bp,width_bytes ; this will add in to get the bytes right
      push   ds
      push   es
      mov    ax,buffer
      mov    ds,ax
      mov    es,ax
      mov    si,4000h
      mov    di,0
      sub    cx,si
      shr    cx,1
      shr    cx,1
      shr    cx,1
sp_1:
      push   cx
      mov    cx,8
sp_2:
      push   di
      lodsb
      call   cs:shift_proc[bx]
      shr    al,1
      rcl    byte ptr ds:[di],1
      add    di,bp
      shr    al,1
      rcl    byte ptr ds:[di],1
      add    di,bp
      shr    al,1
      rcl    byte ptr ds:[di],1
      add    di,bp
      shr    al,1
      rcl    byte ptr ds:[di],1
      pop    di
      loop   sp_2
      inc    di
      pop    cx
      loop   sp_1
      pop    ds
      pop    es
      mov    cx,di
      shl    cx,1
      shl    cx,1
      call   flush_buffer
      ret
do_dither:
; if we are in color mode we have to separate colors
      cmp   planes,1
      je    dd_0
      jmp   separate
dd_0:
; this dithers the results to buffer
      push   ds
      push   es
      mov    ax,buffer
      mov    ds,ax
      mov    es,ax
      mov    si,4000h
      mov    di,0
      sub    cx,si
      shr    cx,1
      shr    cx,1
      shr    cx,1
      mov    dx,0  ; running total for dither
dd_1:
      push   cx
      push   bx
      mov    cx,8
dd_2:
      lodsb
      call   cs:shift_proc[bx]
      cmp    cs:ddswitch,0
      je    do_store
      and   al,15          ; this is dither stuff
      add   dl,al          ;
      mov   al,0           ;
      cmp   dl,15          ;
      jle   do_store       ;
      mov   al,15          ;
      sub   dl,16          ;
do_store:
      shr    al,1
      rcl    ah,1
      loop   dd_2
      call   store_proc
      pop    bx
      pop    cx
      loop   dd_1
      pop    ds
      pop    es
      mov    cx,di
      call   flush_buffer
      ret
;
set_mnrange:
 public set_mnrange
	call	set_range
	cmp	al,27
	jne	ok_srange
bad_mnrange:
        call    blop
        call    blop
        call    blop
	call	present
	ret
ok_srange:
	mov	ax,srow
        mov     bx,lrow
        cmp     ax,bx
        je      bad_mnrange
        jl      sr1
        xchg    ax,bx
sr1:
	mov	sy,ax
        mov     ly,bx
	mov	ax,scol
	mov	bx,lcol
        cmp     ax,bx
        je      bad_mnrange
        jl      sr2
        xchg    ax,bx
sr2:
	mov	sx,ax
	mov	lx,bx
; calculate window width
        mov    ax,lx
        sub    ax,sx
        shl    ax,1
        shl    ax,1
        shl    ax,1
        mov    window_wid,ax
        mov    ax,ly
        sub    ax,sy
; ax has the width of a window, it must be adusted for planes
        mov    dx,0
        div    planes
        mov    window_len,ax
	call	present
	ret
;
;
;
;
;
setup_mand:
; begin the mand
; first set the mand mode and check to see if the mandel is there
;
;
	call	reset_segs
	mov	ax,sy
	mov	srow,ax
	mov	ax,sx
	mov	scol,ax
	mov	ax,lx
	mov	lcol,ax
	mov	ax,ly
	mov	lrow,ax
;
;
;
	mov	ax,sx
	cmp	ax,lx
	jne	good_range
bad_range:
	lea	dx,err7
	jmp	errorp
good_range:
	mov	ax,lx
	mov	ax,sy
	cmp	ax,ly
	je	bad_range
; check the pmax etc
	lea	si,pmax
	mov	cx,6
c_pmax:
	cmp	word ptr ds:[si].fhigh,0
	jne	c_pmaxe
	cmp	word ptr ds:[si].fdech,0
	jne	c_pmaxe
	cmp	word ptr ds:[si].fdecl,0
	jne	c_pmaxe
	jmp	bad_pmax
c_pmaxe:
	add	si,9
	loop c_pmax
	jmp	g_pmax
bad_pmax:
	lea	dx,err1
	jmp	errorp
g_pmax:
	call	calc_file_size
	call	cc_setup
	ret
;
;
;
;
;
do_mandel:
public do_mandel
begin_mand:
	call	reset_segs
	call	setup_mand
; now we have to set up a loop to read the data
;
	call	do_wait
	mov	pass,0
; mand loop
	call	set_start
;
;
	movv qmax,q
	mov	yloc,0
	mov	cx,height_pix
	mov	xloc,0
mand_loop:
	push	cx
	mov	di,4000h
	call	mandel_line
;
	mov	cx,di
        call    do_dither
	jc 	end_mand
;
	inc	yloc
	call	setq
;
	pop	cx
	loop	mand_loop
        push    cx
end_mand:
        pop     cx
	call	present
	call	goback
;
;	mandel input routine
;
cinput:
	ret
;
;
errorp:
;
;
	mov	left_margin,64
	mov	curx,64
	mov	cury,48
	call	prbox
	call	getkey
	call	blip
	call	present
	mov	left_margin,0
	call	goback
	ret
;
;
pmess	proc near
; print the message
	mov	left_margin,64
	mov	curx,64
	mov	cury,48
;	lea	dx,line1
	call	prbox
	call	getkey
	call	blip
	call	present
	mov	left_margin,0
	call	goback
	ret
pmess	endp
set_pmax:
public set_pmax
	lea	dx,pmaxm
	lea	di,pmax
	call finput
	ret
set_pmin:
public set_pmin
	lea	dx,pminm
	lea	di,pmin
	call finput
	ret
;
;
set_qmax:
public set_qmax
	lea	dx,qmaxm
	lea	di,qmax
	call finput
	ret
set_qmin:
public set_qmin
	lea	dx,qminm
	lea	di,qmin
	call finput
	ret
set_iter:
public set_iter
	lea	dx,iterm
	lea	di,lm
	call finput
	ret
set_modulus:
public set_modulus
	lea	dx,modum
	lea	di,tp
	call finput
	ret
;
;
;
;
finput:
; this reads the guy in, dx points to message and di points to where
	call	reset_segs
	mov	strg,0
	push	di
	mov	left_margin,64
	mov	curx,64
	mov	cury,48
	call	prbox
	mov	left_margin,144
	mov	curx,144
	mov	ax,48
	add	ax,cwidth
	mov	cury,ax
	lea	si,strg
	mov	cx,12
	mov	str_len,12
	call gstring
	pop	di
	cmp	al,27
	jne	do_fix
        call    present
	stc
	ret
do_fix:
	lea	si,strg
; up to decimal point
	mov	ds:[di].fsign,1
	mov	ds:[di].fexp,0
	mov	ds:[di].fhigh,0
	mov	ds:[di].fdecl,0
	mov	ds:[di].fdech,0
	cld
	mov	bp,0
	mov	bx,0
f1:
	lodsb
	cmp	al,20h
	je	f1
	cmp	al,'-'
	je	f2
	cmp	al,'+'
	je	f3
	cmp	al,'.'
	je	f4
	cmp	al,30h
	jl	f9
	cmp	al,39h
	jg	f9
	and	al,15
	mov	ah,0
	xchg ax,bx
	mov	cl,10
	mul	cl
	add	bx,ax
	adc	dx,0
	jmp	f1
f2:
	mov	ds:[di].fsign,-1
	jmp	f1
f3:
	mov	ds:[di].fsign,1
	jmp	f1
f4:
; decimal point
	mov	ds:[di].fhigh,bx
	jmp	ff0
f9:
;
	mov	ds:[di].fhigh,bx
	jmp	ff9
multp:
; bp,bx keep the current floater
; (a + b)*c = a*c + b*c
	and	al,15
	mov	ah,0
	push ax
	push bp
	mov	cx,10
; mult bx first as in integer
	mov	ax,bx
	mul	cx
	mov	bx,ax
	mov	bp,dx
	pop	ax	; used to be bp
	mul	cx
	add	bp,ax
	pop	ax	; our incoming guy
	add	bx,ax
	adc	bp,0
	ret
ff0:
; have the decimal point
	mov	ax,0
	mov	dx,0
	mov	bx,0
	mov	bp,0
	mov	cx,8
ff1:
	push	cx
	lodsb
	cmp	al,30h
	jl	ff3
	cmp	al,39h
	jg	ff3
	call multp
	pop	cx
	loop ff1
	jmp	ff4
ff2:
	push cx
ff3:
	mov	ax,0
	call multp
	pop	cx
	loop ff2
ff4:
; bp:bx has the number
;
;
; number has to be div by 100,000,000
; has to be mul by 1,00,00,00,00
;
	push	bp	; high order
	push	bx
	mov	ax,bx
	mov	dx,0
	mov	bx,0
	mov	bp,0
	mov	cx,10000
; dx:ax is the bottom 8 bits of number
	mov	dx,ax	; mul 1,00,00
	mov	ax,0
	mov	dh,0
	idiv	cx
	push	dx	; never div, mul 2
	; ax is div 1 mul 2
	mov	dh,0
	mov	dl,ah
	mov	ah,al
	mov	al,0	; mul 3
	idiv	cx
	push	dx ; div 1 mul 3
	mov	dh,0
	mov	dl,ah
	mov	ah,al
	mov	al,0	; mul 4
	add	bx,ax
	adc	bp,dx	; done here
	pop	dx	; div 1 mul 3
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 4
	idiv cx
	adc	bx,ax
	adc	bp,0	; discard remainder
	pop	dx	; never div mul 2
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 3
	idiv cx
	push dx	; 0 div mul 3
	mov	dh,0
	mov	dl,ah
	mov	ah,al
	mov	al,0	; mul 4 div 1
	idiv cx
	add	bx,ax ; ax is div2 mul 4
	adc	bp,0
	pop	dx	; 0 div 3 mul
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 4
	idiv cx
	add	bx,ax	; throw out dx
;
;
	pop	ax
	pop	dx
	mov	al,ah
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul -1
; dx:ax is mul 1 div 0
	idiv	cx
	push	dx	; div 0 mul -1
	mov	dh,0
	mov	dl,ah
	mov	ah,al
	mov	al,0	; mul 0
	idiv cx	;
	; ax is div 2 mul 0 ; discard
	add	ax,7fffh
	adc	bx,0
	adc	bp,0
	; dx has div 1 mul 0
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 1 div 1
	idiv	cx
	push	dx	; div 1 mul 1
	mov	dh,0
	mov	dl,ah
	mov	ah,al
	mov	al,0	; mul 2 div 2
	add	bp,ax ; mult quick 2 more
	pop	dx	; div 1 mul 1
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 2
	idiv cx
	add	bp,ax	; div 2 mul 2 quick mult
	; dx has mul 2 div 1
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 3
	idiv	cx
	push	dx	; div 1 mul 3
	; ax is div 2 mul 3
	mov	dh,0
	mov	dl,ah
	mov	ah,al
	mov	al,0	; mul 4
	add	bx,ax
	adc	bp,dx
	pop	dx	; div 1 mul 3
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 4
	idiv	cx
	; ax is div 2 mul 4	; dx is mul 4 div 1, discard?
	add	bx,ax
	adc	bp,0
;	mov	al,0
;	mov	ah,dl
;	mov	dl,dh
;	mov	dh,0	; mul 5
;	idiv	cx
;	; ax is mul 5 div 2
;	add	ax,7fh
;	mov	al,ah
;	mov	ah,0	;mult -1
;	add	bx,ax
;	adc	bp,0
	pop	dx	; div 0 mul -1
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 0
	idiv	cx
	push	dx	; never div mul 0
	; ax is div 1 mul 0
	mov	dh,0
	mov	dl,ah
	mov	ah,al
	mov	al,0	; mul 1
	idiv cx
	push	dx	; div 1 mul 1
	; ax is div 2 mul 1
	mov	dh,0
	mov	dl,ah
	mov	ah,al
	mov	al,0	; mul 2
	add	bp,ax
	pop	dx	; div 1 mul 1
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 2
	idiv cx
	add	bp,ax	; div 2 mul 2 quick mult
	; dx has mul 2 div 1
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 3
	idiv	cx
	push	dx	; div 1 mul 3
	; ax is div 2 mul 3
	mov	dh,0
	mov	dl,ah
	mov	ah,al
	mov	al,0	; mul 4
	add	bx,ax
	adc	bp,dx
	pop	dx	; div 1 mul 3
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 4
	idiv	cx
	; ax is div 2 mul 4	; dx is mul 4 div 1, discard?
	add	bx,ax
	adc	bp,0
;	mov	al,0
;	mov	ah,dl
;	mov	dl,dh
;	mov	dh,0	; mul 5
;	idiv	cx
;	; ax is mul 5 div 2
;	add	ax,7fh
;	mov	al,ah
;	mov	ah,0	;mult -1
;	add	bx,ax
;	adc	bp,0
;
	pop	dx	; never div mul 0
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 1
	idiv cx
	push dx	; div 0 mul 1
	; ax is div 1 mul 1
	mov	dx,ax; div 1 mul 1
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 2
	idiv cx
	add	bp,ax
	; dx has mul 2 div 1
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 3
	idiv	cx
	push	dx
	; ax is div 2 mul 3
	mov	dh,0
	mov	dl,ah
	mov	ah,al
	mov	al,0	; mul 4
	add	bx,ax
	adc	bp,dx
	pop	dx	; div 1 mul 3
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 4
	idiv	cx
	; ax is div 2 mul 4
	add	bx,ax
	adc	bp,0
	pop	dx	; div 0 mul 1
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 2
	idiv	cx
	push	dx	; div 0 mul 2
	; ax is div 1 mul 2
	mov	dx,ax
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 3
	idiv	cx
	push	dx	;div 1 mul 3
	; ax is div 2 mul 3
	mov	dh,0
	mov	dl,ah
	mov	ah,al
	mov	al,0	; mul 4
	add	bx,ax
	adc	bp,dx
	pop	dx	; div 1 mul 3
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 4
	idiv	cx
	; ax is div 2 mul 4
	add	bx,ax
	adc	bp,0
	pop	dx	; div 0 mul 2
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 3
	idiv	cx
	push	dx	; div 0 mul 3
	mov	dx,ax
	; dx is mul 3 div 1
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 4
	idiv	cx
	; ax is div 2 mul 4
	add	bx,ax
	adc	bp,0
	pop	dx	; div 0 mul 3
	mov	al,0
	mov	ah,dl
	mov	dl,dh
	mov	dh,0	; mul 4
	idiv	cx
	add	bx,ax
	adc	bp,0
;
	mov	ds:[di].fdech,bp
	mov	ds:[di].fdecl,bx
;
;
ff9:
; go home
        call    present
	ret
;
;
;
;
mandels:
;	Xlast = Ylast = modulus = 0.0;
	movv zero,xlast
	movv zero,ylast
	mov	cx,loopmax
ml1:
	push	cx
	call	mtry
; have to see if the muldulus is greater than 1000
	jc	ml10
	pop	cx
	loop	ml1
	push	cx
ml10:
	pop	cx
 	mov	color,cx
	ret
set_start:
; set up max col and max row
; deltaP = (Pmax - Pmin)/(max_col - 1.0);	/* determine real axis increment */
; deltaQ = (Qmax - Qmin)/(max_row - 1.0);/*determine imaginary axis increment*/
	push	cx
	subb	pmax,pmin,tmp1
	divi	tmp1,window_wid,deltap
	subb	qmin,qmax,tmp1
	divi	tmp1,window_len,deltaq
	pop	cx
	ret
;
;
;
;
mandel_line:
; this does a single mandelbrot line
;
        movv    pmin,p
        mov     cx,width_bytes
        shl     cx,1
        shl     cx,1
        shl     cx,1
        mov     di,4000h
man1:
	push	cx
        push    di
	call	mandels  ; gets a dot
        pop     di
        call    do_dot
        push    di
; have to increment p
 	mov	cx,color2
 	mov	ax,loopmax
 	sub	ax,60
 	cmp	cx,ax
 	jg	new_color
 	cmp	color1,cx
 	jne	new_color
 	cmp	color,cx
 	jne	new_color
 	jmp	same_color
new_color:
 	mov	cx,color1
 	mov	color2,cx
 	mov	cx,color
 	mov	color1,cx
nc0:
	call	set_p
        pop     di
	pop	cx
nc1:
	inc	xloc
	loop	man1
        ret
do_dot:
     push   es
     mov    es,buffer
     mov    ax,color
     stosb
     pop    es
     ret
same_color:
; here we can skip a dot
	cmp	cx,50
	jl	same_color2
        pop     di
	pop	cx
	cmp	cx,1
	je	nc1
	dec	cx
        call    do_dot
	push	cx
        push    di
	inc	xloc
	call	set_p
	jmp	nc0
same_color2:
; here we skip 2 dots
        pop     di
	pop	cx
	cmp	cx,2
	jle	nc1
	dec	cx
	dec	cx
        call    do_dot
	push	cx
        push    di
	inc	xloc
	call	set_p
	inc	xloc
	call	set_p
        pop     di
        call    do_dot
        push    di
	jmp	nc0
set_p:
	push	cx
	addd	p,deltap,tmp1
	pop	cx
	movv	tmp1,p
	ret
setq:
	push	cx
	addd	q,deltaq,tmp1
	pop	cx
	movv	tmp1,q
	ret
mtry:
; here is where all of the calcs are
;
	push	cx
;	Xcur = sqr (Xlast) - sqr (Ylast) + P;	/* find components of next Z */
; if this is not the first time here then tmp1 and tmp2 already have sqr
	cmp	cx,loopmax
	je	not_ftime
	jmp	no_sq
not_ftime:
	mull xlast,xlast,tmp1
	mull ylast,ylast,tmp2
no_sq:
	subb tmp1,tmp2,tmp3
	addd p,tmp3,xcur
;	Ycur = 2 * Xlast * Ylast + Q;
	mull xlast,ylast,tmp1
	shl	tmp1.fdecl,1
	rcl	tmp1.fdech,1
	rcl	tmp1.fhigh,1
	addd tmp1,q,ycur
;	Xlast = Xcur;			/* update last Z */
	movv xcur,xlast
;	Ylast = Ycur;
	movv ycur,ylast
;	modulus = sqr (Xcur) + sqr (Ycur);		/* find size of Z */
	mull	xcur,xcur,tmp1
	mull	ycur,ycur,tmp2
	mov	ax,turnp
	cmp	tmp1.fhigh,ax
	jg	mdone
	cmp	tmp2.fhigh,ax
	jg	mdone
	addd	tmp1,tmp2,modulus
	mov	ax,turnp
	cmp	modulus.fhigh,ax
	jg	mdone
	pop	cx
	clc
	ret
mdone:
	pop	cx
	stc
	ret
CSEG ENDS
	END
