; OKPRES.ASM is the present function of OPTIKS. This takes the
; data out of the screen buffers and puts it onto the screen
; Also included here is the grid
;
segmentsize equ 8000h
dseg segment public 'DATA'
	ASSUME CS:CSEG,DS:DSEG,ES:DSEG
extrn   curr_seg:word,siloc:word
extrn   vid_wid:word,vid_len:word,vbuffer:word
extrn   clean:byte,curx:word,cury:word
extrn   interlace:word,vwid:word
extrn   work_seg:word,last_seg:word,last_si:word
extrn   fat_on:byte,planes:word,nswitch:byte,last_open:byte
extrn   mode:byte
view   dw 1
public view
fat_count  db  0
fat_buff  db   160 dup(0)
cline   dw  0
public cline
curbk   dw  0
vesashift  db  0

dseg ends
;
CSEG	SEGMENT PARA PUBLIC 'CODE'
	ASSUME CS:CSEG,DS:DSEG,ES:DSEG
public  present,do_grid
extrn   reset_segs:near,get_curr_seg:near,get_next_seg:near
extrn   printline:near
; this places the current data on the screen
;
; the following data must be addressable by the cs register
p_data  proc  near
ccur_seg    dw  0
cinterlace  dw  0    ; interlace factor
cvbuffer    dw  0    ; video buffer location
cvid_wid    dw  0    ; wid of real screen
cvwid       dw  0    ; wid of virtual page
cplanes     dw  0
cview       dw  0
cmode       dw  0
public cmode
p_data   endp
do_grid  proc near
       call     reset_segs    ; make sure segs are good
; first the horizontal grid lines, every 8th line on screen
       mov    ax,vid_wid
       mov    cl,4
       shl    ax,cl      ; 8 lines
       mov    dx,0
       mov    cx,interlace
       div    cx         ; fixed for interlace
       sub    ax,vid_wid ; 15 lines
; ax has the length of 15  lines
       mov    bp,ax  ; save it
; now figure length
       mov    ax,vid_len  ; length is already corrected?
       mov    dx,0
       mov    cx,interlace
       mul    cx
       mov    cl,4
       shr    ax,cl
       mov    cx,ax
; cx has the number of grid lines to draw
       mov    di,0
       mov    dx,vid_wid
       shr    dx,1       ; number of words
       mov    ax,vbuffer
       mov    es,ax
grid_loop1:
       push   cx
       mov    cx,dx
       add    di,bp
grid_loop2:
       xor    word ptr es:[di],0feffh
       inc    di
       inc    di
       loop   grid_loop2
;
       pop    cx
       loop   grid_loop1
; now we have to do the verticle lines
       mov    ax,vid_wid
       shr    ax,1
       mov    bp,ax  ; count of dots per line
       mov    dx,interlace
       mov    cx,vid_len
       mov    di,1
       mov    bx,2000h
grid_loop3:
       push   cx
       mov    cx,bp  ;number of bytes
grid_loop4:
       push   di
       push   cx
       mov    cx,dx  ; interlace lines
grid_loop5:
       xor    byte ptr es:[di],01h
       add    di,bx
       loop   grid_loop5
;
       pop    cx
       pop    di
       inc    di
       inc    di
       loop   grid_loop4
;
       pop    cx
       loop   grid_loop3
       call   reset_segs
       ret
do_grid  endp
present proc   near
        push    ds
        push    es
        call     reset_segs    ; make sure segs are good
	mov     al,byte ptr mode
        mov     ah,0
        mov     cs:cmode,ax
        mov     cline,0
        mov     curbk,-1
        call    calc_bank
        mov     cline,0
        cmp     fat_on,0
        jne     fat1
        mov     ax,last_seg
        cmp     ax,curr_seg
        jg      fat1
        je      fat0
        mov     curr_seg,ax
        mov     ax,last_si
        mov     siloc,ax
        jmp     fat1
fat0:
        mov     ax,last_si
        cmp     siloc,ax
        jle     fat1
        mov     siloc,ax
fat1:
        mov     clean,0  ; tell finger that the screen is clear
; set up local cs override guys
;
        mov     ax,curr_seg
        mov     work_seg,ax ; work seg is used to calc virtual page
;
        mov     ax,planes
        cmp     ax,0
        jg      ok_planes
        mov     ax,1
ok_planes:
        mov     cs:cplanes,ax
;
        mov     ax,interlace
        mov     cs:cinterlace,ax
;           move psegs into cp_segs
;
        mov     ax,vbuffer
        mov     cs:cvbuffer,ax
;
        mov     ax,vid_wid
        mov     cs:cvid_wid,ax
;
        mov     ax,view
        shr    ax,1
        mov     cs:cview,ax
;
        mov     ax,vwid
        mov     cs:cvwid,ax

; set things up for loops
        cmp     fat_on,1
        jne     no_fat
        jmp     fat_pres
no_fat:
        mov     si,siloc
        mov     di,0
        mov     cx,vid_len        ; cx will have the line count
        mov     dx,vwid          ; dx has the vid_wid
        call    get_curr_seg    ; returns current work seg in ax
        mov     ds,ax
putloop:
; in loop:
;       ds points to current segment
;       si is offset into segment
;       dx has the vid_wid number
;       cx has line count
        mov     bp,cx    ; use BP rather than push and pop for speed
        mov     cx,cs:cinterlace  ; interlace is times to loop for line
        mov     es,cs:cvbuffer    ; buffer offset
        mov     bx,200h           ; bx is used to quick add interlace
interloop:
        mov     ax,cs:cvid_wid    ; ax has the read screen width
; p_present has to preserve bp,es,dx,cx,ds
        call    p_present
        mov     ax,es
        add     ax,bx    ;200h - next interlace
        mov     es,ax
        loop    interloop         ; do this for interlace  times
        add     di,cs:cvid_wid    ; adds in vwid to get next line
        mov     cx,bp             ; restore bp
        loop    putloop
        cmp     cs:cmode,8
        jne     no_genius
	mov     ax,0b800h
        mov     es,ax
        mov     di,0
        mov     cx,496
gen_loop:
        mov     bp,cx    ; use BP rather than push and pop for speed
        mov     ax,cs:cvid_wid    ; ax has the read screen width
        call    p_present
        add     di,cs:cvid_wid    ; adds in vwid to get next line
        mov     cx,bp             ; restore bp
        loop    gen_loop
no_genius:
; now put the name  of the file on the bottom line
        call    reset_segs
        cmp     nswitch,0
        je      by_name
        cmp     last_open,0
        je      by_name
        mov     ax,vid_len
        mul     interlace
        sub     ax,12
        mov     cury,ax
        mov     curx,80
        lea     di,last_open
        mov     cx,64
        mov     al,0
        cld
repne   scasb
        sub     cx,64
        neg     cx
        lea     si,last_open
        call    printline
by_name:
        pop     es
        pop     ds
        mov     ax,0
        mov     cline,0
        mov     curbk,-1
        call    calc_bank
        mov     cline,0
        ret
fat_pres:
; this presents fat bits to the screen as apposed to other
;
        call    reset_segs
;       int     3
        mov     si,siloc
        mov     di,0
        mov     cx,vid_len        ; cx will have the line count
        mov     dx,vwid          ; dx has the vid_wid
        mov     fat_count,9
putloopf:
        call    reset_segs
        mov     bp,cx    ; use BP rather than push and pop for speed
; in loop:
;       ds points to current segment
;       si is offset into segment
;       dx has the vid_wid number
;       cx has line count
;
        cmp     fat_count,7
        jle     do_fpres
        mov     fat_count,0
; es still points to data segment
;  strategy here is to first reformat 20 bytes into 160 bytes
        push    cx
        push    di
        push    si
        push    dx
        push    ds
        call    get_curr_seg    ; returns current work seg in ax
        mov     ds,ax
        lea     di,fat_buff
        mov     cx,20
floop1:
        push    cx
        cld
        lodsb
        mov     cx,8
floop2:
        clc
        rcl     al,1
        jc      store_f
        mov     byte ptr es:[di],0
        jmp     by_fstore
store_f:
        mov     byte ptr es:[di],0ffh
by_fstore:
        inc     di
        loop    floop2
        pop     cx
        loop    floop1
; have set up the 160 byte fat_buff
; now have to get the ds to point to the guy
        pop     ds
        pop     dx
        pop     si
        pop     di
        pop     cx
        add     si,dx            ; this is virtual buffer size
        cmp     si,0
; this will always occur on a segment boundary
        jge     do_fpres
        sub     si,segmentsize ; for offeset into next seg
        call    get_next_seg
do_fpres:
        mov     cx,cs:cinterlace  ; interlace is times to loop for line
        mov     es,cs:cvbuffer    ; buffer offset
        mov     bx,200h           ; bx is used to quick add interlace
        push    si
        lea     si,fat_buff
interloopf:
        inc     fat_count
        mov     ax,cs:cvid_wid    ; ax has the read screen width
; p_present has to preserve bp,es,dx,cx,ds
        call    fp_present
        mov     ax,es
        add     ax,bx    ;200h - next interlace
        mov     es,ax
        loop    interloopf        ; do this for interlace  times
        add     di,cs:cvid_wid    ; adds in vwid to get next line
        mov     cx,bp             ; restore bp
        pop     si
        loop    putloopf
        pop     es
        pop     ds
        ret
present endp
fp_present proc  near
; this moves fatbuff to the video
; ax has the add amount
        push    cx
        push    di
; cx and di are preserved by stacking, slow but it works
;
        push  si

        call  calc_bank

        mov     cx,ax   ; cx has num bytes to move
        cld
rep     movsb
        pop     si
        pop     di
        pop     cx
        ret
fp_present endp
do_view:
; setup is cx has count, cview has compression
; si and di are set for move
; ax,dx,bx,and bp must be preserved if used
       push  ax
       push  bx
;
; cx has the number of bytes to transfer
;
vloop0:
       push  cx
       lodsb
       mov  bh,al
       lodsb
       mov  bl,al
; this little loop moves 8 bits into al
       mov  cx,8
vloop2:
       rcl  bx,1
       rcl  al,1
       shl  bx,1
       loop  vloop2
; al has a fixed byte
; if cview is more than 1 then do it again
       cmp   cs:cview,1
       je    by_rest_v
       mov   ah,al
       lodsb
       mov  bh,al
       lodsb
       mov  bl,al
; this little loop moves 8 bits into al
       mov  cx,8
vloop3:
       rcl  bx,1
       rcl  al,1
       shl  bx,1
       loop  vloop3
       mov   bx,ax
       mov  cx,8
vloop4:
       rcl  bx,1
       rcl  al,1
       shl  bx,1
       loop  vloop4
; ax has the 16 bits to compress
by_rest_v:
       stosb
       pop   cx
       loop  vloop0
       pop   bx
       pop   ax
       ret
p_present proc  near
; ax has the add amount
        push    cx
        push    di
        call  calc_bank
; cx and di are preserved by stacking, slow but it works
;
; this is the planes stuff. if planes are not 1 we have to send
; multiple lines of different color
;
        mov     cx,cs:cplanes
        cmp     cx,1
        jle     by_planes
; do colors here
        push    ax
        push    dx
        mov     ax,0ff08h ; bit mask index and all bits
        mov     dx,3ceh
        out     dx,ax   ; set bit mask so all bits are on
        pop     dx
        pop     ax
plane_loop:
        push    cx
        push    si      ; si will be popped below
        push    di
        push    dx
        push    ax
        mov     al,byte ptr es:[di]
; select plane
        mov     dx,3c4h ; sequencer
        mov     al,2    ; map mask
        out     dx,al
        mov     dx,3c5h
        mov     al,1
        dec     cl
        sub     cl,3
        neg     cl
        shl     al,cl
        out     dx,al   ; set map to current guy
        pop     ax
        mov     cx,ax   ; cx has num bytes to move
        cmp     cs:cview,0
        jle     do_pmove
        call    do_view
        jmp     by_pmove
do_pmove:
rep     movsb
by_pmove:
        pop     dx
        pop     di
        pop     si
        add     si,dx            ; this is virtual buffer size
        pop     cx
        loop    plane_loop
; here we have to reset the map mask register
        push    ax
        push    dx
;       mov     ax,0ff08  ; all bits
;       mov     dx,3ceh
;        out     dx,ax
        mov     ax,0f02h  ; all planes
        mov     dx,3c4h
        out     dx,ax
        pop     dx
        pop     ax
        jmp     done_planes
by_planes:
        push    si      ; si will be popped below
        mov     cx,ax   ; cx has num bytes to move
        cmp     cs:cview,0
        jle     do_move
        call    do_view
        jmp     by_move
do_move:
rep     movsb
by_move:
        pop     si
        add     si,dx            ; this is virtual buffer size
done_planes:
        cmp    cs:cview,0
        jle    by_vview
; here we have to add a few extra dx's to si
        push    cx
        push    ax
        push    dx
        mov     ax,cs:cview
        mul     cs:cplanes
        mov     cx,ax
        pop     dx
        pop     ax
vvloop:
        cmp     si,0
; this will always occur on a segment boundary
        jge     vpresent_e_loop
        sub     si,segmentsize ; for offeset into next seg
        call    get_next_seg
        mov     ds,ax
vpresent_e_loop:
        add     si,dx            ; this is virtual buffer size
        loop    vvloop
        pop     cx
by_vview:
        cmp     si,0
; this will always occur on a segment boundary
        jge     present_e_loop
        sub     si,segmentsize ; for offeset into next seg
        call    get_next_seg
        mov     ds,ax
present_e_loop:
        pop     di
        pop     cx
        ret
p_present endp
calc_bank	proc  near
public calc_bank
; this procedure calculates bases on the values in bx,etc
; the new bank and places the result in di
;	mov	di,[xpos]
;	mov	ax,[ypos]
;	mov	dx,[maxx]
        cmp     cs:cmode,0ffh
        je     its_vesa_time
        ret
its_vesa_time:
        push    ax
        push    dx
        push    ds
        push    es
        call    reset_segs
        cmp     mode,-1
        jne     nonew
        mov     di,0
        mov     ax,cline
        inc     cline
	mul	vid_wid 		;640 bytes wide in most cases
	mov	di,ax
	mov	ax,dx
	cmp	ax,curbk
	jz	nonew
	call    newbank         ;switch banks if a new bank entered
nonew:
        pop      es
        pop      ds
        pop      dx
        pop      ax
	clc
	ret

calc_bank	endp


newbank	proc near		;bank number is in AX
	cli
	mov	curbk,ax
	push	ax
	push	bx
	push	cx
	push	dx
	mov	cl,vesashift
	shl	ax,cl
	mov	dx,ax
	xor	bx,bx
	mov	ax,4f05h
	int	10h
	sti
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret


newbank	endp

CSEG	ENDS
        END
